-- The table can include the following values:
--    >    objects = { string:object1path, string:object2path, ... }
--    Defines the list of objects whose visibility will be enabled/disabled.
--    >    labelcolor = {number:red, number:green, number:blue, number:alpha}
--    Defines the color of the addon labels. The name of the addon will be then displayed using
--    this same color in the 'Addon Visibility' window.
--    >    locationtypes = {string:locationtype1, string:locationtype2, ...}
--    Defines the types of location that will be enabled/disabled simultaneously with the objects visibility.
--    List of all location types: http://en.wikibooks.org/wiki/Celestia/SSC_File#Type_.22string.22
--    >    script = string:scriptfilename
--    Defines the filename of the script that is run whenever the addon checkbox is clicked (either checked or unchecked)
--    The script path is relative to the addon's directory.

AllMinorMoons =
{
	groupe = false,
	checkBorder = {1, 1, 0, 1},
	labelcolor = {0.964, 0.432, 0.100, 0.8},
	markcolor = "#80FF80",
	markstyle = "diamond",
	marksize = "3",
	number = 197,
	counter = true,
	
	objects =
	{
		-- Sol/Mars
		"Sol/Mars/Deimos",
		"Sol/Mars/Phobos",
		-- Sol/Jupiter
		"Sol/Jupiter/Amalthea",
		"Sol/Jupiter/Himalia",
		"Sol/Jupiter/Elara",
		"Sol/Jupiter/Pasiphae",
		"Sol/Jupiter/Sinope",
		"Sol/Jupiter/Lysithea",
		"Sol/Jupiter/Carme",
		"Sol/Jupiter/Ananke",
		"Sol/Jupiter/Leda",
		"Sol/Jupiter/Thebe",
		
		"Sol/Jupiter/Adrastea",
		"Sol/Jupiter/Metis",
		"Sol/Jupiter/Callirrhoe",
		"Sol/Jupiter/Themisto",
		"Sol/Jupiter/Megaclite",
		"Sol/Jupiter/Taygete",
		"Sol/Jupiter/Chaldene",
		"Sol/Jupiter/Harpalyke",
		"Sol/Jupiter/Kalyke",
		"Sol/Jupiter/Iocaste",
		
		"Sol/Jupiter/Erinome",
		"Sol/Jupiter/Isonoe",
		"Sol/Jupiter/Praxidike",
		"Sol/Jupiter/Autonoe",
		"Sol/Jupiter/Thyone",
		"Sol/Jupiter/Hermippe",
		"Sol/Jupiter/Aitne",
		"Sol/Jupiter/Eurydome",
		"Sol/Jupiter/Euanthe",
		"Sol/Jupiter/Euporie",
		
		"Sol/Jupiter/Orthosie",
		"Sol/Jupiter/Sponde",
		"Sol/Jupiter/Kale",
		"Sol/Jupiter/Pasithee",
		"Sol/Jupiter/Hegemone",
		"Sol/Jupiter/Mneme",
		"Sol/Jupiter/Aoede",
		"Sol/Jupiter/Thelxinoe",
		"Sol/Jupiter/Arche",
		"Sol/Jupiter/Kallichore",
		
		"Sol/Jupiter/Helike",
		"Sol/Jupiter/Carpo",
		"Sol/Jupiter/Eukelade",
		"Sol/Jupiter/Cyllene",
		"Sol/Jupiter/Kore",
		"Sol/Jupiter/Herse",
		"Sol/Jupiter/Dia",
		"Sol/Jupiter/Eirene",
		"Sol/Jupiter/Philophrosyne",
		"Sol/Jupiter/Eupheme",
		
		"Sol/Jupiter/Valetudo",
		"Sol/Jupiter/Pandia",
		"Sol/Jupiter/Ersa",
		"Sol/Jupiter/Jupiter LI",
		"Sol/Jupiter/Jupiter LII",
		"Sol/Jupiter/Jupiter LIV",
		"Sol/Jupiter/Jupiter LVI",
		"Sol/Jupiter/Jupiter LIX",
		"Sol/Jupiter/S-2003 J 2",
		"Sol/Jupiter/S-2003 J 4",
		
		"Sol/Jupiter/S-2003 J 9",
		"Sol/Jupiter/S-2003 J 10",
		"Sol/Jupiter/S-2003 J 12",
		"Sol/Jupiter/S-2003 J 16",
		"Sol/Jupiter/Jupiter LV",
		"Sol/Jupiter/Jupiter LXI",
		"Sol/Jupiter/S-2003 J 23",
		"Sol/Jupiter/Jupiter LXXII",
		"Sol/Jupiter/Jupiter LXIII",
		"Sol/Jupiter/Jupiter LXIV",
		
		"Sol/Jupiter/Jupiter LXVI",
		"Sol/Jupiter/Jupiter LXVII",
		"Sol/Jupiter/Jupiter LXVIII",
		"Sol/Jupiter/Jupiter LXIX",
		"Sol/Jupiter/Jupiter LXX",
		
		-- Sol/Saturn
		"Sol/Saturn/Hyperion",
		"Sol/Saturn/Phoebe",
		"Sol/Saturn/Janus",
		"Sol/Saturn/Epimetheus",
		"Sol/Saturn/Helene",
		"Sol/Saturn/Telesto",
		"Sol/Saturn/Calypso",
		"Sol/Saturn/Atlas",
		"Sol/Saturn/Prometheus",
		"Sol/Saturn/Pandora",
		
		"Sol/Saturn/Pan (moon)",
		"Sol/Saturn/Ymir",
		"Sol/Saturn/Paaliaq",
		"Sol/Saturn/Tarvos",
		"Sol/Saturn/Ijiraq",
		"Sol/Saturn/Suttungr",
		"Sol/Saturn/Kiviuq",
		"Sol/Saturn/Mundilfari",
		"Sol/Saturn/Albiorix",
		"Sol/Saturn/Skathi",
		
		"Sol/Saturn/Erriapus",
		"Sol/Saturn/Siarnaq",
		"Sol/Saturn/Thrymr",
		"Sol/Saturn/Narvi",
		"Sol/Saturn/Methone",
		"Sol/Saturn/Pallene",
		"Sol/Saturn/Polydeuces",
		"Sol/Saturn/Daphnis",
		"Sol/Saturn/Aegir",
		"Sol/Saturn/Bebhionn",
		
		"Sol/Saturn/Bergelmir",
		"Sol/Saturn/Bestla",
		"Sol/Saturn/Farbauti",
		"Sol/Saturn/Fenrir",
		"Sol/Saturn/Fornjot",
		"Sol/Saturn/Hati",
		"Sol/Saturn/Hyrrokkin",
		"Sol/Saturn/Kari",
		"Sol/Saturn/Loge",
		"Sol/Saturn/Skoll",
		
		"Sol/Saturn/Surtur",
		"Sol/Saturn/Anthe",
		"Sol/Saturn/Jarnsaxa",
		"Sol/Saturn/Greip",
		"Sol/Saturn/Tarqeq",
		"Sol/Saturn/Aegaeon",
		"Sol/Saturn/S-2004 S 3",
		"Sol/Saturn/S-2004 S 4",
		"Sol/Saturn/S-2004 S 6",
		"Sol/Saturn/S-2004 S 7",
		
		"Sol/Saturn/S-2004 S 12",
		"Sol/Saturn/S-2004 S 13",
		"Sol/Saturn/S-2004 S 17",
		"Sol/Saturn/S-2006 S 1",
		"Sol/Saturn/S-2006 S 3",
		"Sol/Saturn/S-2007 S 2",
		"Sol/Saturn/S-2007 S 3",
		"Sol/Saturn/S-2009 S 1",
		"Sol/Saturn/S-2004 S 20",
		"Sol/Saturn/S-2004 S 21",
		
		"Sol/Saturn/S-2004 S 22",
		"Sol/Saturn/S-2004 S 23",
		"Sol/Saturn/S-2004 S 24",
		"Sol/Saturn/S-2004 S 25",
		"Sol/Saturn/S-2004 S 26",
		"Sol/Saturn/S-2004 S 27",
		"Sol/Saturn/S-2004 S 28",
		"Sol/Saturn/S-2004 S 29",
		"Sol/Saturn/S-2004 S 30",
		"Sol/Saturn/2004 XXX 3",
		
		"Sol/Saturn/2004 S xxx 1",
		"Sol/Saturn/2004 S xxx 2",
		"Sol/Saturn/2004 XXX 4",
		"Sol/Saturn/2004 XXX 5",
		"Sol/Saturn/2004 XXX 6",
		"Sol/Saturn/2004 XXX 7",
		"Sol/Saturn/2004 XXX 8",
		"Sol/Saturn/2004 XXX 9",
		
		-- Sol/Uranus
		"Sol/Uranus/Cordelia",
		"Sol/Uranus/Ophelia",
		"Sol/Uranus/Bianca",
		"Sol/Uranus/Cressida",
		"Sol/Uranus/Desdemona",
		"Sol/Uranus/Juliet",
		"Sol/Uranus/Portia",
		"Sol/Uranus/Rosalind",
		"Sol/Uranus/Belinda",
		"Sol/Uranus/Puck",
		
		"Sol/Uranus/Caliban",
		"Sol/Uranus/Sycorax",
		"Sol/Uranus/Prospero",
		"Sol/Uranus/Setebos",
		"Sol/Uranus/Stephano",
		"Sol/Uranus/Trinculo",
		"Sol/Uranus/Francisco",
		"Sol/Uranus/Margaret",
		"Sol/Uranus/Ferdinand",
		"Sol/Uranus/Perdita",
		
		"Sol/Uranus/Mab",
		"Sol/Uranus/Cupid",
		
		-- Sol/Neptune
		"Sol/Neptune/Cupid",
		"Sol/Neptune/Naiad",
		"Sol/Neptune/Thalassa",
		"Sol/Neptune/Despina",
		"Sol/Neptune/Galatea",
		"Sol/Neptune/Larissa",
		"Sol/Neptune/Proteus",
		"Sol/Neptune/Halimede",
		"Sol/Neptune/Psamathe",
		"Sol/Neptune/Sao",
		
		"Sol/Neptune/Laomedeia",
		"Sol/Neptune/Neso",
		"Sol/Neptune/Hippocamp",
		
		-- dwarf planets
		"Sol/Haumea/Hi'iaka",
		"Sol/Haumea/Namaka",
		"Sol/Makemake/S-2015 136472 I",
		"Sol/Pluto-Charon/Hydra",
		"Sol/Pluto-Charon/Kerberos",
		"Sol/Pluto-Charon/Nix",
		"Sol/Pluto-Charon/Styx",
	}
}