-- The table can include the following values:
--    >    objects = { string:object1path, string:object2path, ... }
--    Defines the list of objects whose visibility will be enabled/disabled.
--    >    labelcolor = {number:red, number:green, number:blue, number:alpha}
--    Defines the color of the addon labels. The name of the addon will be then displayed using
--    this same color in the 'Addon Visibility' window.
--    >    locationtypes = {string:locationtype1, string:locationtype2, ...}
--    Defines the types of location that will be enabled/disabled simultaneously with the objects visibility.
--    List of all location types: http://en.wikibooks.org/wiki/Celestia/SSC_File#Type_.22string.22
--    >    script = string:scriptfilename
--    Defines the filename of the script that is run whenever the addon checkbox is clicked (either checked or unchecked)
--    The script path is relative to the addon's directory.

AllMoons =
{
	groupe = false,
	checkBorder = {1, 1, 0, 1},
	labelcolor = {0.964, 0.432, 0.100, 0.8},
	markcolor = "#CC99FF",
	markstyle = "circle",
	marksize = "1", -- 2 for square 1 for circle
	number = 19,
	counter = true,
	
	objects =
	{
		-- Mercury
		-- Venus
		-- Earth
		"Sol/Earth/Moon",
		-- Mars
		"Sol/Mars/Deimos",
		"Sol/Mars/Phobos",
		-- Jupiter
		"Sol/Jupiter/Callisto",
		"Sol/Jupiter/Europa",
		"Sol/Jupiter/Ganymede",
		"Sol/Jupiter/Io",
		-- Saturn
		"Sol/Saturn/Titan",
		-- Uranus
		-- Neptune
		"Sol/Neptune/Triton",
		-- Fictionnal
		-- Tyche
		-- Phattie and Theia
		"Sol/Phattie/Hypothetical Moon I",
		"Sol/Phattie/Hypothetical Moon II",
		"Sol/Earth/Moon I",
		"Sol/Theia/Moon-Theia",
		--"",
		--"",
		--"",
		-- Planet X
		"Sol/Planet X/North Wind",
		"Sol/Planet X/West Wind",
		"Sol/Planet X/East Wind",
		"Sol/Planet X/South Wind",
		"Sol/Planet X/Nibiru",
		-- Antichthon
		"Sol/Antichthon/Lilith",
		-- Vulcan
	}
}