----------------------------------------------
-- renderBox.lua
-- Author - Vincent Giangiulio a.k.a Vincent
-- Edit by Lygin Gennady a.k.a Croc 13.01.2017
-- Integration by Lygin Gennady a.k.a Croc 18.03.2017
-- Edit by Patrick Ziegler a.k.a. Gironde 06.04.2017
-- Edit by Patrick Ziegler a.k.a. Gironde 06.10.2018
----------------------------------------------

-- Choose these are not in Vidiba and that you want
-- This you select must be in section renderClass of config.lua
-- After must select the 'elseif bloc' that corresponding in section 'renderFrame.Customdraw' / renderclass
-- and the test 'if' in 'else' for standard traitement

-- If you do not use the functions "9", "10", "11", "12", "13", "14", or "15" 
-- you must transform the following lines into comments (--) and modify the renderclass in config.lua 
	require "AllPlanets"			-- renderCheckBox[9]
	require "AllDwarfPlanets"		-- renderCheckBox[10]
	require "AllMoons"				-- renderCheckBox[11]
	require "AllMinorMoons"			-- renderCheckBox[12]
	require "AllAsteroids"			-- renderCheckBox[13]
	require "AllComets"				-- renderCheckBox[14]
	require "AllSpacecrafts"		-- renderCheckBox[15]

------------------------------------------------------------
-------------- Define local functions ----------------------
------------------------------------------------------------

-- ----------- label ----------------
setLabelElementName = function(str)
	if str == "Constell. in Latin" then
		strl = "i18nconstellations"
	else
		strl = string.lower(string.gsub(str, " ", "")) -- replace "" by "" and convert string in minus
	end
	return strl
end

-- ---------- objet -----------------
setRenderElementName = function(str)
	strr = string.lower(string.gsub(str, " ", "")) -- replace all " " by "" and convert string in minus
	return strr
end

-- ---------- orbit -----------------
setOrbitElementName = function(str)
	strr = string.gsub(str, " ", "") -- replace all " " by ""
	return strr
end

-- ---------- guide -----------------
setGuideElementName = function(str)
	strr = string.lower(string.gsub(str, " ", "")) -- replace all " " by "" and convert string in minus
	return strr
end

-- ---------- check -----------------
setCheckBoxText = function(box, k, flag)  -- Sets the check mark -- edited by Gironde 13-04-2017
	if flag then
		box[k].Text = "v"
	else
		box[k].Text = ""
	end
end

-- ---------- classBox --------------
makeClassBox = function(classBox, k, v, leftOffset) -- Function used to create a box for each class
	classBox = CXBox:new()
		:init(0, 0, 0, 0)
		:textfont(normalfont)
		:textcolor(cbutextoff)
		:movetext(0, 8)
		:text(_(v))
		:movable(false)
		:attach(renderFrame, leftOffset+15, renderFrameHeight-25-(20*k), renderFrameWidth-leftOffset-100, 14+(20*k))
end
-- --------- checkBox ---------------
makeCheckBox = function(checkBox, k, v, leftOffset) -- Function used to create a check box for each element
	checkBox[k] = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:fillimage(fill_img_Frame3) --:fillcolor({1,1,0,.2})
		:textfont(smallfont)
		:textcolor(cbutextoff)
		:textpos("center")
		:movetext(20, 10)
		:text("")
		:movable(false)
		:active(true)
		:attach(renderFrame, leftOffset, renderFrameHeight-25-(20*k), renderFrameWidth-leftOffset-11, 14+(20*k))
end

------------------------------------------------------------
------------- Set initial values render frame --------------
------------------------------------------------------------

nrender = table.getn(renderClass) -- the syntax #renderClass replace table.getn(renderClass) in lua5.2
nguide = table.getn(guideClass) -- the syntax #guideClass replace table.getn(guideClass) in lua5.2
norbit = table.getn(orbitClass) -- the syntax #orbitClass replace table.getn(orbitClass) in lua5.2
nlabel = table.getn(labelClass) -- the syntax #labelClass replace table.getn(labelClass) in lua5.2
local nmax = math.max(nrender, nguide + 2, norbit, nlabel) -- nmax = nguide + 2 = 21

local newwidth, newheight
renderFrameWidth, renderFrameHeight = 380, (20 * nmax)+20 -- 440

renderLeftOffset = 10
orbitLeftOffset = 30
labelLeftOffset = 50
guideLeftOffset = 220

renderCheckBox = {} -- table the render check
guideCheckBox = {} -- table the guide check
orbitCheckBox = {} -- table the orbit check
labelCheckBox = {} -- table the label check

rendertable = {} -- used for receive the flag for celestia
orbittable = {} -- used for receive the flag for celestia
labeltable = {} -- used for receive the flag for celestia

------------------------------------------------------------
---------------- Set up and Draw the boxes -----------------
------------------------------------------------------------
-- box ----
renderBox = CXBox:new()
	:init(0, 0, 0, 0)
	:movable(false)
	:attach(screenBox, width, height, 0, 0)

-- frame --
renderFrame = CXBox:new() -- frame of renders in screenBox
	:init(0, 0, 0, 0)
	:fillimage(fill_img_Frame2) --:fillcolor(csetbofill)
	:bordercolor(cbubordoff)
	:movable(true)
	:visible(false)
	:attach(screenBox, (width-renderFrameWidth)/2+100, height-renderFrameHeight-2, (width-renderFrameWidth)/2-100, 2)
	
	renderFrame.Customdraw = function(this)
		if render_firstTickDone then -- this is true after the first pass after the loading when clicking on the setrenderbutton
			textlayout:setfont(normalfont)
			
			textlayout:setfontcolor({0.2,0.8,1,0.7})
			
			-- Left
			textlayout:setpos(this.lb+10, this.tb-20) -- Change title : "Objects / Orbits / Labels:"
			textlayout:println(_("Objects / Orbits / Labels:"))
			
			textlayout:setpos(this.lb+10, this.tb-185) -- Change title : "Planets and other objects:"
			textlayout:println(_("Planets and other objects:"))
			
			-- Right
			textlayout:setpos(this.lb+guideLeftOffset, this.tb-20)
			textlayout:println(_("Lines and markers:"))
			
			textlayout:setpos(this.lb+guideLeftOffset, this.tb-124)
			textlayout:println(_("Grid:"))
			
			textlayout:setpos(this.lb+renderLeftOffset+190+20, this.tb-225)
			textlayout:println(_("Embellishment:"))
			
			textlayout:setpos(this.lb+renderLeftOffset+190+20, this.tb-385)
			textlayout:println(_("Aspect"))
			
			if not(renderCloseButtonDone) then
				renderCloseButtonDone = true
				makeCloseButton(renderCloseButton, renderFrame, setRenderButton)
			end
		else
			render_firstTickDone = true -- when loading
		end
		
		if newwidth ~= width or newheight ~= height then
			newwidth, newheight = width, height
			renderFrame:attach(screenBox, width-renderFrameWidth-213, height-renderFrameHeight-2, 213, 2)
		end
	end -- end renderFrame.customdraw

--************************ mofify by Gironde 05-10-2018 ********************************************
-- ================= created and check  of renderflags: render ===================

-- K is the number of entry in table 'renderClass', v is the value ("name" or "")
for k, v in ipairs(renderClass) do -- loop for the 'renderClass' column (1st column boxes)
	makeClassBox(renderClassBox, k, "", renderLeftOffset) -- create an new element
	makeCheckBox(renderCheckBox, k, "", renderLeftOffset) -- create an new check-box
	
	FlagsRender = celestia:getrenderflags() -- get flags of celestia
	
	-- clone flag of .planets from Celestia to renderCheckBox[k]
	-- in celestia 9,10,11,12,13,14,15 are the same
	-- this code is to make them independent
	if FlagsRender.planets == true and ( k==9 or k== 10 or k== 11 or k==12 or k== 13 or k== 14 or k==15) then -- 
		renderCheckBox[k].Text = "v"
	end
	
	 -- in config section 'renderClass' these equal to "" are not visible in renderBox
	if v == "" then
		renderCheckBox[k].Visible = false
	end
	
	-- independant checkboxs for 9, 10, 11, 12, 13, 14, 15
	-- their 'renderClass' doesn't need .Customdraw but only .Action because they are not supported by celestia
	--------------------------------------------------
	
	if k == 9 then -- object Planets (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllPlanets.objects) do -- to replace by Planets table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class planets and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
		
	elseif k == 10 then -- object Dwarfplanets (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllDwarfPlanets.objects) do -- to replace by Dwarfplanets table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class dwarfplanets and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
		
	elseif k == 11 then -- object Moons (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllMoons.objects) do -- to replace by Moons table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class Moons and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
		
	elseif k == 12 then -- object Minormoons (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllMinorMoons.objects) do -- to replace by Minormoons table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class Minor Moons and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
		
	elseif k == 13 then -- object Asteroids (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllAsteroids.objects) do  -- to replace by Asteroids table -- n is index and obj is the value
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class Asteroids and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
	
	elseif k == 14 then -- object Comets (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllComets.objects) do -- to replace by Comets table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class Comets and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
	
	elseif k == 15 then -- object Spacecrafts (not in Celestia)
		--------------------------------------
		renderCheckBox[k].Action = function()
			if renderCheckBox[k].Text == "v" then -- checked or not checked
				renderCheckBox[k].Text = ""
			else
				renderCheckBox[k].Text = "v"
			end
			for n,obj in ipairs(AllSpacecrafts.objects) do -- to replace by Spacecrafts table
				local ViDiBaObj = celestia:find(obj) -- search in Celestia
				if renderCheckBox[k].Text == "" then -- test the class Spacecrafts and not the objects
					ViDiBaObj:setvisible(false) -- set all objects of table
				else
					ViDiBaObj:setvisible(true) -- set all objects of table
				end
			end
		end
		
	else -- for others elements (1 to 8), the flags are those of celestia (getrenderflags and setrenderflags
		--------------------------------------
		local vv, kk = v, k
		renderCheckBox[k].Customdraw = function(this)
			vrend = setRenderElementName(vv)
			renderFlag = celestia:getrenderflags()[vrend]
			setCheckBoxText(renderCheckBox, kk, renderFlag)
		end
		--------------------------------------
		renderCheckBox[k].Action = function()
			vrend = setRenderElementName(vv)
			renderFlag = celestia:getrenderflags()[vrend]
			renderFlag = not(renderFlag)
			rendertable[vrend] = renderFlag
			celestia:setrenderflags(rendertable) -- save in celestia lags
		end
	end -- end of special checkboxs 9, 10, 11, 12, 13, 14, 15
end -- end for k, v in ipairs(renderClass) do

-- ================= created and check  of renderflags: orbit ===================
for k, v in ipairs(orbitClass) do -- loop for orbitClass
	makeClassBox(orbitClassBox, k, "", orbitLeftOffset)
	makeCheckBox(orbitCheckBox, k, "", orbitLeftOffset)
	if v == "" then orbitCheckBox[k].Visible = false end
	
	-------------------------------------
	local vv, kk = v, k -- used in .Customdraw and .Action
	orbitCheckBox[k].Customdraw = function(this)
		vorb = setOrbitElementName(vv)
		orbitFlag = celestia:getorbitflags()[vorb]
		setCheckBoxText(orbitCheckBox, kk, orbitFlag)
	end
	-------------------------------------
	orbitCheckBox[k].Action = function()
		vorb = setOrbitElementName(vv)
		orbitFlag = celestia:getorbitflags()[vorb]
		orbitFlag = not(orbitFlag)
		orbittable[vorb] = orbitFlag
		celestia:setorbitflags(orbittable)
	end
	--------------------------------------
end -- end of k, v in ipairs(orbitClass)

-- ================= created and check  of renderflags: guide ===================
for k, v in ipairs(guideClass) do -- loop for guideClass
	makeClassBox(guideClassBox, k, v, guideLeftOffset)
	makeCheckBox(guideCheckBox, k, "", guideLeftOffset)
	
	if v == "" then guideCheckBox[k].Visible = false end
	
	--------------------------------------
	local vv, kk = v, k -- used in .Customdraw and .Action
	guideCheckBox[k].Customdraw = function(this)
		vguid = setGuideElementName(vv)
		renderFlag = celestia:getrenderflags()[vguid]
		setCheckBoxText(guideCheckBox, kk, renderFlag)
	end
	--------------------------------------
	guideCheckBox[k].Action = function()
		vguid = setGuideElementName(vv)
		renderFlag = celestia:getrenderflags()[vguid]
		renderFlag = not(renderFlag)
		rendertable[vguid] = renderFlag
		celestia:setrenderflags(rendertable)
	end
	--------------------------------------
end -- end for k, v in ipairs(guideClass) do

-- ================= created and check  of renderflags: label ===================
for k, v in ipairs(labelClass) do -- loop for labelClass
	makeClassBox(labelClassBox, k, v, labelLeftOffset)
	makeCheckBox(labelCheckBox, k, "", labelLeftOffset)
	if v == "" then labelCheckBox[k].Visible = false end
	
	--------------------------------------
	local vv, kk = v, k -- used in .Customdraw and .Action
	labelCheckBox[k].Customdraw = function(this)
		vlab = setLabelElementName(vv)
		labelFlag = celestia:getlabelflags()[vlab]
		if v == "Constell. in Latin" then
			setCheckBoxText(labelCheckBox, kk, not(labelFlag))
		else
			setCheckBoxText(labelCheckBox, kk, labelFlag)
		end
	end
	--------------------------------------
	labelCheckBox[k].Action = function()
		vlab = setLabelElementName(vv)
		labelFlag = celestia:getlabelflags()[vlab]
		labelFlag = not(labelFlag)
		labeltable[vlab] = labelFlag
		celestia:setlabelflags(labeltable)
	end
	--------------------------------------
end -- end for k, v in ipairs(labelClass) do

-- ========================================================================
-- ========================================================================

--=========================================
-- stardistance box and frame : container renderFrame
-- Original Author of algorythme - Vincent Giangiulio a.k.a Vincent
-- Adapted by Patrick Ziegler alias Gironde 27-03-2017
-- Edit by Lygin Gennady a.k.a  12.04.2017
--=========================================

-------------------------------- star distance frame ---------------------------------------------------------

-- There is no method to retrieve or change the cursor position in Celestia stardistance window
-- Only the number size

----------------------------------------
-- set initial values
----------------------------------------

local stardistanceLimitFrameWidth, stardistanceLimitFrameHeight = 200, 43   -- dimensions of frame of complete scrollbar
local stardistanceLimitTrackFrameW = stardistanceLimitFrameWidth-16
local stardistanceLimitCursorframeW = 12  									-- width of cursor of stardistance
local stardistanceLimitCursorMargin = 3  									-- margin of cursor
local addLeftOffset = 10+5 -- edit Croc
local stardistanceLimit = celestia:getstardistancelimit()
local laststardistanceLimit = nil											-- Buffer variable
local stardistanceLimit2 = nil												-- Buffer variable
local laststardistanceLimit2 = 1000000										-- Buffer variable
local stardistLimScale = 1000000											-- scale of track and cursor
local changeScaleCaseCheck = false											-- flag : one of casecheck have been used or not

local stardistanceLimitPosMax = stardistanceLimitTrackFrameW - stardistanceLimitCursorframeW - (2 * stardistanceLimitCursorMargin) -- position max of cursor on the track,  edit Jogad
local stardistanceLimitPos = math.ceil(celestia:getstardistancelimit() * stardistanceLimitPosMax / stardistLimScale) 	-- convert Ly in pixel the position of cursor edit Jogad

--------------------------------------------------------------------------------------------------------------------
--------------------------------- star distance principal frame ----------------------------------------------------
--------------------------------------------------------------------------------------------------------------------

stardistanceLimitFrame = CXBox:new() -- frame for label and track : prinicipal frame of adjusting tool
	:init(0, 0, 0, 0)
	:movable(false)
	:attach(renderFrame, addLeftOffset-7, 47,
		(renderFrameWidth-stardistanceLimitFrameWidth-addLeftOffset+7), (renderFrameHeight-stardistanceLimitFrameHeight-25-20-2))
	
	stardistanceLimitFrame.Customdraw = function(this)
		stardistanceLimit = celestia:getstardistancelimit() -- update and set display of LUT
		
		textlayout:setfont(normalfont)
		textlayout:setpos(this.lb+7+3, this.tb-15)
		textlayout:setfontcolor({0.2,0.8,1,0.7})
		textlayout:println(_("Limit Star Distance (ly):"))
		
		stardistanceLimit_str = string.format("%1.0f", math.floor(stardistanceLimit))
		textlayout:setpos(this.lb+142, this.tb-15)
		textlayout:setfontcolor(cbutextoff)
		textlayout:println(stardistanceLimit_str)
		
		-- ********* 1)  changing on track and cursor by changing scale of track ***********
		
		-- The scale has been changed (stardistLimScale)
		-- see firsttickdone
		if changeScaleCaseCheck == true then -- use only after FirstTickDone
			changeScaleCaseCheck = false -- reset
			--stardistanceLimit = stardistLimScale -- Force stardistanceLimit to the high value of the scale
			
			stardistanceLimitPos = math.floor(stardistanceLimit * stardistanceLimitPosMax / stardistLimScale) -- convert in pixel -- math.ceil = math_round
				-- update display
			
			stardistanceLimitCursorFrame.Customdraw ()
			celestia:setstardistancelimit(stardistanceLimit) -- set celestia
			-- The rest is done by the same code as below
		end
		
		-- ********* 2) search position of cursor on the screen **************************
		
		-- Determines the stardistancelimit for celestia, according to the position of the cursor on the track.
		-- Used when we move the cursor.
		stardistanceLimit_lb = stardistanceLimitTrackFrame.lb -- Indicates a position of the left edge relative to the right edge of the screenbox
		stardistanceLimit_lb2 = stardistanceLimitCursorFrame.lb-- Indicates a position of the left edge relative to the right edge of the screenbox
		
		-- for define the value
		-- the distance is calculated by difference between lb2 et lb (pixel) and converted this in Ly
		-- calcul of number of Ly
		stardistanceLimit2 =  math.ceil(stardistanceLimit_lb2 - stardistanceLimit_lb - stardistanceLimitCursorMargin) * stardistLimScale / stardistanceLimitPosMax -- convert  in Ly -- round in celestia
		
		if stardistanceLimit2 < 1 then -- 1 is the bottom limit
			stardistanceLimit2 = 1
		end
		
		-- -- laststardistanceLimit = nil or stardistanceLimit before movement
		if laststardistanceLimit2 ~= stardistanceLimit2 and not(stardistanceLimitTrack_FirstTickDone) then
			-- The cursor has been moved set the new celestia stardistanceLimit with stardistanceLimit2   and not stardistanceLimit ( update at the beginning of this customdraw)
			laststardistanceLimit2 = stardistanceLimit2 -- laststardistanceLimit2 take the new value
			celestia:setstardistancelimit(laststardistanceLimit2) -- set celestia
		end
		
		stardistanceLimitTrack_FirstTickDone = false -- stardistanceLimitTrack_FirstTickDone = false
		
		-- ********* 3) Cursor operation *******************************************
		
		stardistanceLimit = celestia:getstardistancelimit() -- update stardistanceLimit in LUT or stardistanceLimit = laststardistanceLimit2
		
		--  test of scale received from celestia for changing automatically the scale of LUT
		
		if stardistanceLimit > 100000 then
			Case5CheckFrame.Action ()
		elseif stardistanceLimit <= 100000 and stardistanceLimit > 10000 then
			Case4CheckFrame.Action ()
		elseif stardistanceLimit <= 10000 and stardistanceLimit > 1000 then
			Case3CheckFrame.Action ()
		elseif stardistanceLimit <= 1000 and stardistanceLimit > 100 then
			Case2CheckFrame.Action ()
		elseif stardistanceLimit <= 100 then
			Case1CheckFrame.Action ()
		end
		
		--------------------------------------------------------------------------------
		if laststardistanceLimit ~= stardistanceLimit then
				-- cursor has moved, set the new position of the cursor.
			laststardistanceLimit = stardistanceLimit
				-- to define the position use the stardistLimScale calculation in LUT, not 1000000
			stardistanceLimitPos = math.floor(stardistanceLimit * stardistanceLimitPosMax / stardistLimScale) -- convert in pixel -- math.ceil = math_round
				-- update display
			stardistanceLimitCursorFrame:attach(stardistanceLimitTrackFrame, stardistanceLimitCursorMargin+stardistanceLimitPos, 0, stardistanceLimitTrackFrameW-stardistanceLimitCursorMargin-stardistanceLimitPos-stardistanceLimitCursorframeW, 0)
		end
	end -- stardistanceLimitFrame.customdraw

--------------------------------------------------------------------------------------------------------------------
------------------------------------- star distance child frames ---------------------------------------------------
--------------------------------------------------------------------------------------------------------------------

------------------------------- star distance track of adjusting tool -----------------------
stardistanceLimitTrackFrame = CXBox:new()
	:visible(true)
	:attach(stardistanceLimitFrame, 8, 8, 8, 24)

----------------------------------- star distance cursor of adjusting tool ---------------------
stardistanceLimitCursorBox = CXBox:new()
	:bordercolor(cslidefrbord)
	:visible(true)
	:attach(stardistanceLimitTrackFrame, 2, 4, 2, 4)
	
stardistanceLimitCursorFrame = CXBox:new()
	:bordercolor(checkBcolor)
	:fillcolor(cslidebofill)
	:visible(true)
	:movable(true)
	:attach(stardistanceLimitTrackFrame, stardistanceLimitCursorMargin+stardistanceLimitPos, 0,
			stardistanceLimitTrackFrameW-stardistanceLimitCursorMargin-stardistanceLimitPos-stardistanceLimitCursorframeW, 0)
	
	stardistanceLimitCursorBox.Masked = stardistanceLimitCursorFrame
	
	stardistanceLimitCursorFrame.Customdraw = function(this)
		-- redraw the cursor frame
		stardistanceLimitCursorFrame:attach(stardistanceLimitTrackFrame, stardistanceLimitCursorMargin+stardistanceLimitPos, 0, stardistanceLimitTrackFrameW-stardistanceLimitCursorMargin-stardistanceLimitPos-stardistanceLimitCursorframeW, 0)
	end

--------------------------------------------------------------------------------------------------------------------
-------------------------------- add check cases stardistance in renderFrame ---------------------------------------
--------------------------------------------------------------------------------------------------------------------

Case1LabelFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor(color1)
	:textpos("left")
	:movetext(-4, 9)
	:text("100")
	:movable(false)
	:active(true)
	:attach(stardistanceLimitFrame, 23, -12, 172, 45)
	
	Case1CheckFrame = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:textfont(smallfont)
		:textcolor(color0)
		:textpos("left")
		:movetext(-3, 12)
		:text("")
		:movable(false)
		:active(true)
		:attach(stardistanceLimitFrame, 12, -8, 179, 47)
		
		Case1CheckFrame.Action = function()
			if stardistLimScale ~= 100 then
				Case1CheckFrame.Text = "o"
				Case2CheckFrame.Text = ""
				Case3CheckFrame.Text = ""
				Case4CheckFrame.Text = ""
				Case5CheckFrame.Text = ""
				
				changeScaleCaseCheck  = true
				stardistLimScale = 100
			end
		end
-----------------------------
Case2LabelFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor(color1)
	:textpos("left")
	:movetext(-4, 9)
	:text("1K")
	:movable(false)
	:active(true)
	:attach(stardistanceLimitFrame, 23+38, -12, 172-38, 45)
	
	Case2CheckFrame = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:textfont(smallfont)
		:textcolor(color0)
		:textpos("left")
		:movetext(-3, 12)
		:text("")
		:movable(false)
		:active(true)
		:attach(stardistanceLimitFrame, 12+38, -8, 179-38, 47)
		
		Case2CheckFrame.Action = function()
			if stardistLimScale ~= 1000 then
				Case1CheckFrame.Text = ""
				Case2CheckFrame.Text = "o"
				Case3CheckFrame.Text = ""
				Case4CheckFrame.Text = ""
				Case5CheckFrame.Text = ""
				
				changeScaleCaseCheck  = true
				stardistLimScale = 1000
			end
		end
-----------------------------
Case3LabelFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor(color1)
	:textpos("left")
	:movetext(-4, 9)
	:text("10K")
	:movable(false)
	:active(true)
	:attach(stardistanceLimitFrame, 23+38*2, -12, 172-38*2, 45)
	
	Case3CheckFrame = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:textfont(smallfont)
		:textcolor(color0)
		:textpos("left")
		:movetext(-3, 12)
		:text("")
		:movable(false)
		:active(true)
		:attach(stardistanceLimitFrame, 12+38*2, -8, 179-38*2, 47)
		
		Case3CheckFrame.Action = function()
			if stardistLimScale ~= 10000 then
				Case1CheckFrame.Text = ""
				Case2CheckFrame.Text = ""
				Case3CheckFrame.Text = "o"
				Case4CheckFrame.Text = ""
				Case5CheckFrame.Text = ""
				
				changeScaleCaseCheck  = true
				stardistLimScale = 10000
			end
		end
-----------------------------
Case4LabelFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor(color1)
	:textpos("left")
	:movetext(-4, 9)
	:text("100K")
	:movable(false)
	:active(true)
	:attach(stardistanceLimitFrame, 23+38*3, -12, 172-38*3, 45)
	
	Case4CheckFrame = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:textfont(smallfont)
		:textcolor(color0)
		:textpos("left")
		:movetext(-3, 12)
		:text("")
		:movable(false)
		:active(true)
		:attach(stardistanceLimitFrame, 12+38*3, -8, 179-38*3, 47)
		
		Case4CheckFrame.Action = function()
			if stardistLimScale ~= 100000 then
				Case1CheckFrame.Text = ""
				Case2CheckFrame.Text = ""
				Case3CheckFrame.Text = ""
				Case4CheckFrame.Text = "o"
				Case5CheckFrame.Text = ""
				
				changeScaleCaseCheck  = true
				stardistLimScale = 100000
			end
		end
-----------------------------
Case5LabelFrame = CXBox:new()
	:init(0, 0, 0, 0)
	:textfont(smallfont)
	:textcolor(color1)
	:textpos("left")
	:movetext(-4, 9)
	:text("1M")
	:movable(false)
	:active(true)
	:attach(stardistanceLimitFrame, 23+38*4, -12, 172-38*4, 45)
	
	Case5CheckFrame = CXBox:new()
		:init(0, 0, 0, 0)
		:bordercolor(checkBcolor)
		:textfont(smallfont)
		:textcolor(color0)
		:textpos("left")
		:movetext(-3, 12)
		:text("o")
		:movable(false)
		:active(true)
		:attach(stardistanceLimitFrame, 12+38*4, -8, 179-38*4, 47)
		
		Case5CheckFrame.Action = function() -- modify the check case and stardistLimScale
			if stardistLimScale ~= 1000000 then
				Case1CheckFrame.Text = ""
				Case2CheckFrame.Text = ""
				Case3CheckFrame.Text = ""
				Case4CheckFrame.Text = ""
				Case5CheckFrame.Text = "o"
				
				changeScaleCaseCheck  = true
				stardistLimScale = 1000000
			end
		end

--***************************************************************************************************
--***************************************************************************************************
