-- The table can include the following values:
--    >    objects = { string:object1path, string:object2path, ... }
--    Defines the list of objects whose visibility will be enabled/disabled.
--    >    labelcolor = {number:red, number:green, number:blue, number:alpha}
--    Defines the color of the addon labels. The name of the addon will be then displayed using
--    this same color in the 'Addon Visibility' window.
--    >    locationtypes = {string:locationtype1, string:locationtype2, ...}
--    Defines the types of location that will be enabled/disabled simultaneously with the objects visibility.
--    List of all location types: http://en.wikibooks.org/wiki/Celestia/SSC_File#Type_.22string.22
--    >    script = string:scriptfilename
--    Defines the filename of the script that is run whenever the addon checkbox is clicked (either checked or unchecked)
--    The script path is relative to the addon's directory.

AllSpacecrafts =
{
	groupe = false,
	checkBorder = {0.964, 0.432, 0.100, 0.8},
	labelcolor = {0.964, 0.432, 0.100, 0.8},
	markcolor = "#F56E19",
	markstyle = "triangle",
	marksize = "3",
	number = 4119,
	counter = true,
	
	objects =
	{
		-- A
		"Sol/Earth/ACE",
		"Sol/Earth/ACRIMSAT",
		"Sol/Earth/Aeolus",
		"Sol/Earth/AIM",
		"Sol/Earth/Ajisai",
		"Sol/Earth/Akari",
		"Sol/Earth/Akebono",
		"Sol/Earth/Alouette 1",
		"Sol/Earth/Alouette 2",
		"Sol/Earth/AMC-8",
		"Sol/Earth/AMSC-1",
		"Sol/AL-AMAL",
		"Sol/Earth/Aqua",
		"Sol/Earth/ARASE",
		"Sol/Earth/Ares I",
		"Sol/Earth/Ares V",
		"Sol/Earth/Ariane 4-pad",
		"Sol/Earth/Ariane 6 A62-pad",
		"Sol/Earth/Ariane 6 A64-pad",
		"Sol/Earth/Asterix (Sat)",
		"Sol/Earth/Aura",
		-- ABS
		"Sol/Earth/ABS-1A",
		"Sol/Earth/ABS-3", -- ABS-5
		"Sol/Earth/ABS-1B",
		"Sol/Earth/ABS-7",
		"Sol/Earth/ABS-6", -- ABS-1
		"Sol/Earth/ABS-4", -- ABS-2i
		"Sol/Earth/ABS-2",
		"Sol/Earth/ABS-3A",
		"Sol/Earth/ABS-2A",
		-- AMSAT
		"Sol/Earth/Oscar 7",
		"Sol/Earth/Oscar 10",
		-- Anik
		"Sol/Earth/Anik A1",
		"Sol/Earth/Anik A2",
		"Sol/Earth/Anik A3",
		"Sol/Earth/Anik B1",
		"Sol/Earth/Anik D1",
		"Sol/Earth/Anik C1",
		"Sol/Earth/Anik C2",
		"Sol/Earth/Anik C3",
		"Sol/Earth/Anik C1",
		"Sol/Earth/Anik D2",
		"Sol/Earth/Anik E1",
		"Sol/Earth/Anik E2",
		"Sol/Earth/Anik F1",
		"Sol/Earth/Anik F1R",
		"Sol/Earth/Anik F2",
		"Sol/Earth/Anik F3",
		"Sol/Earth/Anik G1",
		-- Asiasat
		"Sol/Earth/AsiaSat 2",
		"Sol/Earth/AsiaSat 3",
		"Sol/Earth/AsiaSat 3S",
		"Sol/Earth/AsiaSat 4",
		"Sol/Earth/AsiaSat 5",
		"Sol/Earth/AsiaSat 8",
		"Sol/Earth/AsiaSat 9",
		-- Astra
		"Sol/Earth/Astra 1A",
		"Sol/Earth/Astra 1B",
		"Sol/Earth/Astra 1C",
		"Sol/Earth/Astra 1D",
		"Sol/Earth/Astra 1E",
		"Sol/Earth/Astra 1F",
		"Sol/Earth/Astra 1G",
		"Sol/Earth/Astra 2A",
		"Sol/Earth/Astra 1H",
		"Sol/Earth/Astra 2B",
		"Sol/Earth/Astra 2D",
		"Sol/Earth/Astra 2C",
		"Sol/Earth/Astra 3A",
		"Sol/Earth/Astra 1KR",
		"Sol/Earth/Astra 1L",
		"Sol/Earth/Astra 1M",
		"Sol/Earth/Astra 3B",
		"Sol/Earth/Astra 1N",
		"Sol/Earth/Astra 2F",
		"Sol/Earth/Astra 2E",
		"Sol/Earth/Astra 5B",
		"Sol/Earth/Astra 2G",
		-- Astro
		"Sol/Earth/ASTRO-A",
		"Sol/Earth/ASTRO-B",
		"Sol/Earth/ASTRO-C",
		-- Astrocast
		"Sol/Earth/ASTROCAST 0.1",
		"Sol/Earth/ASTROCAST 0.2",
		"Sol/Earth/ASTROCAST-0101",
		"Sol/Earth/ASTROCAST-0103",
		"Sol/Earth/ASTROCAST-0102",
		"Sol/Earth/ASTROCAST-0105",
		"Sol/Earth/ASTROCAST-0104",
		"Sol/Earth/ASTROCAST-0204",
		"Sol/Earth/ASTROCAST-0201",
		"Sol/Earth/ASTROCAST-0203",
		"Sol/Earth/ASTROCAST-0205",
		"Sol/Earth/ASTROCAST-0202",
		-- Atlas
		"Sol/Earth/Atlas SLV-3 Agena-D",
		"Sol/Earth/Atlas V 551",
		"Sol/Earth/Atlas-5-Centaur",
		-- ATV cargo
		"Sol/Earth/ATV-1",
		"Sol/Earth/ATV-2",
		"Sol/Earth/ATV-3",
		"Sol/Earth/ATV-4",
		"Sol/Earth/ATV-5",
		"Sol/Earth/ATV-004 return",
		"Sol/Earth/ATV-004 departure",
		-- Apollo story
		"Sol/Apollo 8 S-IVB 508N",
		"Sol/Apollo 9 S-IVB 504",
		"Sol/S-IVB 505",
		"Sol/Earth/Moon/C-SM106-LM insert",
		"Sol/LM-4",
		"Sol/LM Snoopy", --  Apollo 10
		"Sol/Earth/CM106",
		"Sol/Earth/CM106a",
		"Sol/Earth/Moon/LEM 'Eagle'",
		"Sol/Earth/Moon/Apollo 11-desc",
		"Sol/Earth/Moon/LEM Eagle descending",
		"Sol/Earth/Moon/Apollo 11 CSM+AS",
		"Sol/Earth/Moon/apollo12",
		"Sol/Earth/Moon/apollo12/Apollo 12-full",
		"Sol/Earth/Moon/apollo12/Apollo 12-desc",
		"Sol/Earth/Moon/Apollo 12 S-IVB 507",
		"Sol/Apollo 12 S-IVB 507",
		"Sol/Earth/Moon/apollo14",
		"Sol/Earth/Moon/apollo14/Apollo 14-full",
		"Sol/Earth/Moon/apollo14/Apollo 14_desc",
		"Sol/Earth/Moon/apollo15",
		"Sol/Earth/Moon/apollo15/LEM Apollo 15-full",
		"Sol/Earth/Moon/apollo15/LEM Apollo 15-desc",
		"Sol/Earth/Moon/apollo16",
		"Sol/Earth/Moon/apollo16/Apollo 16_full",
		"Sol/Earth/Moon/apollo16/Apollo 16-desc",
		"Sol/Earth/Moon/apollo17",
		"Sol/Earth/Moon/apollo17/Apollo 17-full",
		"Sol/Earth/Moon/apollo17/Apollo 17-desc",
		--***************************************
		--***************************************
		--***************************************
		-- B
		"Sol/Earth/Buran Landed",
		"Sol/Earth/Beidou M3",
		"Sol/BepiColombo MCS",
			"Sol/Mercury/BepiColombo MPO",
			"Sol/Mercury/BepiColombo MMO",
		"Sol/Beresheet",
		-- Blagovest
		"Sol/Earth/Blagovest 11L",
		"Sol/Earth/Blagovest 12L",
		"Sol/Earth/Blagovest 13L",
		"Sol/Earth/Blagovest 14L",
		--***************************************
		--***************************************
		--***************************************
		-- C
		"Sol/Earth/CALIPSO",
		"Sol/Cassini-Huygens",
		"Sol/Cassini",
		"Sol/Earth/Centaur 4",
		"Sol/Earth/Centaur R-B 43227",
		"Sol/Earth/Chandra X-Ray Observatory",
		"Sol/Earth/CAT 1",
		"Sol/Earth/CAT 3",
		"Sol/Earth/CAT 4",
		"Sol/Earth/Chinasat 5",
		"Sol/Earth/Chinasat 5R",
		-- Chang'e
		"Sol/Earth/Chang'e 4",
			"Sol/Earth/Moon/Queqiao", -- Chang'e 4
		"Sol/Earth/CHEOPS",
		"Sol/Earth/Moon/Clementine",
		"Sol/Earth/Cloudsat",
		-- Cluster
		"Sol/Earth/Cluster II-FM6(SALSA)",
		"Sol/Earth/Cluster II-FM7(SAMBA)",
		"Sol/Earth/Cluster II-FM5(RUMBA)",
		"Sol/Earth/Cluster II-FM8(TANGO)",
		
		"Sol/Earth/C-NOFS",
		"Sol/Earth/COBE",
		"Sol/Earth/Compton GRO",
		"Sol/Earth/CoRoT",
		"Sol/Mars/Curiosity",
		-- Cargo Cygnus
		"Sol/Earth/Orbital ATK Cygnus Standard",
		"Sol/Earth/CYGNUS Mass Simulator",
		"Sol/Earth/CYGNUS Orb-D1",
		"Sol/Earth/CYGNUS ORB-1",
		"Sol/Earth/CYGNUS ORB-2",
		"Sol/Earth/CYGNUS ORB-4",
		"Sol/Earth/CYGNUS OA-5",
		"Sol/Earth/CYGNUS OA-6",
		"Sol/Earth/CYGNUS OA-7",
		"Sol/Earth/CYGNUS OA-8",
		"Sol/Earth/CYGNUS OA-9",
		"Sol/Earth/Cygnus NG 10",
		"Sol/Earth/Cygnus NG 11",
		"Sol/Earth/Cygnus NG 12",
		"Sol/Earth/Cygnus NG 13",
		"Sol/Earth/Cygnus NG 14",
		"Sol/Earth/Cygnus NG 15",
		--***************************************
		--***************************************
		--***************************************
		-- D
		"Sol/Dawn",
		"Sol/Deep Impact",
		"Sol/Impactor",
		"Sol/Deep Space 1",
		"Sol/Earth/Delta-4H",
		"Sol/Earth/Earth-L1/DSCOVR",
		"Sol/Earth/DSP-14",
		"Sol/Earth/DSP-15",
		"Sol/Earth/DSP-16",
		"Sol/Earth/DSP-17",
		"Sol/Earth/DSP-18",
		"Sol/Earth/DSP-20",
		"Sol/Earth/DSP-21",
		"Sol/Earth/DSP-22",
		-- Double Star
		"Sol/Double Star 1",
		"Sol/Double Star 2",
		-- Dragon SpaceX
		"Sol/Earth/DRAGONSAT 1",
		"Sol/Earth/DRAGON & FALCON",
		"Sol/Earth/DRAGONSAT 2",
		"Sol/Earth/PICODRAGON",
		"Sol/Earth/MICRODRAGON",
		"Sol/Earth/CREW DRAGON DEMO-1",
		"Sol/Earth/CREW DRAGON DEMO-2",
		"Sol/Earth/CREW DRAGON 1",
		"Sol/Earth/DRAGON C1",
		"Sol/Earth/DRAGON C2+",
		"Sol/Earth/DRAGON CRS-1",
		"Sol/Earth/DRAGON CRS-2",
		"Sol/Earth/DRAGON CRS-3",
		"Sol/Earth/DRAGON CRS-4",
		"Sol/Earth/DRAGON CRS-5",
		"Sol/Earth/DRAGON CRS-6",
		"Sol/Earth/DRAGON CRS-8",
		"Sol/Earth/DRAGON CRS-9",
		"Sol/Earth/DRAGON CRS-10",
		"Sol/Earth/DRAGON CRS-11",
		"Sol/Earth/DRAGON CRS-12",
		"Sol/Earth/DRAGON CRS-13",
		"Sol/Earth/DRAGON CRS-14",
		"Sol/Earth/DRAGON CRS-15",
		"Sol/Earth/DRAGON CRS-16",
		"Sol/Earth/DRAGON CRS-17",
		"Sol/Earth/DRAGON CRS-18",
		"Sol/Earth/DRAGON CRS-19",
		"Sol/Earth/DRAGON CRS-20",
		"Sol/Earth/DRAGON CRS-21",
		"Sol/Earth/SpaceX Dragon XL",
		"Sol/Earth/Moon/SpaceX Dragon XL",
		-- DirecTV
		"Sol/Earth/DirecTV-1",
		"Sol/Earth/DirecTV-1R",
		"Sol/Earth/DirecTV-2", --Nimiq 4i
		"Sol/Earth/DirecTV-3", --Nimiq 3
		"Sol/Earth/DirecTV-4S",
		"Sol/Earth/DirecTV-5", -- Tempo 1
		"Sol/Earth/DirecTV-6", -- Tempo 2
		"Sol/Earth/DirecTV-7S",
		"Sol/Earth/DirecTV-8",
		"Sol/Earth/DirecTV-9S",
		"Sol/Earth/DirecTV-10",
		"Sol/Earth/DirecTV-11",
		"Sol/Earth/DirecTV-12",
		"Sol/Earth/DirecTV-14",
		"Sol/Earth/DirecTV-15",
		"Sol/Earth/DirecTV-16", -- AT&T-16
		"Sol/Earth/DirecTV KU-79W", -- Sky Mexico 1
		--***************************************
		--***************************************
		--***************************************
		-- E
		"Sol/Earth/EchoStar 16",
		"Sol/Earth/EDRS-A",
		"Sol/Earth/EDRS-C",
		"Sol/Earth/EnvisatOrbitFocus",
			"Sol/Earth/EnvisatOrbitFocus/Envisat",
		"Sol/Earth/EO-1",
		"Sol/Earth/Epsilon 1",
		"Sol/Earth/ERBS",
		"Sol/Earth/Explorer 1",
		"Sol/Europa Clipper",
		-- Ekran
		"Sol/Earth/Ekran 1",
		"Sol/Earth/Ekran 2",
		"Sol/Earth/Ekran 3",
		"Sol/Earth/Ekran 4",
		"Sol/Earth/Ekran 6",
		"Sol/Earth/Ekran 7",
		"Sol/Earth/Ekran 8",
		"Sol/Earth/Ekran 9",
		"Sol/Earth/Ekran 10",
		"Sol/Earth/Ekran 11",
		"Sol/Earth/Ekran 12",
		"Sol/Earth/Ekran 13",
		"Sol/Earth/Ekran 14",
		"Sol/Earth/Ekran 15",
		"Sol/Earth/Ekran 16",
		"Sol/Earth/Ekran 17",
		"Sol/Earth/Ekran 18",
		"Sol/Earth/Ekran 19",
		"Sol/Earth/Ekran 20",
		"Sol/Earth/Ekran 21",
		
		"Sol/ExoMars16 TGO",
			"Sol/ExoMars16 TGO/Schiaparelli",
		--***************************************
		--***************************************
		--***************************************
		-- F
		"Sol/Earth/FERMI",
		"Sol/Earth/Firefly",
		"Sol/Earth/Formosat 5",
		"Sol/Earth/FUSE",
		
		"Sol/Earth/FLOCK 1C-1", -- 
		"Sol/Earth/FLOCK 1C-2", -- 
		"Sol/Earth/FLOCK 1C-3", -- 
		"Sol/Earth/FLOCK 1C-4", -- 
		"Sol/Earth/FLOCK 1C-5", -- 
		"Sol/Earth/FLOCK 1C-6", -- 
		"Sol/Earth/FLOCK 1C-7", -- 
		"Sol/Earth/FLOCK 1C-8", -- 
		"Sol/Earth/FLOCK 1C-9", -- 
		"Sol/Earth/FLOCK 1C-10", -- 
		"Sol/Earth/FLOCK 1C-11", -- 
		"Sol/Earth/FLOCK 2K-3", -- 
		"Sol/Earth/FLOCK 2K-4", -- 
		"Sol/Earth/FLOCK 2K-1", -- 
		"Sol/Earth/FLOCK 2K-2", -- 
		"Sol/Earth/FLOCK 2K-47", -- 
		"Sol/Earth/FLOCK 2K-48", -- 
		"Sol/Earth/FLOCK 2K-45", -- 
		"Sol/Earth/FLOCK 2K-24", -- 
		"Sol/Earth/FLOCK 2K-46", -- 
		"Sol/Earth/FLOCK 2K-23", -- 
		"Sol/Earth/FLOCK 2K-21", -- 
		"Sol/Earth/FLOCK 2K-22", -- 
		"Sol/Earth/FLOCK 2K-7", -- 
		"Sol/Earth/FLOCK 2K-8", -- 
		"Sol/Earth/FLOCK 2K-5", -- 
		"Sol/Earth/FLOCK 2K-40", -- 
		"Sol/Earth/FLOCK 2K-39", -- 
		"Sol/Earth/FLOCK 2K-37", -- 
		"Sol/Earth/FLOCK 2K-38", -- 
		"Sol/Earth/FLOCK 2K-31", -- 
		"Sol/Earth/FLOCK 2K-32", -- 
		"Sol/Earth/FLOCK 2K-29", -- 
		"Sol/Earth/FLOCK 2K-30", -- 
		"Sol/Earth/FLOCK 2K-44", -- 
		"Sol/Earth/FLOCK 2K-43", -- 
		"Sol/Earth/FLOCK 2K-41", -- 
		"Sol/Earth/FLOCK 2K-36", -- 
		"Sol/Earth/FLOCK 2K-35", -- 
		"Sol/Earth/FLOCK 2K-34", -- 
		"Sol/Earth/FLOCK 2K-33", -- 
		"Sol/Earth/FLOCK 2K-28", -- 
		"Sol/Earth/FLOCK 2K-27", -- 
		"Sol/Earth/FLOCK 2K-26", -- 
		"Sol/Earth/FLOCK 2K-25", -- 
		"Sol/Earth/FLOCK 2K-20", -- 
		"Sol/Earth/FLOCK 2K-19", -- 
		"Sol/Earth/FLOCK 2K-18", -- 
		"Sol/Earth/FLOCK 2K-17", -- 
		"Sol/Earth/FLOCK 2K-16", -- 
		"Sol/Earth/FLOCK 2K-15", -- 
		"Sol/Earth/FLOCK 2K-13", -- 
		"Sol/Earth/FLOCK 2K-14", -- 
		"Sol/Earth/FLOCK 2K-12", -- 
		"Sol/Earth/FLOCK 2K-11", -- 
		"Sol/Earth/FLOCK 2K-10", -- 
		"Sol/Earth/FLOCK 2K-9", -- 
		"Sol/Earth/FLOCK 2K-6", -- 
		"Sol/Earth/FLOCK 2P-1", -- 
		"Sol/Earth/FLOCK 2P-2", -- 
		"Sol/Earth/FLOCK 2P-3", -- 
		"Sol/Earth/FLOCK 2P-4", -- 
		"Sol/Earth/FLOCK 2P-5", -- 
		"Sol/Earth/FLOCK 2P-6", -- 
		"Sol/Earth/FLOCK 2P-7", -- 
		"Sol/Earth/FLOCK 2P-8", -- 
		"Sol/Earth/FLOCK 2P-9", -- 
		"Sol/Earth/FLOCK 2P-10", -- 
		"Sol/Earth/FLOCK 2P-11", -- 
		"Sol/Earth/FLOCK 2P-12", -- 
		"Sol/Earth/FLOCK 3K-3",
		"Sol/Earth/FLOCK 3K-4",
		"Sol/Earth/FLOCK 3K-1",
		"Sol/Earth/FLOCK 3K-2",
		"Sol/Earth/FLOCK 3K-6",
		"Sol/Earth/FLOCK 3K-5",
		"Sol/Earth/FLOCK 3K-8",
		"Sol/Earth/FLOCK 3K-7",
		"Sol/Earth/FLOCK 3K-12",
		"Sol/Earth/FLOCK 3K-11",
		"Sol/Earth/FLOCK 3K-10",
		"Sol/Earth/FLOCK 3K-9",
		"Sol/Earth/FLOCK 3M-1",
		"Sol/Earth/FLOCK 3M-3",
		"Sol/Earth/FLOCK 3M-4",
		"Sol/Earth/FLOCK 3M-2",
		"Sol/Earth/FLOCK 3P-20",
		"Sol/Earth/FLOCK 3P-8",
		"Sol/Earth/FLOCK 3P-51",
		"Sol/Earth/FLOCK 3P-37",
		"Sol/Earth/FLOCK 3P-19",
		"Sol/Earth/FLOCK 3P-24",
		"Sol/Earth/FLOCK 3P-18",
		"Sol/Earth/FLOCK 3P-22",
		"Sol/Earth/FLOCK 3P-21",
		"Sol/Earth/FLOCK 3P-28",
		"Sol/Earth/FLOCK 3P-26",
		"Sol/Earth/FLOCK 3P-17",
		"Sol/Earth/FLOCK 3P-27",
		"Sol/Earth/FLOCK 3P-25",
		"Sol/Earth/FLOCK 3P-4",
		"Sol/Earth/FLOCK 3P-2",
		"Sol/Earth/FLOCK 3P-1",
		"Sol/Earth/FLOCK 3P-3",
		"Sol/Earth/FLOCK 3P-6",
		"Sol/Earth/FLOCK 3P-7",
		"Sol/Earth/FLOCK 3P-5",
		"Sol/Earth/FLOCK 3P-12",
		"Sol/Earth/FLOCK 3P-9",
		"Sol/Earth/FLOCK 3P-10",
		"Sol/Earth/FLOCK 3P-11",
		"Sol/Earth/FLOCK 3P-60",
		"Sol/Earth/FLOCK 3P-58",
		"Sol/Earth/FLOCK 3P-57",
		"Sol/Earth/FLOCK 3P-75",
		"Sol/Earth/FLOCK 3P-70",
		"Sol/Earth/FLOCK 3P-73",
		"Sol/Earth/FLOCK 3P-88",
		"Sol/Earth/FLOCK 3P-85",
		"Sol/Earth/FLOCK 3P-79",
		"Sol/Earth/FLOCK 3P-86",
		"Sol/Earth/FLOCK 3P-36",
		"Sol/Earth/FLOCK 3P-30",
		"Sol/Earth/FLOCK 3P-34",
		"Sol/Earth/FLOCK 3P-35",
		"Sol/Earth/FLOCK 3P-33",
		"Sol/Earth/FLOCK 3P-49",
		"Sol/Earth/FLOCK 3P-67",
		"Sol/Earth/FLOCK 3P-68",
		"Sol/Earth/FLOCK 3P-41",
		"Sol/Earth/FLOCK 3P-45",
		"Sol/Earth/FLOCK 3P-48",
		"Sol/Earth/FLOCK 3P-43",
		"Sol/Earth/FLOCK 3P-42",
		"Sol/Earth/FLOCK 3P-61",
		"Sol/Earth/FLOCK 3P-40",
		"Sol/Earth/FLOCK 3P-16",
		"Sol/Earth/FLOCK 3P-14",
		"Sol/Earth/FLOCK 3P-53",
		"Sol/Earth/FLOCK 3P-54",
		"Sol/Earth/FLOCK 3P-23",
		"Sol/Earth/FLOCK 3P-76",
		"Sol/Earth/FLOCK 3P-69",
		"Sol/Earth/FLOCK 3P-84",
		"Sol/Earth/FLOCK 3P-59",
		"Sol/Earth/FLOCK 3P-32",
		"Sol/Earth/FLOCK 3P-71",
		"Sol/Earth/FLOCK 3P-77",
		"Sol/Earth/FLOCK 3P-80",
		"Sol/Earth/FLOCK 3P-66",
		"Sol/Earth/FLOCK 3P-65",
		"Sol/Earth/FLOCK 3P-50",
		"Sol/Earth/FLOCK 3P-52",
		"Sol/Earth/FLOCK 3P-46",
		"Sol/Earth/FLOCK 3P-47",
		"Sol/Earth/FLOCK 3P-44",
		"Sol/Earth/FLOCK 3P-64",
		"Sol/Earth/FLOCK 3P-63",
		"Sol/Earth/FLOCK 3P-62",
		"Sol/Earth/FLOCK 3P-38",
		"Sol/Earth/FLOCK 3P-39",
		"Sol/Earth/FLOCK 3P-15",
		"Sol/Earth/FLOCK 3P-13",
		"Sol/Earth/FLOCK 3P-55",
		"Sol/Earth/FLOCK 3P-56",
		"Sol/Earth/FLOCK 3P-81",
		"Sol/Earth/FLOCK 3P-87",
		"Sol/Earth/FLOCK 3P-29",
		"Sol/Earth/FLOCK 3P-82",
		"Sol/Earth/FLOCK 3P-78",
		"Sol/Earth/FLOCK 3P-74",
		"Sol/Earth/FLOCK 3P-31",
		"Sol/Earth/FLOCK 3P-83",
		"Sol/Earth/FLOCK 3P-72",
		"Sol/Earth/FLOCK 3P'-3",
		"Sol/Earth/FLOCK 3P'-2",
		"Sol/Earth/FLOCK 3P'-1",
		"Sol/Earth/FLOCK 3P'-4",
		"Sol/Earth/FLOCK 3R-9",
		"Sol/Earth/FLOCK 3R-12",
		"Sol/Earth/FLOCK 3R-11",
		"Sol/Earth/FLOCK 3R-5",
		"Sol/Earth/FLOCK 3R-8",
		"Sol/Earth/FLOCK 3R-4",
		"Sol/Earth/FLOCK 3R-3",
		"Sol/Earth/FLOCK 3R-16",
		"Sol/Earth/FLOCK 3R-15",
		"Sol/Earth/FLOCK 3R-10",
		"Sol/Earth/FLOCK 3R-6",
		"Sol/Earth/FLOCK 3R-7",
		"Sol/Earth/FLOCK 3R-1",
		"Sol/Earth/FLOCK 3R-2",
		"Sol/Earth/FLOCK 3R-14",
		"Sol/Earth/FLOCK 3R-13",
		"Sol/Earth/FLOCK 3S-1",
		"Sol/Earth/FLOCK 3S-3",
		"Sol/Earth/FLOCK 3S-2",
		"Sol/Earth/FLOCK 4A-1",
		"Sol/Earth/FLOCK 4A-2",
		"Sol/Earth/FLOCK 4A-3",
		"Sol/Earth/FLOCK 4A-4",
		"Sol/Earth/FLOCK 4A-17",
		"Sol/Earth/FLOCK 4A-18",
		"Sol/Earth/FLOCK 4A-19",
		"Sol/Earth/FLOCK 4A-20",
		"Sol/Earth/FLOCK 4A-8",
		"Sol/Earth/FLOCK 4A-7",
		"Sol/Earth/FLOCK 4A-6",
		"Sol/Earth/FLOCK 4A-5",
		"Sol/Earth/FLOCK 4A-11",
		"Sol/Earth/FLOCK 4A-10",
		"Sol/Earth/FLOCK 4A-9",
		"Sol/Earth/FLOCK 4A-16",
		"Sol/Earth/FLOCK 4A-15",
		"Sol/Earth/FLOCK 4A-14",
		"Sol/Earth/FLOCK 4A-13",
		"Sol/Earth/FLOCK 4A-12",
		"Sol/Earth/FLOCK 4E'-1",
		"Sol/Earth/FLOCK 4E'-7",
		"Sol/Earth/FLOCK 4E'-9",
		"Sol/Earth/FLOCK 4E'-8",
		"Sol/Earth/FLOCK 4E'-5",
		"Sol/Earth/FLOCK 4E'-3",
		"Sol/Earth/FLOCK 4E'-2",
		"Sol/Earth/FLOCK 4E'-4",
		"Sol/Earth/FLOCK 4E'-6",
		"Sol/Earth/FLOCK 4P-9",
		"Sol/Earth/FLOCK 4P-10",
		"Sol/Earth/FLOCK 4P-11",
		"Sol/Earth/FLOCK 4P-12",
		"Sol/Earth/FLOCK 4P-4",
		"Sol/Earth/FLOCK 4P-3",
		"Sol/Earth/FLOCK 4P-2",
		"Sol/Earth/FLOCK 4P-1",
		"Sol/Earth/FLOCK 4P-8",
		"Sol/Earth/FLOCK 4P-7",
		"Sol/Earth/FLOCK 4P-6",
		"Sol/Earth/FLOCK 4P-5",
		"Sol/Earth/FLOCK 4S-1",
		"Sol/Earth/FLOCK 4S-2",
		"Sol/Earth/FLOCK 4S-3",
		"Sol/Earth/FLOCK 4S-4",
		"Sol/Earth/FLOCK 4S-5",
		"Sol/Earth/FLOCK 4S-6",
		"Sol/Earth/FLOCK 4S-7",
		"Sol/Earth/FLOCK 4S-8",
		"Sol/Earth/FLOCK 4S-9",
		"Sol/Earth/FLOCK 4S-10",
		"Sol/Earth/FLOCK 4S-11",
		"Sol/Earth/FLOCK 4S-12",
		"Sol/Earth/FLOCK 4S-13",
		"Sol/Earth/FLOCK 4S-14",
		"Sol/Earth/FLOCK 4S-15",
		"Sol/Earth/FLOCK 4S-16",
		"Sol/Earth/FLOCK 4S-17",
		"Sol/Earth/FLOCK 4S-18",
		"Sol/Earth/FLOCK 4S-19",
		"Sol/Earth/FLOCK 4S-20",
		"Sol/Earth/FLOCK 4S-21",
		"Sol/Earth/FLOCK 4S-22",
		"Sol/Earth/FLOCK 4S-23",
		"Sol/Earth/FLOCK 4S-24",
		"Sol/Earth/FLOCK 4S-25",
		"Sol/Earth/FLOCK 4S-26",
		"Sol/Earth/FLOCK 4S-27",
		"Sol/Earth/FLOCK 4S-28",
		"Sol/Earth/FLOCK 4S-29",
		"Sol/Earth/FLOCK 4S-30",
		"Sol/Earth/FLOCK 4S-31",
		"Sol/Earth/FLOCK 4S-32",
		"Sol/Earth/FLOCK 4S-33",
		"Sol/Earth/FLOCK 4S-34",
		"Sol/Earth/FLOCK 4S-35",
		"Sol/Earth/FLOCK 4S-36",
		"Sol/Earth/FLOCK 4S-37",
		"Sol/Earth/FLOCK 4S-38", -- nonoperational
		"Sol/Earth/FLOCK 4S-39",
		"Sol/Earth/FLOCK 4S-40",
		"Sol/Earth/FLOCK 4S-41",
		"Sol/Earth/FLOCK 4S-42",
		"Sol/Earth/FLOCK 4S-43",
		"Sol/Earth/FLOCK 4S-44",
		"Sol/Earth/FLOCK 4S-45",
		"Sol/Earth/FLOCK 4S-46",
		"Sol/Earth/FLOCK 4S-47",
		"Sol/Earth/FLOCK 4S-48",
		"Sol/Earth/FLOCK 4V-12",
		"Sol/Earth/FLOCK 4V-11",
		"Sol/Earth/FLOCK 4V-14",
		"Sol/Earth/FLOCK 4V-8",
		"Sol/Earth/FLOCK 4V-6",
		"Sol/Earth/FLOCK 4V-5",
		"Sol/Earth/FLOCK 4V-7",
		"Sol/Earth/FLOCK 4V-10",
		"Sol/Earth/FLOCK 4V-13",
		"Sol/Earth/FLOCK 4V-1",
		"Sol/Earth/FLOCK 4V-4",
		"Sol/Earth/FLOCK 4V-2",
		"Sol/Earth/FLOCK 4V-3",
		"Sol/Earth/FLOCK 4V-16",
		"Sol/Earth/FLOCK 4V-15",
		"Sol/Earth/FLOCK 4V-17",
		"Sol/Earth/FLOCK 4V-21",
		"Sol/Earth/FLOCK 4V-18",
		"Sol/Earth/FLOCK 4V-19",
		"Sol/Earth/FLOCK 4V-20",
		"Sol/Earth/FLOCK 4V-22",
		"Sol/Earth/FLOCK 4V-23",
		"Sol/Earth/FLOCK 4V-24",
		"Sol/Earth/FLOCK 4V-25",
		"Sol/Earth/FLOCK 4V-26",
		
		--***************************************
		--***************************************
		--***************************************
		-- G
		-- Gaia
		"Sol/Gaia (sat)",
			"Sol/Earth/Gaia (sat)",
		-- Galaxy
		"Sol/Earth/Galaxy 1",
		"Sol/Earth/Galaxy 1R",
		"Sol/Earth/Galaxy 2",
		"Sol/Earth/Galaxy 3",
		"Sol/Earth/Galaxy 3C",
		"Sol/Earth/Galaxy 3R",
		"Sol/Earth/Galaxy 4",
		"Sol/Earth/Galaxy 5",
		"Sol/Earth/Galaxy 6",
		"Sol/Earth/Galaxy 7",
		"Sol/Earth/Galaxy 8",
		"Sol/Earth/Galaxy 9",
		"Sol/Earth/Galaxy 10R",
		"Sol/Earth/Galaxy 11",
		"Sol/Earth/Galaxy 12",
		"Sol/Earth/Galaxy 13", -- Horizons 1
		"Sol/Earth/Galaxy 14",
		"Sol/Earth/Galaxy 15",
		"Sol/Earth/Galaxy 16",
		"Sol/Earth/Galaxy 17",
		"Sol/Earth/Galaxy 18",
		"Sol/Earth/Galaxy 19",
		"Sol/Earth/Galaxy 23",
		"Sol/Earth/Galaxy 25",
		"Sol/Earth/Galaxy 26",
		"Sol/Earth/Galaxy 27",
		"Sol/Earth/Galaxy 28",
		
		"Sol/Earth/GALEX",
		"Sol/Galileo", -- Nasa
		-- Galileo GPS - Esa
		"Sol/Earth/Galileo-IOV PFM",
		"Sol/Earth/Galileo-IOV PFM",
		"Sol/Earth/Galileo-IOV FM2",
		"Sol/Earth/Galileo-IOV FM3",
		"Sol/Earth/Galileo-IOV FM4",
		"Sol/Earth/Galileo-FOC FM1",
		"Sol/Earth/Galileo-FOC FM2",
		"Sol/Earth/Galileo-FOC FM3",
		"Sol/Earth/Galileo-FOC FM4",
		"Sol/Earth/Galileo-FOC FM5",
		"Sol/Earth/Galileo-FOC FM6",
		"Sol/Earth/Galileo-FOC FM7",
		"Sol/Earth/Galileo-FOC FM8",
		"Sol/Earth/Galileo-FOC FM9",
		"Sol/Earth/Galileo-FOC FM10",
		"Sol/Earth/Galileo-FOC FM11",
		"Sol/Earth/Galileo-FOC FM12",
		"Sol/Earth/Galileo-FOC FM13",
		"Sol/Earth/Galileo-FOC FM14",
		"Sol/Earth/Galileo-FOC FM15",
		"Sol/Earth/Galileo-FOC FM16",
		"Sol/Earth/Galileo-FOC FM17",
		"Sol/Earth/Galileo-FOC FM18",
		"Sol/Earth/Galileo-FOC FM19",
		"Sol/Earth/Galileo-FOC FM20",
		"Sol/Earth/Galileo-FOC FM21",
		"Sol/Earth/Galileo-FOC FM222",
		"Sol/Earth/Giove-A",
		"Sol/Earth/Giove-B",
		-- Gemini
		"Sol/Earth/Gemini 7",
		"Sol/Earth/Gemini SC8",
		"Sol/Earth/Gemini SC8/Agena D Target",
		
		"Sol/Generic Toutatis-2",
		
		"Sol/Genesis",
		"Sol/Giotto",
		"Sol/Earth/Gokturk-2",
		"Sol/Earth/GPM-CORE",
		
		-- GOES
		"Sol/Earth/GOES-A",
		"Sol/Earth/GOES-B",
		"Sol/Earth/GOES-C",
		"Sol/Earth/GOES-D",
		"Sol/Earth/GOES-E",
		"Sol/Earth/GOES-F",
		"Sol/Earth/GOES-H",
		"Sol/Earth/GOES-I",
		"Sol/Earth/GOES-J",
		"Sol/Earth/GOES-K",
		"Sol/Earth/GOES-L",
		"Sol/Earth/GOES-M",
		"Sol/Earth/GOES-N",
		"Sol/Earth/GOES-O",
		"Sol/Earth/GOES-P",
		"Sol/Earth/GOES-R",
		"Sol/Earth/GOES-S",
		"Sol/Earth/GOES-T",
		"Sol/Earth/GOES-U",
		-- Globalstar
		"Sol/Earth/GLOBALSTAR M001",
		"Sol/Earth/GLOBALSTAR M004",
		"Sol/Earth/GLOBALSTAR M002",
		"Sol/Earth/GLOBALSTAR M003",
		"Sol/Earth/GLOBALSTAR M014",
		"Sol/Earth/GLOBALSTAR M006",
		"Sol/Earth/GLOBALSTAR M015",
		"Sol/Earth/GLOBALSTAR M008",
		"Sol/Earth/GLOBALSTAR M023",
		"Sol/Earth/GLOBALSTAR M040",
		"Sol/Earth/GLOBALSTAR M036",
		"Sol/Earth/GLOBALSTAR M038",
		"Sol/Earth/GLOBALSTAR M022",
		"Sol/Earth/GLOBALSTAR M041",
		"Sol/Earth/GLOBALSTAR M046",
		"Sol/Earth/GLOBALSTAR M037",
		"Sol/Earth/GLOBALSTAR M045",
		"Sol/Earth/GLOBALSTAR M044",
		"Sol/Earth/GLOBALSTAR M019",
		"Sol/Earth/GLOBALSTAR M042",
		"Sol/Earth/GLOBALSTAR M025",
		"Sol/Earth/GLOBALSTAR M049",
		"Sol/Earth/GLOBALSTAR M047",
		"Sol/Earth/GLOBALSTAR M052",
		"Sol/Earth/GLOBALSTAR M035",
		"Sol/Earth/GLOBALSTAR M032",
		"Sol/Earth/GLOBALSTAR M051",
		"Sol/Earth/GLOBALSTAR M030",
		"Sol/Earth/GLOBALSTAR M048",
		"Sol/Earth/GLOBALSTAR M026",
		"Sol/Earth/GLOBALSTAR M043",
		"Sol/Earth/GLOBALSTAR M028",
		"Sol/Earth/GLOBALSTAR M053",
		"Sol/Earth/GLOBALSTAR M027",
		"Sol/Earth/GLOBALSTAR M054",
		"Sol/Earth/GLOBALSTAR M024",
		"Sol/Earth/GLOBALSTAR M058",
		"Sol/Earth/GLOBALSTAR M050",
		"Sol/Earth/GLOBALSTAR M033",
		"Sol/Earth/GLOBALSTAR M055",
		"Sol/Earth/GLOBALSTAR M057",
		"Sol/Earth/GLOBALSTAR M059",
		"Sol/Earth/GLOBALSTAR M056",
		"Sol/Earth/GLOBALSTAR M031",
		"Sol/Earth/GLOBALSTAR M039",
		"Sol/Earth/GLOBALSTAR M034",
		"Sol/Earth/GLOBALSTAR M029",
		"Sol/Earth/GLOBALSTAR M061",
		"Sol/Earth/GLOBALSTAR M063",
		"Sol/Earth/GLOBALSTAR M062",
		"Sol/Earth/GLOBALSTAR M060",
		"Sol/Earth/GLOBALSTAR M064",
		-- GLONASS GPS
		"Sol/Earth/Cosmos 1413",
		"Sol/Earth/Cosmos 1490",
		"Sol/Earth/Cosmos 1491",
		"Sol/Earth/Cosmos 1519",
		"Sol/Earth/Cosmos 1520",
		"Sol/Earth/Cosmos 1554",
		"Sol/Earth/Cosmos 1555",
		"Sol/Earth/Cosmos 1593",
		"Sol/Earth/Cosmos 1594",
		"Sol/Earth/Cosmos 1650",
		"Sol/Earth/Cosmos 1651",
		"Sol/Earth/Cosmos 1710",
		"Sol/Earth/Cosmos 1711",
		"Sol/Earth/Cosmos 1778",
		"Sol/Earth/Cosmos 1779",
		"Sol/Earth/Cosmos 1780",
		"Sol/Earth/Cosmos 1883",
		"Sol/Earth/Cosmos 1884",
		"Sol/Earth/Cosmos 1885",
		"Sol/Earth/Cosmos 1946",
		"Sol/Earth/Cosmos 1947",
		"Sol/Earth/Cosmos 1948",
		"Sol/Earth/Cosmos 1970",
		"Sol/Earth/Cosmos 1971",
		"Sol/Earth/Cosmos 1972",
		"Sol/Earth/Cosmos 1987",
		"Sol/Earth/Cosmos 1988",
		"Sol/Earth/Cosmos 2022",
		"Sol/Earth/Cosmos 2023",
		"Sol/Earth/Cosmos 2079",
		"Sol/Earth/Cosmos 2080",
		"Sol/Earth/Cosmos 2081",
		"Sol/Earth/Cosmos 2109",
		"Sol/Earth/Cosmos 2110",
		"Sol/Earth/Cosmos 2111",
		"Sol/Earth/Cosmos 2139",
		"Sol/Earth/Cosmos 2140",
		"Sol/Earth/Cosmos 2141",
		"Sol/Earth/Cosmos 2177",
		"Sol/Earth/Cosmos 2178",
		"Sol/Earth/Cosmos 2179",
		"Sol/Earth/Cosmos 2204",
		"Sol/Earth/Cosmos 2205",
		"Sol/Earth/Cosmos 2206",
		"Sol/Earth/Cosmos 2234",
		"Sol/Earth/Cosmos 2235",
		"Sol/Earth/Cosmos 2236",
		"Sol/Earth/Cosmos 2275",
		"Sol/Earth/Cosmos 2276",
		"Sol/Earth/Cosmos 2277",
		"Sol/Earth/Cosmos 2287",
		"Sol/Earth/Cosmos 2288",
		"Sol/Earth/Cosmos 2289",
		"Sol/Earth/Cosmos 2294",
		"Sol/Earth/Cosmos 2295",
		"Sol/Earth/Cosmos 2296",
		"Sol/Earth/Cosmos 2307",
		"Sol/Earth/Cosmos 2308",
		"Sol/Earth/Cosmos 2309",
		"Sol/Earth/Cosmos 2316",
		"Sol/Earth/Cosmos 2317",
		"Sol/Earth/Cosmos 2318",
		"Sol/Earth/Cosmos 2323",
		"Sol/Earth/Cosmos 2324",
		"Sol/Earth/Cosmos 2325",
		"Sol/Earth/Cosmos 2362",
		"Sol/Earth/Cosmos 2363",
		"Sol/Earth/Cosmos 2364",
		"Sol/Earth/Cosmos 2374",
		"Sol/Earth/Cosmos 2375",
		"Sol/Earth/Cosmos 2376",
		"Sol/Earth/Cosmos 2380",
		"Sol/Earth/Cosmos 2381",
		"Sol/Earth/Cosmos 2382",
		"Sol/Earth/Cosmos 2394",
		"Sol/Earth/Cosmos 2395",
		"Sol/Earth/Cosmos 2396",
		"Sol/Earth/Cosmos 2402",
		"Sol/Earth/Cosmos 2403",
		"Sol/Earth/Cosmos 2404",
		"Sol/Earth/Cosmos 2411",
		"Sol/Earth/Cosmos 2412",
		"Sol/Earth/Cosmos 2413",
		"Sol/Earth/Cosmos 2417",
		"Sol/Earth/Cosmos 2418",
		"Sol/Earth/Cosmos 2419",
		"Sol/Earth/Cosmos 2424",
		"Sol/Earth/Cosmos 2425",
		"Sol/Earth/Cosmos 2426",
		"Sol/Earth/Cosmos 2431",
		"Sol/Earth/Cosmos 2432",
		"Sol/Earth/Cosmos 2433",
		"Sol/Earth/Cosmos 2434",
		"Sol/Earth/Cosmos 2435",
		"Sol/Earth/Cosmos 2436",
		"Sol/Earth/Cosmos 2442",
		"Sol/Earth/Cosmos 2443",
		"Sol/Earth/Cosmos 2443",
		"Sol/Earth/Cosmos 2447",
		"Sol/Earth/Cosmos 2448",
		"Sol/Earth/Cosmos 2449",
		"Sol/Earth/Cosmos 2456",
		"Sol/Earth/Cosmos 2457",
		"Sol/Earth/Cosmos 2458",
		"Sol/Earth/Cosmos 2459",
		"Sol/Earth/Cosmos 2460",
		"Sol/Earth/Cosmos 2461",
		"Sol/Earth/Cosmos 2464",
		"Sol/Earth/Cosmos 2465",
		"Sol/Earth/Cosmos 2466",
		"Sol/Earth/Cosmos 2471",
		"Sol/Earth/Cosmos 2474",
		"Sol/Earth/Cosmos 2475",
		"Sol/Earth/Cosmos 2476",
		"Sol/Earth/Cosmos 2477",
		"Sol/Earth/Cosmos 2478",
		"Sol/Earth/Cosmos 2485",
		"Sol/Earth/Cosmos 2492",
		"Sol/Earth/Cosmos 2500",
		"Sol/Earth/Cosmos 2501",
		"Sol/Earth/Cosmos 2514",
		"Sol/Earth/Cosmos 2516",
		"Sol/Earth/Cosmos 2522",
		"Sol/Earth/Cosmos 2527",
		"Sol/Earth/Cosmos 2529",
		"Sol/Earth/Cosmos 2534",
		"Sol/Earth/Cosmos 2544",
		"Sol/Earth/Cosmos 2545",
		-- Grace
		"Sol/Earth/GRACE-1",
		"Sol/Earth/GRACE-2",
		"Sol/Earth/GRACE-FO1",
		"Sol/Earth/GRACE-FO2",
		-- Grail
		"Sol/Earth/GRAIL-A(Ebb)",
		"Sol/Earth/GRAIL-B(Flow)",
		-- GSAT indian's satellites for comm.
		"Sol/Earth/GSAT-1",
		"Sol/Earth/GSAT-2",
		"Sol/Earth/GSAT-3",
		"Sol/Earth/GSAT-6",
		"Sol/Earth/GSAT-6A",
		"Sol/Earth/GSAT-7",
		"Sol/Earth/GSAT-7A",
		"Sol/Earth/GSAT-8",
		"Sol/Earth/GSAT-9",
		"Sol/Earth/GSAT-10",
		"Sol/Earth/GSAT-11",
		"Sol/Earth/GSAT-12",
		"Sol/Earth/GSAT-14",
		"Sol/Earth/GSAT-15",
		"Sol/Earth/GSAT-16",
		"Sol/Earth/GSAT-17",
		"Sol/Earth/GSAT-18",
		"Sol/Earth/GSAT-19",
		"Sol/Earth/GSAT-29",
		"Sol/Earth/GSAT-30",
		"Sol/Earth/GSAT-31",
		--* Geizer
		"Sol/Earth/Geizer 11L",
		"Sol/Earth/Geizer 12L",
		"Sol/Earth/Geizer 13L",
		"Sol/Earth/Geizer 15L",
		"Sol/Earth/Geizer 16L",
		"Sol/Earth/Geizer 17L",
		"Sol/Earth/Geizer 18L",
		"Sol/Earth/Geizer 19L",
		"Sol/Earth/Geizer 20L",
		"Sol/Earth/Geizer 22L",
		-- Gals
		"Sol/Earth/Gals 1",
		"Sol/Earth/Gals 2",
		-- Gorizont
		"Sol/Earth/Gorizont 1",
		"Sol/Earth/Gorizont 2",
		"Sol/Earth/Gorizont 3",
		"Sol/Earth/Gorizont 4",
		"Sol/Earth/Gorizont 5",
		"Sol/Earth/Gorizont 6",
		"Sol/Earth/Gorizont 7",
		"Sol/Earth/Gorizont 8",
		"Sol/Earth/Gorizont 9",
		"Sol/Earth/Gorizont 10",
		"Sol/Earth/Gorizont 11",
		"Sol/Earth/Gorizont 12",
		"Sol/Earth/Gorizont 13",
		"Sol/Earth/Gorizont 14",
		"Sol/Earth/Gorizont 15",
		"Sol/Earth/Gorizont 16",
		"Sol/Earth/Gorizont 17",
		"Sol/Earth/Gorizont 18",
		"Sol/Earth/Gorizont 19",
		"Sol/Earth/Gorizont 20",
		"Sol/Earth/Gorizont 21",
		"Sol/Earth/Gorizont 22",
		"Sol/Earth/Gorizont 23",
		"Sol/Earth/Gorizont 24",
		"Sol/Earth/Gorizont 25",
		"Sol/Earth/Gorizont 26",
		"Sol/Earth/Gorizont 27",
		"Sol/Earth/Gorizont 28",
		"Sol/Earth/Gorizont 29",
		"Sol/Earth/Gorizont 30",
		"Sol/Earth/Gorizont 31",
		"Sol/Earth/Gorizont 32",
		"Sol/Earth/Gorizont 33",
		--***************************************
		--***************************************
		--***************************************
		-- H
		
		--Hayabusa
		"Sol/Hayabusa 1",
		"Sol/Hayabusa 2",
		-- Helios
		"Sol/Helios A",
		"Sol/Helios B",
		
		"Sol/Earth/Herschel",
		"Sol/Earth/Hinode",
		"Sol/Earth/Hipparcos",
		"Sol/Earth/Moon/_hiten",
			"Sol/Earth/Moon/_hiten/Hiten",
		"Sol/Earth/Hitomi",
		-- Horizons
		-- Horizons 1 -- see Galaxy 13
		"Sol/Earth/Horizons 2",
		"Sol/Earth/Horizons 3e",
		-- HTV cargo
		"Sol/Earth/HTV-1",
		"Sol/Earth/HTV-2",
		"Sol/Earth/HTV-3",
		"Sol/Earth/HTV-4",
		"Sol/Earth/HTV-5",
		"Sol/Earth/HTV-6",
			"Sol/Earth/HTV-6 return",
			"Sol/Earth/HTV-6 departure",
		"Sol/Earth/HTV-7",
		"Sol/Earth/HTV-8",
		"Sol/Earth/HTV-9",
		
		"Sol/Earth/Hubble",
		"Sol/Huygens (free flight)",
			"Sol/Saturn/Titan/Huygens Landed",
		"Sol/Hope",
		--***************************************
		--***************************************
		--***************************************
		-- I
		"Sol/Earth/IBEX",
		-- Icesat
		"Sol/Earth/ICESat",
		"Sol/Earth/ICESat-2",
		
		"Sol/Earth/ICON",
		"Sol/InSight (orbiter)",
			"Sol/Mars/InSight (Lander)",
		"Sol/Earth/INTEGRAL",
		"Sol/Earth/IRIS (sat)",
		
		"Sol/Earth/ISEE-1",
		"Sol/Earth/ISEE-2",
		"Sol/Earth/ISEE-3",
		"Sol/Earth/ISIS 1",
		"Sol/Earth/ISIS 2",
		
		"Sol/Earth/ISO",
		"Sol/Earth/ISO (Earth Barycentre)",
		--INSAT
		"Sol/Earth/INSAT-1A",
		"Sol/Earth/INSAT-1B",
		"Sol/Earth/INSAT-1C",
		"Sol/Earth/INSAT-1D",
		"Sol/Earth/INSAT-2A",
		"Sol/Earth/INSAT-2B",
		"Sol/Earth/INSAT-2C",
		"Sol/Earth/INSAT-2D",
		"Sol/Earth/INSAT-2DT",
		"Sol/Earth/INSAT-2E",
		"Sol/Earth/INSAT-3A",
		"Sol/Earth/INSAT-3B",
		"Sol/Earth/INSAT-3C",
		"Sol/Earth/INSAT-3D",
		"Sol/Earth/INSAT-3DR",
		"Sol/Earth/INSAT-3E",
		"Sol/Earth/INSAT-4A",
		"Sol/Earth/INSAT-4B",
		"Sol/Earth/INSAT-4CR",
		-- Inmarsat
		"Sol/Earth/MARISAT 1",
		"Sol/Earth/MARISAT 2",
		"Sol/Earth/MARISAT 3",
		"Sol/Earth/MARECS-A",
		"Sol/Earth/MARECS-B2",
		"Sol/Earth/INMARSAT 201",
		"Sol/Earth/INMARSAT 202",
		"Sol/Earth/INMARSAT 203",
		"Sol/Earth/INMARSAT 204",
		"Sol/Earth/INMARSAT 301",
		"Sol/Earth/INMARSAT 302",
		"Sol/Earth/INMARSAT 303",
		"Sol/Earth/INMARSAT 304",
		"Sol/Earth/INMARSAT 305",
		"Sol/Earth/INMARSAT 401",
		"Sol/Earth/INMARSAT 402",
		"Sol/Earth/INMARSAT 403",
		"Sol/Earth/INMARSAT 4A-4",
		"Sol/Earth/INMARSAT 501",
		"Sol/Earth/INMARSAT 502",
		"Sol/Earth/INMARSAT 503",
		"Sol/Earth/INMARSAT 504",
		"Sol/Earth/INMARSAT 505",
		------ IRRIDIUM ---------------
		"Sol/Earth/DUMMY MASS 1",
		"Sol/Earth/DUMMY MASS 2",
		"Sol/Earth/IRIDIUM 2",
		"Sol/Earth/IRIDIUM 3",
		"Sol/Earth/IRIDIUM 4",
		"Sol/Earth/IRIDIUM 5",
		"Sol/Earth/IRIDIUM 6",
		"Sol/Earth/IRIDIUM 7",
		"Sol/Earth/IRIDIUM 8",
		"Sol/Earth/IRIDIUM 10",
		"Sol/Earth/IRIDIUM 11",
		"Sol/Earth/IRIDIUM 12",
		"Sol/Earth/IRIDIUM 13",
		"Sol/Earth/IRIDIUM 14",
		"Sol/Earth/IRIDIUM 15",
		"Sol/Earth/IRIDIUM 16",
		"Sol/Earth/IRIDIUM 17",
		"Sol/Earth/IRIDIUM 18",
		"Sol/Earth/IRIDIUM 19",
		"Sol/Earth/IRIDIUM 20",
		"Sol/Earth/IRIDIUM 21",
		"Sol/Earth/IRIDIUM 22",
		"Sol/Earth/IRIDIUM 23",
		"Sol/Earth/IRIDIUM 24",
		"Sol/Earth/IRIDIUM 25",
		"Sol/Earth/IRIDIUM 26",
		"Sol/Earth/IRIDIUM 28",
		"Sol/Earth/IRIDIUM 29",
		"Sol/Earth/IRIDIUM 30",
		"Sol/Earth/IRIDIUM 31",
		"Sol/Earth/IRIDIUM 32",
		"Sol/Earth/IRIDIUM 33",
		"Sol/Earth/IRIDIUM 34",
		"Sol/Earth/IRIDIUM 35",
		"Sol/Earth/IRIDIUM 36",
		"Sol/Earth/IRIDIUM 37",
		"Sol/Earth/IRIDIUM 38",
		"Sol/Earth/IRIDIUM 39",
		"Sol/Earth/IRIDIUM 40",
		"Sol/Earth/IRIDIUM 41",
		"Sol/Earth/IRIDIUM 42",
		"Sol/Earth/IRIDIUM 43",
		"Sol/Earth/IRIDIUM 44",
		"Sol/Earth/IRIDIUM 45",
		"Sol/Earth/IRIDIUM 46",
		"Sol/Earth/IRIDIUM 47",
		"Sol/Earth/IRIDIUM 49",
		"Sol/Earth/IRIDIUM 50",
		"Sol/Earth/IRIDIUM 51",
		"Sol/Earth/IRIDIUM 52",
		"Sol/Earth/IRIDIUM 53",
		"Sol/Earth/IRIDIUM 54",
		"Sol/Earth/IRIDIUM 55",
		"Sol/Earth/IRIDIUM 56",
		"Sol/Earth/IRIDIUM 57",
		"Sol/Earth/IRIDIUM 58",
		"Sol/Earth/IRIDIUM 59",
		"Sol/Earth/IRIDIUM 60",
		"Sol/Earth/IRIDIUM 61",
		"Sol/Earth/IRIDIUM 62",
		"Sol/Earth/IRIDIUM 63",
		"Sol/Earth/IRIDIUM 64",
		"Sol/Earth/IRIDIUM 65",
		"Sol/Earth/IRIDIUM 66",
		"Sol/Earth/IRIDIUM 67",
		"Sol/Earth/IRIDIUM 68",
		"Sol/Earth/IRIDIUM 69",
		"Sol/Earth/IRIDIUM 70",
		"Sol/Earth/IRIDIUM 71",
		"Sol/Earth/IRIDIUM 72",
		"Sol/Earth/IRIDIUM 73",
		"Sol/Earth/IRIDIUM 74",
		"Sol/Earth/IRIDIUM 75",
		"Sol/Earth/IRIDIUM 76",
		"Sol/Earth/IRIDIUM 77",
		"Sol/Earth/IRIDIUM 80",
		"Sol/Earth/IRIDIUM 81",
		"Sol/Earth/IRIDIUM 82",
		"Sol/Earth/IRIDIUM 83",
		"Sol/Earth/IRIDIUM 84",
		"Sol/Earth/IRIDIUM 86",
		"Sol/Earth/IRIDIUM 90",
		"Sol/Earth/IRIDIUM 91",
		"Sol/Earth/IRIDIUM 94",
		"Sol/Earth/IRIDIUM 95",
		"Sol/Earth/IRIDIUM 96",
		"Sol/Earth/IRIDIUM 97",
		"Sol/Earth/IRIDIUM 98",
		"Sol/Earth/IRIDIUM 911",
		"Sol/Earth/IRIDIUM 914",
		"Sol/Earth/IRIDIUM 920",
		"Sol/Earth/IRIDIUM 921",
		"Sol/Earth/IRIDIUM 100",
		"Sol/Earth/IRIDIUM 102",
		"Sol/Earth/IRIDIUM 103",
		"Sol/Earth/IRIDIUM 104",
		"Sol/Earth/IRIDIUM 105",
		"Sol/Earth/IRIDIUM 106",
		"Sol/Earth/IRIDIUM 107",
		"Sol/Earth/IRIDIUM 108",
		"Sol/Earth/IRIDIUM 109",
		"Sol/Earth/IRIDIUM 110",
		"Sol/Earth/IRIDIUM 111",
		"Sol/Earth/IRIDIUM 112",
		"Sol/Earth/IRIDIUM 113",
		"Sol/Earth/IRIDIUM 114",
		"Sol/Earth/IRIDIUM 115",
		"Sol/Earth/IRIDIUM 116",
		"Sol/Earth/IRIDIUM 117",
		"Sol/Earth/IRIDIUM 118",
		"Sol/Earth/IRIDIUM 119",
		"Sol/Earth/IRIDIUM 120",
		"Sol/Earth/IRIDIUM 121",
		"Sol/Earth/IRIDIUM 122",
		"Sol/Earth/IRIDIUM 123",
		"Sol/Earth/IRIDIUM 124",
		"Sol/Earth/IRIDIUM 125",
		"Sol/Earth/IRIDIUM 126",
		"Sol/Earth/IRIDIUM 128",
		"Sol/Earth/IRIDIUM 129",
		"Sol/Earth/IRIDIUM 130",
		"Sol/Earth/IRIDIUM 131",
		"Sol/Earth/IRIDIUM 132",
		"Sol/Earth/IRIDIUM 133",
		"Sol/Earth/IRIDIUM 134",
		"Sol/Earth/IRIDIUM 135",
		"Sol/Earth/IRIDIUM 136",
		"Sol/Earth/IRIDIUM 137",
		"Sol/Earth/IRIDIUM 138",
		"Sol/Earth/IRIDIUM 139",
		"Sol/Earth/IRIDIUM 140",
		"Sol/Earth/IRIDIUM 141",
		"Sol/Earth/IRIDIUM 142",
		"Sol/Earth/IRIDIUM 143",
		"Sol/Earth/IRIDIUM 144",
		"Sol/Earth/IRIDIUM 145",
		"Sol/Earth/IRIDIUM 146",
		"Sol/Earth/IRIDIUM 147",
		"Sol/Earth/IRIDIUM 148",
		"Sol/Earth/IRIDIUM 149",
		"Sol/Earth/IRIDIUM 150",
		"Sol/Earth/IRIDIUM 151",
		"Sol/Earth/IRIDIUM 152",
		"Sol/Earth/IRIDIUM 153",
		"Sol/Earth/IRIDIUM 154",
		"Sol/Earth/IRIDIUM 155",
		"Sol/Earth/IRIDIUM 156",
		"Sol/Earth/IRIDIUM 157",
		"Sol/Earth/IRIDIUM 158",
		"Sol/Earth/IRIDIUM 159",
		"Sol/Earth/IRIDIUM 160",
		"Sol/Earth/IRIDIUM 161",
		"Sol/Earth/IRIDIUM 162",
		"Sol/Earth/IRIDIUM 163",
		"Sol/Earth/IRIDIUM 164",
		"Sol/Earth/IRIDIUM 165",
		"Sol/Earth/IRIDIUM 166",
		"Sol/Earth/IRIDIUM 167",
		"Sol/Earth/IRIDIUM 168",
		"Sol/Earth/IRIDIUM 169",
		"Sol/Earth/IRIDIUM 170",
		"Sol/Earth/IRIDIUM 171",
		"Sol/Earth/IRIDIUM 172",
		"Sol/Earth/IRIDIUM 173",
		"Sol/Earth/IRIDIUM 175",
		"Sol/Earth/IRIDIUM 176",
		"Sol/Earth/IRIDIUM 180",
		"Sol/Earth/ISIS 1",
		"Sol/Earth/ISIS 2",
		-- ISS
		"Sol/Earth/ISS full",
		"Sol/Earth/ISS 1",
		"Sol/Earth/ISS 2",
		"Sol/Earth/ISS 3",
		"Sol/Earth/ISS 4",
		"Sol/Earth/ISS 5",
		"Sol/Earth/ISS 6",
		"Sol/Earth/ISS 7",
		"Sol/Earth/ISS 8",
		"Sol/Earth/ISS 9",
		"Sol/Earth/ISS 10",
		"Sol/Earth/ISS 11",
		"Sol/Earth/ISS 12",
		"Sol/Earth/ISS 13",
		"Sol/Earth/ISS 7",
		"Sol/Earth/ISS Zarya",
		
		--***************************************
		--***************************************
		--***************************************
		-- J
		"Sol/Earth/James Webb ST",
		-- Jason
		"Sol/Earth/Jason-1",
		"Sol/Earth/Jason-2",
		"Sol/Earth/Jason-3",
		
		"Sol/Juno (sat)",
		--***************************************
		--***************************************
		--***************************************
		-- K
		"Sol/Earth/Moon/Kaguya",
		"Sol/Kepler",
		"Sol/Earth/KIKU 8",
		"Sol/Earth/Kosmos 2237 Tselina-2",
		-- Kepler
		"Sol/Earth/KEPLER-1 (CASE)",
		"Sol/Earth/KEPLER-2 (TARS)",
		"Sol/Earth/KEPLER-5 (AMIDALA)",
		"Sol/Earth/KEPLER-4 (ANTILLES)",
		"Sol/Earth/KEPLER-12 (BOBA)",
		"Sol/Earth/KEPLER-13 (LUCKY)",
		"Sol/Earth/KEPLER-15 (SUDORMRF)",
		"Sol/Earth/KEPLER-8 (AMAROK)",
		"Sol/Earth/KEPLER-10 (BABY YODA)",
		"Sol/Earth/KEPLER-11 (DANEEL)",
		"Sol/Earth/KEPLER-14 (STELLA)",
		"Sol/Earth/KEPLER-9 (ARTEMIS)",
		"Sol/Earth/KEPLER-7 (C3PO)",
		"Sol/Earth/KEPLER-6 (ROCINANTE)",
		
		--***************************************
		--***************************************
		--***************************************
		-- L
		"Sol/Earth/Moon/LADEE:",
		
		"Sol/Earth/LAGEOS 1",
		"Sol/Earth/LAGEOS 2",
		
		"Sol/Earth/Landsat 7",
		"Sol/Earth/Landsat 8",
		
		"Sol/Earth/LCROSS",
			"Sol/Earth/LCROSS/LCROSS Centaur",
			"Sol/Earth/Moon/Centaur(ejecta plume)",
		-- Leasat
		"Sol/Earth/Leasat 1",
		"Sol/Earth/Leasat 2",
		"Sol/Earth/Leasat 3",
		"Sol/Earth/Leasat 4",
		"Sol/Earth/Leasat 5",
		"Sol/Earth/LDEF",
		
		"Sol/LISA Pathfinder",
		"Sol/Lucy",
		
		"Sol/Earth/Moon/Lunar Orbiter 1",
		"Sol/Earth/Moon/Lunar Orbiter 2",
		"Sol/Earth/Moon/Lunar Orbiter 3",
		"Sol/Earth/Moon/Lunar Orbiter 4",
		"Sol/Earth/Moon/Lunar Orbiter 5",
		
		"Sol/Earth/Lunar Prospector",
		"Sol/Earth/Lunar Reconnaissance Orbiter",
		-- Luch
		"Sol/Earth/Cosmos 1700",
		"Sol/Earth/Cosmos 1897",
		"Sol/Earth/Cosmos 2054",
		"Sol/Earth/Luch 1",
		"Sol/Earth/Luch 2",
		"Sol/Earth/Luch 5A",
		"Sol/Earth/Luch 5B",
		"Sol/Earth/Luch 5V",
		"Sol/Earth/Olymp-K",
		
		-- Luna
		"Sol/Earth/Moon/Luna2 site",
			"Sol/Earth/Moon/Luna2 site/Luna 2",
		"Sol/Earth/Moon/Luna5 site",
			"Sol/Earth/Moon/Luna5 site/Luna 5",
		"Sol/Earth/Moon/Luna7 site",
			"Sol/Earth/Moon/Luna7 site/Luna 7",
		"Sol/Earth/Moon/Luna8 site",
			"Sol/Earth/Moon/Luna8 site/Luna 8",
		"Sol/Earth/Moon/Luna 9",
		"Sol/Earth/Moon/Luna 10",
		"Sol/Earth/Moon/Luna13 site",
			"Sol/Earth/Moon/Luna13 site/Luna 13",
		"Sol/Earth/Moon/Luna15 site",
			"Sol/Earth/Moon/Luna15 site/Luna 15",
		"Sol/Earth/Moon/Luna16 site",
			"Sol/Earth/Moon/Luna16 site/Luna 16",
		"Sol/Earth/Moon/Luna17 site",
			"Sol/Earth/Moon/Luna17 site/Luna 17",
			"Sol/Earth/Moon/Luna17 site/Luna 17Lunokhod 1",
		"Sol/Earth/Moon/Luna18 site",
			"Sol/Earth/Moon/Luna18 site/Luna 18",
		"Sol/Earth/Moon/Luna20 site",
			"Sol/Earth/Moon/Luna20 site/Luna 20",
		"Sol/Earth/Moon/Luna 21",
		"Sol/Earth/Moon/Lunokhod 2 bis",
		"Sol/Earth/Moon/Luna23 site",
			"Sol/Earth/Moon/Luna23 site/Luna 23",
		"Sol/Earth/Moon/Luna24 site",
			"Sol/Earth/Moon/Luna24 site/Luna 24 landing",
			"Sol/Earth/Moon/Luna 24 return",
		--***************************************
		--***************************************
		--***************************************
		-- M
		"Sol/Venus/Magellan (probe)",
		-- Mariner
		"Sol/Venus/Mariner 2",
		"Sol/MarCO-A",
		"Sol/MarCO-B",
		"Sol/Mariner 3",
		"Sol/Mariner 4",
		"Sol/Mariner 5",
		"Sol/Mariner 6",
		"Sol/Mariner 7",
		"Sol/Mars/Mariner 9",
		"Sol/Mariner 10",
		-- Mars Explorer
		"Sol/Mars/Mars Explorer-A",
		"Sol/Mars/Mars Explorer-B",
		
		"Sol/Mars/Mars Global Surveyor",
		"Sol/MSL cruiser",
		"Sol/Mars 2020 cruiser",
		"Sol/Mars Observer",
		"Sol/Mars/Mars Odyssey",
		"Sol/Mars Orbiter Mission",
		"Sol/Mars/Mars Pathfinder",
		"Sol/Mars/ Mars Pathfinder",
		"Sol/Mars/Mars Pathfinder/Sojourner",
		"Sol/Mars/ Mars Pathfinder/ Sojourner",
		"Sol/Mars/Mars Polar Lander",
		-- Mercury
		"Sol/Earth/Mercury-Atlas 6 Friendship 7",
		"Sol/Earth/Mercury-Redstone MR3",
		
		"Sol/Mars/Opportunity (rover)",
		"Sol/Mars/Spirit (rover)",
		"Sol/Mars Express",
			"Sol/Mars Express/Beagle 2",
			"Sol/Mars Express/MARSIS",
		
		"Sol/Mars/Path(finder)",
			"Sol/Mars/Path(finder)/Pathfinder",
		"Sol/MRO",
		"Sol/Mars/MAVEN",
			"Sol/MAVEN",
		"Sol/Earth/Friendship 7", -- Mercury program
			"Sol/Earth/Friendship 7/Friendship Component 1", -- Mercury program
			"Sol/Earth/Friendship 7/Friendship Component 2", -- Mercury program
		"Sol/Earth/Freedom 7", -- Mercury program
		"Sol/Earth/Liberty Bell 7", -- Mercury program
		"Sol/MESSENGER",
		"Sol/Earth/Mir",
		"Sol/Earth/MOST",
		"Sol/Earth/MUSES-B",
		-- Meteosat
		"Sol/Earth/METEOSAT-1",
		"Sol/Earth/METEOSAT-2",
		"Sol/Earth/METEOSAT-P2",
		"Sol/Earth/METEOSAT-4 MOP-1",
		"Sol/Earth/METEOSAT-5 MOP-2",
		"Sol/Earth/METEOSAT-6 MOP-3",
		"Sol/Earth/METEOSAT-7",
		"Sol/Earth/METEOSAT-8 MSG-1",
		"Sol/Earth/METEOSAT-9 MSG-2",
		"Sol/Earth/METEOSAT-10 MSG-3",
		"Sol/Earth/METEOSAT-11 MSG-4",
		"Sol/Earth/MetOp-A",
		"Sol/Earth/MetOp-B",
		"Sol/Earth/MetOp-C",
		"Sol/Earth/MMS-1",
		"Sol/Earth/MMS-2",
		"Sol/Earth/MMS-3",
		"Sol/Earth/MMS-4",
		--***************************************
		--***************************************
		--***************************************
		-- N
		"Sol/Earth/N1",
		"Sol/Earth/N1-L3",
		"Sol/Earth/NATO-2A",
		"Sol/Earth/NATO-2B",
		"Sol/Earth/NATO-3A",
		"Sol/Earth/NATO-3B",
		"Sol/Earth/NATO-3C",
		"Sol/Earth/NATO-3D",
		"Sol/Earth/NATO-4A",
		"Sol/Earth/NATO-4B",
		-- Navstar GPS
		"Sol/Earth/NAVSTAR 1",
		"Sol/Earth/NAVSTAR 2",
		"Sol/Earth/NAVSTAR 3",
		"Sol/Earth/NAVSTAR 4",
		"Sol/Earth/NAVSTAR 5",
		"Sol/Earth/NAVSTAR 6",
		"Sol/Earth/NAVSTAR 8",
		"Sol/Earth/NAVSTAR 9",
		"Sol/Earth/NAVSTAR 10",
		"Sol/Earth/NAVSTAR 11",
		"Sol/Earth/NAVSTAR 13",
		"Sol/Earth/NAVSTAR 14",
		"Sol/Earth/NAVSTAR 15",
		"Sol/Earth/NAVSTAR 16",
		"Sol/Earth/NAVSTAR 17",
		"Sol/Earth/NAVSTAR 18",
		"Sol/Earth/NAVSTAR 19",
		"Sol/Earth/NAVSTAR 20",
		"Sol/Earth/NAVSTAR 21",
		"Sol/Earth/NAVSTAR 22",
		"Sol/Earth/NAVSTAR 23",
		"Sol/Earth/NAVSTAR 24",
		"Sol/Earth/NAVSTAR 25",
		"Sol/Earth/NAVSTAR 26",
		"Sol/Earth/NAVSTAR 27",
		"Sol/Earth/NAVSTAR 28",
		"Sol/Earth/NAVSTAR 29",
		"Sol/Earth/NAVSTAR 30",
		"Sol/Earth/NAVSTAR 31",
		"Sol/Earth/NAVSTAR 32",
		"Sol/Earth/NAVSTAR 33",
		"Sol/Earth/NAVSTAR 34",
		"Sol/Earth/NAVSTAR 35",
		"Sol/Earth/NAVSTAR 36",
		"Sol/Earth/NAVSTAR 37",
		"Sol/Earth/NAVSTAR 38",
		"Sol/Earth/NAVSTAR 39",
		"Sol/Earth/NAVSTAR 44", -- in standby
		"Sol/Earth/NAVSTAR 42", -- destroyed after 13 seconds
		"Sol/Earth/NAVSTAR 43",
		"Sol/Earth/NAVSTAR 46",
		"Sol/Earth/NAVSTAR 47",
		"Sol/Earth/NAVSTAR 48",
		"Sol/Earth/NAVSTAR 49",
		"Sol/Earth/NAVSTAR 50", -- in standby
		"Sol/Earth/NAVSTAR 51",
		"Sol/Earth/NAVSTAR 52",
		"Sol/Earth/NAVSTAR 53",
		"Sol/Earth/NAVSTAR 54",
		"Sol/Earth/NAVSTAR 55", -- Nonoperational
		"Sol/Earth/NAVSTAR 56",
		"Sol/Earth/NAVSTAR 57",
		"Sol/Earth/NAVSTAR 58",
		"Sol/Earth/NAVSTAR 59",
		"Sol/Earth/NAVSTAR 60",
		"Sol/Earth/NAVSTAR 61",
		"Sol/Earth/NAVSTAR 62",
		"Sol/Earth/NAVSTAR 63", -- in standby
		"Sol/Earth/NAVSTAR 64",
		"Sol/Earth/NAVSTAR 65",
		"Sol/Earth/NAVSTAR 66",
		"Sol/Earth/NAVSTAR 67",
		"Sol/Earth/NAVSTAR 68",
		"Sol/Earth/NAVSTAR 69",
		"Sol/Earth/NAVSTAR 70",
		"Sol/Earth/NAVSTAR 71",
		"Sol/Earth/NAVSTAR 72",
		"Sol/Earth/NAVSTAR 73",
		"Sol/Earth/NAVSTAR 74",
		"Sol/Earth/NAVSTAR 75",
		"Sol/Earth/NAVSTAR 76",
		"Sol/Earth/NAVSTAR 77",
		"Sol/Earth/NAVSTAR 78",
		"Sol/Earth/NAVSTAR 79",
		"Sol/Earth/NAVSTAR 80",
		"Sol/Earth/NAVSTAR 81",
		-- N-STAR
		--Sol/Earth/N-STAR a -- exit in Galaxy fleet
		"Sol/Earth/N-STAR b",
		"Sol/Earth/N-STAR c",
		"Sol/Earth/N-STAR d",
		-- Nimiq
		"Sol/Earth/Nimiq 1",
		"Sol/Earth/Nimiq 2",
		"Sol/Earth/Nimiq 3", -- see DirecTV-3
		"Sol/Earth/Nimiq 4",
		"Sol/Earth/Nimiq 4i", -- see DirecTV-2
		--Sol/Earth/Nimiq 4iR
		"Sol/Earth/Nimiq 5",
		"Sol/Earth/Nimiq 6",
		
		"Sol/NEAR",
		"Sol/New Horizons",
		"Sol/Nozomi (Planet-B)",
		-- NOAA
		"Sol/Earth/NOAA-1",
		"Sol/Earth/NOAA-2",
		"Sol/Earth/NOAA-3",
		"Sol/Earth/NOAA-4",
		"Sol/Earth/NOAA-5",
		"Sol/Earth/NOAA-6",
		"Sol/Earth/NOAA-7",
		"Sol/Earth/NOAA-8",
		"Sol/Earth/NOAA-9",
		"Sol/Earth/NOAA-10",
		"Sol/Earth/NOAA-11",
		"Sol/Earth/NOAA-12",
		"Sol/Earth/NOAA-13",
		"Sol/Earth/NOAA POES-14",
		"Sol/Earth/NOAA POES-15",
		"Sol/Earth/NOAA POES-16",
		"Sol/Earth/NOAA POES-17",
		"Sol/Earth/NOAA POES-18",
		"Sol/Earth/NOAA POES-19",
		"Sol/Earth/NOAA-20",
		--***************************************
		--***************************************
		--***************************************
		-- O
		"Sol/Earth/OCO-2",
		"Sol/Earth/Omid",
		"Sol/Earth/OrbView 2",
		"Sol/Earth/Ouna",
		
		"Sol/OSIRIS-REx",
		--"Sol/OSIRIS-REx/OSIRIS-REx SRC", -- component
		-- Oneweb ----
		"Sol/Earth/ONEWEB-0006",
		"Sol/Earth/ONEWEB-0007",
		"Sol/Earth/ONEWEB-0008",
		"Sol/Earth/ONEWEB-0010",
		"Sol/Earth/ONEWEB-0011",
		"Sol/Earth/ONEWEB-0012",
		"Sol/Earth/ONEWEB-0013",
		"Sol/Earth/ONEWEB-0017",
		"Sol/Earth/ONEWEB-0018",
		"Sol/Earth/ONEWEB-0019",
		"Sol/Earth/ONEWEB-0020",
		"Sol/Earth/ONEWEB-0021",
		"Sol/Earth/ONEWEB-0022",
		"Sol/Earth/ONEWEB-0023",
		"Sol/Earth/ONEWEB-0024",
		"Sol/Earth/ONEWEB-0025",
		"Sol/Earth/ONEWEB-0026",
		"Sol/Earth/ONEWEB-0027",
		"Sol/Earth/ONEWEB-0028",
		"Sol/Earth/ONEWEB-0029",
		"Sol/Earth/ONEWEB-0031",
		"Sol/Earth/ONEWEB-0032",
		"Sol/Earth/ONEWEB-0033",
		"Sol/Earth/ONEWEB-0034",
		"Sol/Earth/ONEWEB-0035",
		"Sol/Earth/ONEWEB-0036",
		"Sol/Earth/ONEWEB-0037",
		"Sol/Earth/ONEWEB-0038",
		"Sol/Earth/ONEWEB-0039",
		"Sol/Earth/ONEWEB-0040",
		"Sol/Earth/ONEWEB-0041",
		"Sol/Earth/ONEWEB-0042",
		"Sol/Earth/ONEWEB-0043",
		"Sol/Earth/ONEWEB-0044",
		"Sol/Earth/ONEWEB-0045",
		"Sol/Earth/ONEWEB-0046",
		"Sol/Earth/ONEWEB-0047",
		"Sol/Earth/ONEWEB-0048",
		"Sol/Earth/ONEWEB-0049",
		"Sol/Earth/ONEWEB-0050",
		"Sol/Earth/ONEWEB-0051",
		"Sol/Earth/ONEWEB-0052",
		"Sol/Earth/ONEWEB-0053",
		"Sol/Earth/ONEWEB-0054",
		"Sol/Earth/ONEWEB-0055",
		"Sol/Earth/ONEWEB-0056",
		"Sol/Earth/ONEWEB-0057",
		"Sol/Earth/ONEWEB-0058",
		"Sol/Earth/ONEWEB-0059",
		"Sol/Earth/ONEWEB-0060",
		"Sol/Earth/ONEWEB-0061",
		"Sol/Earth/ONEWEB-0062",
		"Sol/Earth/ONEWEB-0063",
		"Sol/Earth/ONEWEB-0064",
		"Sol/Earth/ONEWEB-0065",
		"Sol/Earth/ONEWEB-0066",
		"Sol/Earth/ONEWEB-0067",
		"Sol/Earth/ONEWEB-0068",
		"Sol/Earth/ONEWEB-0069",
		"Sol/Earth/ONEWEB-0080",
		"Sol/Earth/ONEWEB-0081",
		"Sol/Earth/ONEWEB-0082",
		"Sol/Earth/ONEWEB-0083",
		"Sol/Earth/ONEWEB-0085",
		"Sol/Earth/ONEWEB-0086",
		"Sol/Earth/ONEWEB-0087",
		"Sol/Earth/ONEWEB-0088",
		"Sol/Earth/ONEWEB-0090",
		"Sol/Earth/ONEWEB-0092",
		"Sol/Earth/ONEWEB-0093",
		"Sol/Earth/ONEWEB-0094",
		"Sol/Earth/ONEWEB-0095",
		"Sol/Earth/ONEWEB-0096",
		"Sol/Earth/ONEWEB-0098",
		"Sol/Earth/ONEWEB-0101",
		"Sol/Earth/ONEWEB-0102",
		"Sol/Earth/ONEWEB-0107",
		"Sol/Earth/ONEWEB-0108",
		"Sol/Earth/ONEWEB-0109",
		"Sol/Earth/ONEWEB-0110",
		"Sol/Earth/ONEWEB-0111",
		"Sol/Earth/ONEWEB-0112",
		"Sol/Earth/ONEWEB-0113",
		"Sol/Earth/ONEWEB-0114",
		"Sol/Earth/ONEWEB-0115",
		"Sol/Earth/ONEWEB-0116",
		"Sol/Earth/ONEWEB-0117",
		"Sol/Earth/ONEWEB-0118",
		"Sol/Earth/ONEWEB-0119",
		"Sol/Earth/ONEWEB-0120",
		"Sol/Earth/ONEWEB-0121",
		"Sol/Earth/ONEWEB-0122",
		"Sol/Earth/ONEWEB-0123",
		"Sol/Earth/ONEWEB-0124",
		"Sol/Earth/ONEWEB-0125",
		"Sol/Earth/ONEWEB-0126",
		"Sol/Earth/ONEWEB-0127",
		"Sol/Earth/ONEWEB-0128",
		"Sol/Earth/ONEWEB-0129",
		"Sol/Earth/ONEWEB-0130",
		"Sol/Earth/ONEWEB-0131",
		"Sol/Earth/ONEWEB-0132",
		"Sol/Earth/ONEWEB-0133",
		"Sol/Earth/ONEWEB-0134",
		"Sol/Earth/ONEWEB-0135",
		"Sol/Earth/ONEWEB-0136",
		"Sol/Earth/ONEWEB-0137",
		"Sol/Earth/ONEWEB-0138",
		"Sol/Earth/ONEWEB-0139",
		"Sol/Earth/ONEWEB-0140",
		"Sol/Earth/ONEWEB-0141",
		"Sol/Earth/ONEWEB-0142",
		"Sol/Earth/ONEWEB-0143",
		"Sol/Earth/ONEWEB-0144",
		"Sol/Earth/ONEWEB-0145",
		"Sol/Earth/ONEWEB-0146",
		"Sol/Earth/ONEWEB-0147",
		"Sol/Earth/ONEWEB-0148",
		"Sol/Earth/ONEWEB-0149",
		"Sol/Earth/ONEWEB-0150",
		"Sol/Earth/ONEWEB-0151",
		"Sol/Earth/ONEWEB-0152",
		"Sol/Earth/ONEWEB-0153",
		"Sol/Earth/ONEWEB-0154",
		"Sol/Earth/ONEWEB-0155",
		"Sol/Earth/ONEWEB-0156",
		"Sol/Earth/ONEWEB-0157",
		"Sol/Earth/ONEWEB-0158",
		"Sol/Earth/ONEWEB-0159",
		"Sol/Earth/ONEWEB-0160",
		"Sol/Earth/ONEWEB-0161",
		"Sol/Earth/ONEWEB-0162",
		"Sol/Earth/ONEWEB-0163",
		"Sol/Earth/ONEWEB-0164",
		"Sol/Earth/ONEWEB-0165",
		"Sol/Earth/ONEWEB-0166",
		"Sol/Earth/ONEWEB-0167",
		"Sol/Earth/ONEWEB-0168",
		"Sol/Earth/ONEWEB-0169",
		"Sol/Earth/ONEWEB-0170",
		"Sol/Earth/ONEWEB-0171",
		"Sol/Earth/ONEWEB-0172",
		"Sol/Earth/ONEWEB-0173",
		"Sol/Earth/ONEWEB-0174",
		"Sol/Earth/ONEWEB-0175",
		"Sol/Earth/ONEWEB-0176",
		"Sol/Earth/ONEWEB-0177",
		"Sol/Earth/ONEWEB-0178",
		"Sol/Earth/ONEWEB-0179",
		"Sol/Earth/ONEWEB-0180",
		"Sol/Earth/ONEWEB-0181",
		"Sol/Earth/ONEWEB-0182",
		"Sol/Earth/ONEWEB-0183",
		"Sol/Earth/ONEWEB-0184",
		"Sol/Earth/ONEWEB-0185",
		"Sol/Earth/ONEWEB-0186",
		"Sol/Earth/ONEWEB-0187",
		"Sol/Earth/ONEWEB-0188",
		"Sol/Earth/ONEWEB-0189",
		"Sol/Earth/ONEWEB-0190",
		"Sol/Earth/ONEWEB-0191",
		"Sol/Earth/ONEWEB-0192",
		"Sol/Earth/ONEWEB-0193",
		"Sol/Earth/ONEWEB-0194",
		"Sol/Earth/ONEWEB-0195",
		"Sol/Earth/ONEWEB-0196",
		"Sol/Earth/ONEWEB-0197",
		"Sol/Earth/ONEWEB-0198",
		"Sol/Earth/ONEWEB-0199",
		"Sol/Earth/ONEWEB-0200",
		"Sol/Earth/ONEWEB-0201",
		"Sol/Earth/ONEWEB-0202",
		"Sol/Earth/ONEWEB-0203",
		"Sol/Earth/ONEWEB-0204",
		"Sol/Earth/ONEWEB-0205",
		"Sol/Earth/ONEWEB-0206",
		"Sol/Earth/ONEWEB-0207",
		"Sol/Earth/ONEWEB-0208",
		"Sol/Earth/ONEWEB-0209",
		"Sol/Earth/ONEWEB-0210",
		"Sol/Earth/ONEWEB-0211",
		"Sol/Earth/ONEWEB-0212",
		"Sol/Earth/ONEWEB-0213",
		"Sol/Earth/ONEWEB-0214",
		"Sol/Earth/ONEWEB-0215",
		"Sol/Earth/ONEWEB-0216",
		"Sol/Earth/ONEWEB-0217",
		"Sol/Earth/ONEWEB-0218",
		"Sol/Earth/ONEWEB-0219",
		"Sol/Earth/ONEWEB-0220",
		"Sol/Earth/ONEWEB-0221",
		"Sol/Earth/ONEWEB-0222",
		"Sol/Earth/ONEWEB-0223",
		"Sol/Earth/ONEWEB-0224",
		"Sol/Earth/ONEWEB-0225",
		"Sol/Earth/ONEWEB-0226",
		"Sol/Earth/ONEWEB-0227",
		"Sol/Earth/ONEWEB-0228",
		"Sol/Earth/ONEWEB-0229",
		"Sol/Earth/ONEWEB-0230",
		"Sol/Earth/ONEWEB-0231",
		"Sol/Earth/ONEWEB-0232",
		"Sol/Earth/ONEWEB-0233",
		"Sol/Earth/ONEWEB-0234",
		"Sol/Earth/ONEWEB-0235",
		"Sol/Earth/ONEWEB-0236",
		"Sol/Earth/ONEWEB-0237",
		"Sol/Earth/ONEWEB-0238",
		"Sol/Earth/ONEWEB-0239",
		"Sol/Earth/ONEWEB-0240",
		"Sol/Earth/ONEWEB-0241",
		"Sol/Earth/ONEWEB-0242",
		"Sol/Earth/ONEWEB-0243",
		"Sol/Earth/ONEWEB-0244",
		"Sol/Earth/ONEWEB-0245",
		"Sol/Earth/ONEWEB-0246",
		"Sol/Earth/ONEWEB-0247",
		"Sol/Earth/ONEWEB-0248",
		"Sol/Earth/ONEWEB-0249",
		"Sol/Earth/ONEWEB-0250",
		"Sol/Earth/ONEWEB-0251",
		"Sol/Earth/ONEWEB-0252",
		"Sol/Earth/ONEWEB-0253",
		"Sol/Earth/ONEWEB-0254",
		"Sol/Earth/ONEWEB-0255",
		"Sol/Earth/ONEWEB-0256",
		"Sol/Earth/ONEWEB-0257",
		"Sol/Earth/ONEWEB-0258",
		"Sol/Earth/ONEWEB-0259",
		"Sol/Earth/ONEWEB-0260",
		"Sol/Earth/ONEWEB-0261",
		"Sol/Earth/ONEWEB-0262",
		"Sol/Earth/ONEWEB-0263",
		"Sol/Earth/ONEWEB-0264",
		"Sol/Earth/ONEWEB-0265",
		"Sol/Earth/ONEWEB-0266",
		"Sol/Earth/ONEWEB-0267",
		"Sol/Earth/ONEWEB-0268",
		"Sol/Earth/ONEWEB-0269",
		"Sol/Earth/ONEWEB-0270",
		"Sol/Earth/ONEWEB-0271",
		"Sol/Earth/ONEWEB-0272",
		"Sol/Earth/ONEWEB-0273",
		"Sol/Earth/ONEWEB-0274",
		"Sol/Earth/ONEWEB-0275",
		"Sol/Earth/ONEWEB-0276",
		"Sol/Earth/ONEWEB-0277",
		"Sol/Earth/ONEWEB-0278",
		"Sol/Earth/ONEWEB-0279",
		"Sol/Earth/ONEWEB-0280",
		"Sol/Earth/ONEWEB-0281",
		"Sol/Earth/ONEWEB-0282",
		"Sol/Earth/ONEWEB-0283",
		"Sol/Earth/ONEWEB-0284",
		"Sol/Earth/ONEWEB-0285",
		"Sol/Earth/ONEWEB-0286",
		"Sol/Earth/ONEWEB-0287",
		"Sol/Earth/ONEWEB-0288",
		"Sol/Earth/ONEWEB-0289",
		"Sol/Earth/ONEWEB-0290",
		"Sol/Earth/ONEWEB-0291",
		"Sol/Earth/ONEWEB-0292",
		"Sol/Earth/ONEWEB-0293",
		"Sol/Earth/ONEWEB-0294",
		"Sol/Earth/ONEWEB-0295",
		"Sol/Earth/ONEWEB-0296",
		"Sol/Earth/ONEWEB-0297",
		"Sol/Earth/ONEWEB-0298",
		"Sol/Earth/ONEWEB-0299",
		"Sol/Earth/ONEWEB-0300",
		"Sol/Earth/ONEWEB-0301",
		"Sol/Earth/ONEWEB-0302",
		"Sol/Earth/ONEWEB-0303",
		"Sol/Earth/ONEWEB-0304",
		"Sol/Earth/ONEWEB-0305",
		"Sol/Earth/ONEWEB-0306",
		"Sol/Earth/ONEWEB-0307",
		"Sol/Earth/ONEWEB-0308",
		"Sol/Earth/ONEWEB-0309",
		"Sol/Earth/ONEWEB-0310",
		"Sol/Earth/ONEWEB-0311",
		"Sol/Earth/ONEWEB-0312",
		"Sol/Earth/ONEWEB-0313",
		"Sol/Earth/ONEWEB-0314",
		"Sol/Earth/ONEWEB-0315",
		"Sol/Earth/ONEWEB-0316",
		"Sol/Earth/ONEWEB-0317",
		"Sol/Earth/ONEWEB-0318",
		"Sol/Earth/ONEWEB-0319",
		"Sol/Earth/ONEWEB-0320",
		"Sol/Earth/ONEWEB-0321",
		"Sol/Earth/ONEWEB-0322",
		"Sol/Earth/ONEWEB-0323",
		"Sol/Earth/ONEWEB-0324",
		"Sol/Earth/ONEWEB-0325",
		"Sol/Earth/ONEWEB-0326",
		"Sol/Earth/ONEWEB-0327",
		"Sol/Earth/ONEWEB-0328",
		"Sol/Earth/ONEWEB-0329",
		"Sol/Earth/ONEWEB-0330",
		"Sol/Earth/ONEWEB-0331",
		"Sol/Earth/ONEWEB-0332",
		"Sol/Earth/ONEWEB-0333",
		"Sol/Earth/ONEWEB-0334",
		"Sol/Earth/ONEWEB-0335",
		"Sol/Earth/ONEWEB-0336",
		"Sol/Earth/ONEWEB-0337",
		"Sol/Earth/ONEWEB-0338",
		"Sol/Earth/ONEWEB-0339",
		"Sol/Earth/ONEWEB-0340",
		"Sol/Earth/ONEWEB-0341",
		"Sol/Earth/ONEWEB-0342",
		"Sol/Earth/ONEWEB-0343",
		"Sol/Earth/ONEWEB-0344",
		"Sol/Earth/ONEWEB-0345",
		"Sol/Earth/ONEWEB-0346",
		"Sol/Earth/ONEWEB-0347",
		"Sol/Earth/ONEWEB-0348",
		"Sol/Earth/ONEWEB-0349",
		"Sol/Earth/ONEWEB-0350",
		"Sol/Earth/ONEWEB-0351",
		"Sol/Earth/ONEWEB-0352",
		"Sol/Earth/ONEWEB-0353",
		"Sol/Earth/ONEWEB-0354",
		"Sol/Earth/ONEWEB-0355",
		"Sol/Earth/ONEWEB-0356",
		"Sol/Earth/ONEWEB-0357",
		"Sol/Earth/ONEWEB-0358",
		"Sol/Earth/ONEWEB-0359",
		"Sol/Earth/ONEWEB-0360",
		"Sol/Earth/ONEWEB-0361",
		"Sol/Earth/ONEWEB-0362",
		"Sol/Earth/ONEWEB-0363",
		"Sol/Earth/ONEWEB-0364",
		"Sol/Earth/ONEWEB-0365",
		"Sol/Earth/ONEWEB-0366",
		"Sol/Earth/ONEWEB-0367",
		"Sol/Earth/ONEWEB-0368",
		"Sol/Earth/ONEWEB-0369",
		"Sol/Earth/ONEWEB-0370",
		"Sol/Earth/ONEWEB-0371",
		"Sol/Earth/ONEWEB-0372",
		"Sol/Earth/ONEWEB-0373",
		"Sol/Earth/ONEWEB-0374",
		"Sol/Earth/ONEWEB-0375",
		"Sol/Earth/ONEWEB-0376",
		"Sol/Earth/ONEWEB-0377",
		"Sol/Earth/ONEWEB-0378",
		"Sol/Earth/ONEWEB-0379",
		"Sol/Earth/ONEWEB-0380",
		"Sol/Earth/ONEWEB-0381",
		"Sol/Earth/ONEWEB-0382",
		"Sol/Earth/ONEWEB-0383",
		"Sol/Earth/ONEWEB-0384",
		"Sol/Earth/ONEWEB-0385",
		"Sol/Earth/ONEWEB-0386",
		"Sol/Earth/ONEWEB-0387",
		"Sol/Earth/ONEWEB-0388",
		--***************************************
		--***************************************
		--***************************************
		-- P
		"Sol/Parker Solar Probe",
		"Sol/Earth/Pegasus XL",
		"Sol/Mars/Perseverance",
			"Sol/Mars/Ingenuity",
		"Sol/Earth/Phobos-Grunt",
		"Sol/Phoenix cruiser",
		"Sol/Mars/Phoenix Lander",
		-- Pioneer
		"Sol/Pioneer 6",
		"Sol/Pioneer 7",
		"Sol/Pioneer 10",
		"Sol/Pioneer 11",
		"Sol/Pioneer 12",
		
		"Sol/Earth/Planck",
			"Sol/Earth/Planck/Planck_FOV",
		-- Pleiades
		"Sol/Earth/Pleiades-HR 1A",
		"Sol/Earth/Pleiades-HR 1B",
		"Sol/Earth/PLEIADES NEO 2", -- WHR-2020 (2020–2021)
		"Sol/Earth/PLEIADES NEO 3", -- WHR-2020 (2020–2021)
		"Sol/Earth/PLEIADES NEO 4", -- WHR-2020 (2020–2021)
		"Sol/Earth/PLEIADES NEO 5", -- WHR-2020 (2020–2021)
		"Sol/Earth/PLEIADES NEO 6", -- WHR-2020 (2020–2021)
		
		"Sol/Earth/POLAR",
		-- Proba
		"Sol/Earth/PROBA-1",
		"Sol/Earth/PROBA-2",
		"Sol/Earth/PROBA-V",
		"Sol/Earth/PROBA-3", -- project in 2023
		-- Progress
		"Sol/Earth/Progress-M 04M",
		"Sol/Earth/Progress-MS 08",
		"Sol/Earth/Progress-MS 14",
		"Sol/Earth/Progress-MS 15",
		"Sol/Earth/Progress-MS 16",
		"Sol/Earth/Proton M-BM-pad",
		--***************************************
		--***************************************
		--***************************************
		-- Q
		"Sol/Earth/QuikSCAT",
		--***************************************
		--***************************************
		--***************************************
		-- R
		-- RBSP
		"Sol/Earth/RBSP A",
		"Sol/Earth/RBSP B",
		
		"Sol/Earth/RHESSI",
		"Sol/Rosetta",
		--***************************************
		--***************************************
		--***************************************
		-- S
		-- SAC
		"Sol/Earth/SAC-C",
		"Sol/Earth/SAC-D", -- Aquarius
		
		"Sol/Sakigake",
		"Sol/Earth/Saturn V-pad",
		-- Salyut
		"Sol/Earth/Salyut 1",
		"Sol/Earth/Salyut6",
		"Sol/Earth/Salyut6-Soyuz26",
		"Sol/Earth/Salyut6-Soyuz27",
		"Sol/Earth/Salyut6-SoyuzT2",
		"Sol/Earth/Salyut 6",
		"Sol/Earth/Salyut 7",
		-- SBS
		"Sol/Earth/SBS-1",
		"Sol/Earth/SBS-2",
		"Sol/Earth/SBS-3",
		"Sol/Earth/SBS-4",
		"Sol/Earth/SBS-5",
		"Sol/Earth/SBS-6",
		
		"Sol/Earth/Moon/SMART-1",
		"Sol/Earth/SNC Dream Chaser",
		"Sol/Earth/SDO",
		-- Shenzhou
		"Sol/Earth/Shenzhou",
		"Sol/Earth/Shenzhou 1",
		"Sol/Earth/Shenzhou 2",
		"Sol/Earth/Shenzhou 3",
		"Sol/Earth/Shenzhou 4",
		"Sol/Earth/Shenzhou 5",
		"Sol/Earth/Shenzhou 6",
		"Sol/Earth/Shenzhou 7",
		"Sol/Earth/Shenzhou 8",
		"Sol/Earth/Shenzhou 9",
		"Sol/Earth/Shenzhou 10",
		"Sol/Earth/Shenzhou 11",
		"Sol/Earth/Shenzhou 12",
		
		"Sol/Earth/Skylab",
		"Sol/SoHo (sat)",
		-- Solidaridad
		"Sol/Earth/Solidaridad 1", -- Mexico
		"Sol/Earth/Solidaridad 2", -- Mexico
		-- Morelos
		"Sol/Earth/Morelos 1", -- Mexico
		"Sol/Earth/Morelos 1", -- Mexico
		
		"Sol/Earth/SolarMax",
		"Sol/SolO",
		"Sol/Earth/SORCE",
		"Sol/Earth/Spektr-R",
		"Sol/Spitzer Space Telescope",
		-- Spot
		"Sol/Earth/SPOT-1",
		"Sol/Earth/SPOT-2",
		"Sol/Earth/SPOT-3",
		"Sol/Earth/SPOT-4",
		"Sol/Earth/SPOT-5",
		-- Stardust
		"Sol/Stardust-NExT",
			"Sol/Stardust-NExT/SRC cl 1",
			"Sol/Stardust-NExT/SRC op",
			"Sol/Stardust-NExT/SRC cl 2",
		-- Stereo
		"Sol/Earth/Earth-L4/STEREO-A",
		"Sol/Earth/Earth-L5/STEREO-A",
		
		"Sol/1P-Halley/Suisei",
		"Sol/Earth/Suomi NPP",
		"Sol/Earth/SWAS",
		"Sol/Earth/SWIFT",
		"Sol/Earth/Suzaku",
		"Sol/Earth/SpaceX Starship Cargo",
		-- Shuttle Atlantis
		"Sol/Earth/Atlantis STS-27",
		"Sol/Earth/Atlantis STS-30",
		"Sol/Earth/Atlantis STS-34",
		"Sol/Earth/Atlantis STS-36",
		"Sol/Earth/Atlantis STS-37",
		"Sol/Earth/Atlantis STS-38",
		"Sol/Earth/Atlantis STS-43",
		"Sol/Earth/Atlantis STS-44",
		"Sol/Earth/Atlantis STS-45",
		"Sol/Earth/Atlantis STS-46",
		"Sol/Earth/Atlantis STS-51J",
		"Sol/Earth/Atlantis STS-61B",
		"Sol/Earth/Atlantis STS-66",
		"Sol/Earth/Atlantis STS-71",
		"Sol/Earth/Atlantis STS-74",
		"Sol/Earth/Atlantis STS-76",
		"Sol/Earth/Atlantis STS-79",
		"Sol/Earth/Atlantis STS-81",
		"Sol/Earth/Atlantis STS-84",
		"Sol/Earth/Atlantis STS-86",
		"Sol/Earth/Atlantis STS-98",
		"Sol/Earth/Atlantis STS-101",
		"Sol/Earth/Atlantis STS-104",
		"Sol/Earth/Atlantis STS-106",
		"Sol/Earth/Atlantis STS-110",
		"Sol/Earth/Atlantis STS-112",
		"Sol/Earth/Atlantis STS-115",
		"Sol/Earth/Atlantis STS-117",
		"Sol/Earth/Atlantis STS-122",
		"Sol/Earth/Atlantis STS-125",
		"Sol/Earth/Atlantis STS-129",
		"Sol/Earth/Atlantis STS-132",
		"Sol/Earth/Atlantis STS-135",
		-- Shuttles Challenger
		"Sol/Earth/Challenger STS-6",
		"Sol/Earth/Challenger STS-7",
		"Sol/Earth/Challenger STS-8",
		"Sol/Earth/Challenger STS-41B",
		"Sol/Earth/Challenger STS-41C",
		"Sol/Earth/Challenger STS-41G",
		"Sol/Earth/Challenger STS-51B",
		"Sol/Earth/Challenger STS-51F",
		"Sol/Earth/Challenger STS-61A",
		"Sol/Earth/Challenger STS-51L",
		-- Shuttje Columbia
		"Sol/Earth/Columbia STS 1",
		"Sol/Earth/Columbia STS 2",
		"Sol/Earth/Columbia STS 3",
		"Sol/Earth/Columbia STS 4",
		"Sol/Earth/Columbia STS 5",
		"Sol/Earth/Columbia STS 9",
		"Sol/Earth/Columbia STS 28",
		"Sol/Earth/Columbia STS 32",
		"Sol/Earth/Columbia STS 61C",
		"Sol/Earth/Columbia STS-35",
		"Sol/Earth/Columbia STS-40",
		"Sol/Earth/Columbia STS-50",
		"Sol/Earth/Columbia STS-52",
		"Sol/Earth/Columbia STS-55",
		"Sol/Earth/Columbia STS-58",
		"Sol/Earth/Columbia STS-62",
		"Sol/Earth/Columbia STS-65",
		"Sol/Earth/Columbia STS-73",
		"Sol/Earth/Columbia STS-75",
		"Sol/Earth/Columbia STS-78",
		"Sol/Earth/Columbia STS-80",
		"Sol/Earth/Columbia STS-83",
		"Sol/Earth/Columbia STS-87",
		"Sol/Earth/Columbia STS-90",
		"Sol/Earth/Columbia STS-93",
		"Sol/Earth/Columbia STS-94",
		"Sol/Earth/Columbia STS-107",
		"Sol/Earth/Columbia STS-109",
		-- Shuttje Discovery
		"Sol/Earth/Discovery STS-26",
		"Sol/Earth/Discovery STS-29",
		"Sol/Earth/Discovery STS-31",
		"Sol/Earth/Discovery STS-33",
		"Sol/Earth/Discovery STS-39",
		"Sol/Earth/Discovery STS-41",
		"Sol/Earth/Discovery STS-41D",
		"Sol/Earth/Discovery STS-42",
		"Sol/Earth/Discovery STS-48",
		"Sol/Earth/Discovery STS-51",
		"Sol/Earth/Discovery STS-51A",
		"Sol/Earth/Discovery STS-51C",
		"Sol/Earth/Discovery STS-51D",
		"Sol/Earth/Discovery STS-51G",
		"Sol/Earth/Discovery STS-51I",
		"Sol/Earth/Discovery STS-53",
		"Sol/Earth/Discovery STS-56",
		"Sol/Earth/Discovery STS-60",
		"Sol/Earth/Discovery STS-63",
		"Sol/Earth/Discovery STS-64",
		"Sol/Earth/Discovery STS-70",
		"Sol/Earth/Discovery STS-82",
		"Sol/Earth/Discovery STS-85",
		"Sol/Earth/Discovery STS-91",
		"Sol/Earth/Discovery STS-92",
		"Sol/Earth/Discovery STS-95",
		"Sol/Earth/Discovery STS-96",
		"Sol/Earth/Discovery STS-102",
		"Sol/Earth/Discovery STS-103",
		"Sol/Earth/Discovery STS-105",
		"Sol/Earth/Discovery STS-114",
		"Sol/Earth/Discovery STS-116",
		"Sol/Earth/Discovery STS-119",
		"Sol/Earth/Discovery STS-120",
		"Sol/Earth/Discovery STS-121",
		"Sol/Earth/Discovery STS-124",
		"Sol/Earth/Discovery STS-128",
		"Sol/Earth/Discovery STS-131",
		"Sol/Earth/Discovery STS-133",
		-- Shuttles Endeavour
		"Sol/Earth/Endeavour STS-47",
		"Sol/Earth/Endeavour STS-49",
		"Sol/Earth/Endeavour STS-54",
		"Sol/Earth/Endeavour STS-57",
		"Sol/Earth/Endeavour STS-59",
		"Sol/Earth/Endeavour STS-61",
		"Sol/Earth/Endeavour STS-67",
		"Sol/Earth/Endeavour STS-68",
		"Sol/Earth/Endeavour STS-69",
		"Sol/Earth/Endeavour STS-72",
		"Sol/Earth/Endeavour STS-77",
		"Sol/Earth/Endeavour STS-88",
		"Sol/Earth/Endeavour STS-89",
		"Sol/Earth/Endeavour STS-97",
		"Sol/Earth/Endeavour STS-99",
		"Sol/Earth/Endeavour STS-100",
		"Sol/Earth/Endeavour STS-108",
		"Sol/Earth/Endeavour STS-111",
		"Sol/Earth/Endeavour STS-113",
		"Sol/Earth/Endeavour STS-118",
		"Sol/Earth/Endeavour STS-123",
		"Sol/Earth/Endeavour STS-126",
		"Sol/Earth/Endeavour STS-127",
		"Sol/Earth/Endeavour STS-130",
		"Sol/Earth/Endeavour STS-134",
		-- Shuttles Enterprise
		-- Soyuz
		"Sol/Earth/Soyuz-4-1",
			"Sol/Earth/Soyuz-4-1/Ecoutille-S4-1",
		"Sol/Earth/Soyuz-4-2",
			"Sol/Earth/Soyuz-4-2/Ecoutille-S4-2",
		"Sol/Earth/Soyuz-4-amarrage",
			"Sol/Earth/Soyuz-4-amarrage/Ecoutille-S4-amarrage",
			"Sol/Earth/Soyuz-4-amarre",
			"Sol/Earth/Soyuz-4-amarre/Ecoutille-S4-amarre",
			"Sol/Earth/Soyuz-4-amarre/Ecoutille-S4-fermeture",
			"Sol/Earth/Soyuz-4-amarre/Ecoutille-S4-ouverte",
			"Sol/Earth/Soyuz-4-amarre/Ecoutille-S4-ouverture",
			"Sol/Earth/Soyuz-4-amarre/Elliseiv-ecoutille",
			"Sol/Earth/Soyuz-4-amarre/Elliseiv-sortie",
			"Sol/Earth/Soyuz-4-amarre/Khrounov-ecoutille",
			"Sol/Earth/Soyuz-4-amarre/Khrounov-sortie",
			"Sol/Earth/Soyuz-4-approche",
			"Sol/Earth/Soyuz-4-approche/Ecoutille-S4-approche",
			"Sol/Earth/Soyuz-4-circ",
			"Sol/Earth/Soyuz-4-circ/Ecoutille-S4-circ",
			"Sol/Earth/Soyuz-4-desamarrage",
			"Sol/Earth/Soyuz-4-desamarrage/Ecoutille-S4-desamarrage",
			"Sol/Earth/Soyuz-4-eloignement",
			"Sol/Earth/Soyuz-4-eloignement/Ecoutille-S4-eloignement",
			"Sol/Earth/Soyuz-4-eloignement/flamme-Soyuz-4-eloignement",
			"Sol/Earth/Soyuz-4-postamarrage",
			"Sol/Earth/Soyuz-4-postamarrage/Ecoutille-S4-postamarrage",
			"Sol/Earth/Soyuz-4-rotation",
			"Sol/Earth/Soyuz-4-rotation/Ecoutille-S4-rotation",
			"Sol/Earth/Soyuz-4-rotation2",
			"Sol/Earth/Soyuz-4-rotation2/Ecoutille-S4-rotation",
		"Sol/Earth/Soyuz 4",
			"Sol/Earth/Soyuz 4/Khrounov",
			"Sol/Earth/Soyuz 4/Soyuz 4 Hatch",
		"Sol/Earth/Soyuz 5",
			"Sol/Earth/Soyuz 5/Soyuz 5 Hatch",
			"Sol/Earth/Soyuz 5/Yeliseyev",
		"Sol/Earth/Soyuz-5-1",
			"Sol/Earth/Soyuz-5-1/Ecoutille-S5-1",
		"Sol/Earth/Soyuz-5-2",
			"Sol/Earth/Soyuz-5-2/Ecoutille-S5-2",
		"Sol/Earth/Soyuz-5-circ",
			"Sol/Earth/Soyuz-5-circ/Ecoutille-S5",
			"Sol/Earth/Soyuz-5-circ/Ecoutille-S5-circ",
			"Sol/Earth/Soyuz-5-circ/Ecoutille-S5-fermee",
			"Sol/Earth/Soyuz-5-circ/Ecoutille-S5-ouverture",
			"Sol/Earth/Soyuz-5-circ/Ecoutille-S5F",
			"Sol/Earth/Soyuz-5-circ/Elliseiv-2-sortie",
			"Sol/Earth/Soyuz-5-circ/Elliseiv-ecoutille",
			"Sol/Earth/Soyuz-5-circ/Khrounov-ecoutille",
			"Sol/Earth/Soyuz-5-circ/Khrounov-sortie",
		"Sol/Earth/Moon/Soyuz 7K-LOK",
			"Sol/Earth/Moon/Soyuz 7K-LOK/7K-LOK Hatch",
		"Sol/Earth/Soyuz 7K-TM",
			"Sol/Earth/Soyuz 7K-TM 25",
		"Sol/Earth/Moon/LK",
		"Sol/Earth/Moon/LK/LK Prop",
		"Sol/Earth/Moon/LK/LK Hatch",
		"Sol/Earth/Moon/LK/LK Ladder",
		"Sol/Earth/Moon/Cosmonaut",
		"Sol/Earth/Moon/Equipment",
		"Sol/Earth/Moon/Flag ",
		"Sol/Earth/Soyuz-11",
			"Sol/Earth/Soyuz-11-chg",
			"Sol/Earth/Soyuz11-amarrage",
			"Sol/Earth/Soyuz11-approche",
			"Sol/Earth/Soyuz11-amarre",
			"Sol/Earth/Soyuz11-désamarrage",
			"Sol/Earth/Soyuz11-désamarré",
		"Sol/Earth/Apollo18-Soyuz19",
		"Sol/Earth/Soyuz-26",
		"Sol/Earth/Soyuz-26-approche",
		"Sol/Earth/Soyuz-27",
		"Sol/Earth/Soyuz27-Salyut6-Soyuz26",
		"Sol/Earth/Soyuz TMA 2",
		-- Salyut
		"Sol/Earth/Salyut 1",
		"Sol/Earth/Salyut 2",
		"Sol/Earth/Salyut 3",
		"Sol/Earth/Salyut 4",
		"Sol/Earth/Salyut 5",
		"Sol/Earth/Salyut 6",
		"Sol/Earth/Salyut 7",
		"Sol/Earth/Almaz-T2",
		"Sol/Earth/Almaz-1",
		
		-- Spoutnik
		"Sol/Earth/Spoutnik-1",
		"Sol/Earth/Spoutnik-2",
			"Sol/Earth/Spoutnik-2/Laika",
			"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Panneau-1",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Panneau-2",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Panneau-1-rot",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Panneau-2-rot",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Flamme-sp2",
				"Sol/Earth/Spoutnik-2/Spoutnik-2-Etage/Cone-sp2",
			"Sol/Earth/Spoutnik-2/Cone-ecart",
				"Sol/Earth/Spoutnik-2/Cone-ecart/flamme-cone-1",
				"Sol/Earth/Spoutnik-2/Cone-ecart/flamme-cone-2",
				"Sol/Earth/Spoutnik-2/Cone-ecart/flamme-cone-3",
				"Sol/Earth/Spoutnik-2/Cone-ecart/flamme-cone-4",
		"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/flamme-1",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/flamme-2",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/flamme-3",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/flamme-4",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/Panneau1-rot",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/Panneau2-rot",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/Panneau1-o",
			"Sol/Earth/Spoutnik-2/Sp2-Etage-ecart/Panneau2-o",
		"Sol/Earth/Spoutnik-3",
		-- Sirius
		"Sol/Earth/Sirius 1",
		"Sol/Earth/Sirius 2",
		"Sol/Earth/Sirius 3",
		"Sol/Earth/Sirius 4",
		"Sol/Earth/Sirius 5",
		-- Superbird
		"Sol/Earth/Superbird-A",
		"Sol/Earth/Superbird-B1",
		"Sol/Earth/Superbird-A1",
		"Sol/Earth/Superbird-C",
		"Sol/Earth/Superbird-B2",
		"Sol/Earth/Superbird-D",
		"Sol/Earth/Superbird-A2",
		"Sol/Earth/Superbird-C2",
		"Sol/Earth/Superbird-B3",
		-- Surveyor
		"Sol/Earth/Moon/Surveyor 1",
		"Sol/Earth/Moon/Surveyor 3",
		"Sol/Earth/Moon/Surveyor 5",
		"Sol/Earth/Moon/Surveyor 6",
		"Sol/Earth/Moon/Surveyor 7",
		-- Spacebee
		"Sol/Earth/SPACEBEE NZ-1", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE NZ-2", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE NZ-3", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE NZ-4", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE NZ-5", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE NZ-6", -- New Zealand cubsat 0.25U
		"Sol/Earth/SPACEBEE-1", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-2", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-3", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-4", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-5", -- cubsat 1U
		"Sol/Earth/SPACEBEE-6", -- cubsat 1U
		"Sol/Earth/SPACEBEE-7", -- cubsat 1U
		"Sol/Earth/SPACEBEE-8", -- cubsat 1U
		"Sol/Earth/SPACEBEE-9", -- cubsat 1U
		"Sol/Earth/SPACEBEE-10", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-11", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-12", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-13", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-14", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-15", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-16", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-17", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-18", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-19", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-20", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-21", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-22", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-23", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-24", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-25", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-26", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-27", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-28", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-29", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-30", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-31", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-32", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-33", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-34", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-35", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-36", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-37", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-38", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-39", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-40", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-41", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-42", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-43", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-44", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-45", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-46", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-47", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-48", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-49", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-50", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-51", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-52", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-53", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-54", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-55", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-56", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-57", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-58", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-59", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-60", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-61", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-62", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-63", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-76", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-77", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-78", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-79", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-80", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-81", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-82", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-83", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-84", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-85", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-86", -- cubsat 0.25U
		"Sol/Earth/SPACEBEE-87", -- cubsat 0.25U
		-- Starlink
		"Sol/Earth/TINTIN A",
		"Sol/Earth/TINTIN B",
		"Sol/Earth/STARLINK-21",
		"Sol/Earth/STARLINK-22",
		"Sol/Earth/STARLINK-23",
		"Sol/Earth/STARLINK-24",
		"Sol/Earth/STARLINK-25",
		"Sol/Earth/STARLINK-26",
		"Sol/Earth/STARLINK-27",
		"Sol/Earth/STARLINK-28",
		"Sol/Earth/STARLINK-29",
		"Sol/Earth/STARLINK-30",
		"Sol/Earth/STARLINK-31",
		"Sol/Earth/STARLINK-32",
		"Sol/Earth/STARLINK-33",
		"Sol/Earth/STARLINK-34",
		"Sol/Earth/STARLINK-35",
		"Sol/Earth/STARLINK-36",
		"Sol/Earth/STARLINK-37",
		"Sol/Earth/STARLINK-38",
		"Sol/Earth/STARLINK-39",
		"Sol/Earth/STARLINK-40",
		"Sol/Earth/STARLINK-41",
		"Sol/Earth/STARLINK-42",
		"Sol/Earth/STARLINK-43",
		"Sol/Earth/STARLINK-44",
		"Sol/Earth/STARLINK-45",
		"Sol/Earth/STARLINK-48",
		"Sol/Earth/STARLINK-49",
		"Sol/Earth/STARLINK-50",
		"Sol/Earth/STARLINK-51",
		"Sol/Earth/STARLINK-52",
		"Sol/Earth/STARLINK-53",
		"Sol/Earth/STARLINK-54",
		"Sol/Earth/STARLINK-55",
		"Sol/Earth/STARLINK-56",
		"Sol/Earth/STARLINK-57",
		"Sol/Earth/STARLINK-58",
		"Sol/Earth/STARLINK-59",
		"Sol/Earth/STARLINK-60",
		"Sol/Earth/STARLINK-61",
		"Sol/Earth/STARLINK-62",
		"Sol/Earth/STARLINK-63",
		"Sol/Earth/STARLINK-64",
		"Sol/Earth/STARLINK-65",
		"Sol/Earth/STARLINK-66",
		"Sol/Earth/STARLINK-67",
		"Sol/Earth/STARLINK-68",
		"Sol/Earth/STARLINK-69",
		"Sol/Earth/STARLINK-70",
		"Sol/Earth/STARLINK-71",
		"Sol/Earth/STARLINK-72",
		"Sol/Earth/STARLINK-73",
		"Sol/Earth/STARLINK-74",
		"Sol/Earth/STARLINK-75",
		"Sol/Earth/STARLINK-76",
		"Sol/Earth/STARLINK-77",
		"Sol/Earth/STARLINK-78",
		"Sol/Earth/STARLINK-79",
		"Sol/Earth/STARLINK-80",
		"Sol/Earth/STARLINK-81",
		
		"Sol/Earth/STARLINK-1007",
		"Sol/Earth/STARLINK-1008",
		"Sol/Earth/STARLINK-1009",
		"Sol/Earth/STARLINK-1010",
		"Sol/Earth/STARLINK-1011",
		"Sol/Earth/STARLINK-1012",
		"Sol/Earth/STARLINK-1013",
		"Sol/Earth/STARLINK-1014",
		"Sol/Earth/STARLINK-1015",
		"Sol/Earth/STARLINK-1016",
		"Sol/Earth/STARLINK-1017",
		"Sol/Earth/STARLINK-1019",
		"Sol/Earth/STARLINK-1020",
		"Sol/Earth/STARLINK-1021",
		"Sol/Earth/STARLINK-1022",
		"Sol/Earth/STARLINK-1023",
		"Sol/Earth/STARLINK-1024",
		"Sol/Earth/STARLINK-1025",
		"Sol/Earth/STARLINK-1026",
		"Sol/Earth/STARLINK-1027",
		"Sol/Earth/STARLINK-1028",
		"Sol/Earth/STARLINK-1029",
		"Sol/Earth/STARLINK-1030",
		"Sol/Earth/STARLINK-1031",
		"Sol/Earth/STARLINK-1032",
		"Sol/Earth/STARLINK-1033",
		"Sol/Earth/STARLINK-1034",
		"Sol/Earth/STARLINK-1035",
		"Sol/Earth/STARLINK-1036",
		"Sol/Earth/STARLINK-1037",
		"Sol/Earth/STARLINK-1038",
		"Sol/Earth/STARLINK-1039",
		"Sol/Earth/STARLINK-1040",
		"Sol/Earth/STARLINK-1041",
		"Sol/Earth/STARLINK-1042",
		"Sol/Earth/STARLINK-1043",
		"Sol/Earth/STARLINK-1044",
		"Sol/Earth/STARLINK-1045",
		"Sol/Earth/STARLINK-1046",
		"Sol/Earth/STARLINK-1047",
		"Sol/Earth/STARLINK-1048",
		"Sol/Earth/STARLINK-1049",
		"Sol/Earth/STARLINK-1050",
		"Sol/Earth/STARLINK-1051",
		"Sol/Earth/STARLINK-1052",
		"Sol/Earth/STARLINK-1053",
		"Sol/Earth/STARLINK-1054",
		"Sol/Earth/STARLINK-1055",
		"Sol/Earth/STARLINK-1056",
		"Sol/Earth/STARLINK-1057",
		"Sol/Earth/STARLINK-1058",
		"Sol/Earth/STARLINK-1059",
		"Sol/Earth/STARLINK-1060",
		"Sol/Earth/STARLINK-1061",
		"Sol/Earth/STARLINK-1062",
		"Sol/Earth/STARLINK-1063",
		"Sol/Earth/STARLINK-1064",
		"Sol/Earth/STARLINK-1065",
		"Sol/Earth/STARLINK-1066",
		"Sol/Earth/STARLINK-1067",
		"Sol/Earth/STARLINK-1068",
		"Sol/Earth/STARLINK-1069",
		"Sol/Earth/STARLINK-1070",
		"Sol/Earth/STARLINK-1071",
		"Sol/Earth/STARLINK-1072",
		"Sol/Earth/STARLINK-1073",
		"Sol/Earth/STARLINK-1074",
		"Sol/Earth/STARLINK-1075",
		"Sol/Earth/STARLINK-1076",
		"Sol/Earth/STARLINK-1077",
		"Sol/Earth/STARLINK-1078",
		"Sol/Earth/STARLINK-1079",
		"Sol/Earth/STARLINK-1080",
		"Sol/Earth/STARLINK-1081",
		"Sol/Earth/STARLINK-1082",
		"Sol/Earth/STARLINK-1083",
		"Sol/Earth/STARLINK-1084",
		"Sol/Earth/STARLINK-1085",
		"Sol/Earth/STARLINK-1086",
		"Sol/Earth/STARLINK-1087", -- decay 29-05-2020
		"Sol/Earth/STARLINK-1088",
		"Sol/Earth/STARLINK-1089",
		"Sol/Earth/STARLINK-1090",
		"Sol/Earth/STARLINK-1091",
		"Sol/Earth/STARLINK-1092",
		"Sol/Earth/STARLINK-1093",
		"Sol/Earth/STARLINK-1094",
		"Sol/Earth/STARLINK-1095",
		"Sol/Earth/STARLINK-1096",
		"Sol/Earth/STARLINK-1097",
		"Sol/Earth/STARLINK-1098",
		"Sol/Earth/STARLINK-1099",
		"Sol/Earth/STARLINK-1100",
		"Sol/Earth/STARLINK-1101",
		"Sol/Earth/STARLINK-1102",
		"Sol/Earth/STARLINK-1103",
		"Sol/Earth/STARLINK-1104",
		"Sol/Earth/STARLINK-1105",
		"Sol/Earth/STARLINK-1106",
		"Sol/Earth/STARLINK-1107",
		"Sol/Earth/STARLINK-1108",
		"Sol/Earth/STARLINK-1109",
		"Sol/Earth/STARLINK-1110",
		"Sol/Earth/STARLINK-1111",
		"Sol/Earth/STARLINK-1112",
		"Sol/Earth/STARLINK-1113",
		"Sol/Earth/STARLINK-1114",
		"Sol/Earth/STARLINK-1115",
		"Sol/Earth/STARLINK-1116",
		"Sol/Earth/STARLINK-1117",
		"Sol/Earth/STARLINK-1119",
		"Sol/Earth/STARLINK-1120",
		"Sol/Earth/STARLINK-1121",
		"Sol/Earth/STARLINK-1122",
		"Sol/Earth/STARLINK-1123",
		"Sol/Earth/STARLINK-1124",
		"Sol/Earth/STARLINK-1125",
		"Sol/Earth/STARLINK-1126",
		"Sol/Earth/STARLINK-1127",
		"Sol/Earth/STARLINK-1128",
		"Sol/Earth/STARLINK-1129",
		"Sol/Earth/STARLINK-1130 Darksat",
		"Sol/Earth/STARLINK-1131",
		"Sol/Earth/STARLINK-1132",
		"Sol/Earth/STARLINK-1133",
		"Sol/Earth/STARLINK-1134",
		"Sol/Earth/STARLINK-1135",
		"Sol/Earth/STARLINK-1136",
		"Sol/Earth/STARLINK-1137",
		"Sol/Earth/STARLINK-1138",
		"Sol/Earth/STARLINK-1139",
		"Sol/Earth/STARLINK-1140",
		"Sol/Earth/STARLINK-1141",
		"Sol/Earth/STARLINK-1142",
		"Sol/Earth/STARLINK-1143",
		"Sol/Earth/STARLINK-1144",
		"Sol/Earth/STARLINK-1144",
		"Sol/Earth/STARLINK-1144",
		"Sol/Earth/STARLINK-1145",
		"Sol/Earth/STARLINK-1146",
		"Sol/Earth/STARLINK-1147",
		"Sol/Earth/STARLINK-1148",
		"Sol/Earth/STARLINK-1149",
		"Sol/Earth/STARLINK-1150",
		"Sol/Earth/STARLINK-1151",
		"Sol/Earth/STARLINK-1152",
		"Sol/Earth/STARLINK-1153",
		"Sol/Earth/STARLINK-1154",
		"Sol/Earth/STARLINK-1155",
		"Sol/Earth/STARLINK-1156",
		"Sol/Earth/STARLINK-1157",
		"Sol/Earth/STARLINK-1158",
		"Sol/Earth/STARLINK-1159",
		"Sol/Earth/STARLINK-1160",
		"Sol/Earth/STARLINK-1161",
		"Sol/Earth/STARLINK-1162",
		"Sol/Earth/STARLINK-1163",
		"Sol/Earth/STARLINK-1164",
		"Sol/Earth/STARLINK-1165",
		"Sol/Earth/STARLINK-1166",
		"Sol/Earth/STARLINK-1167",
		"Sol/Earth/STARLINK-1168",
		"Sol/Earth/STARLINK-1169",
		"Sol/Earth/STARLINK-1170",
		"Sol/Earth/STARLINK-1171",
		"Sol/Earth/STARLINK-1172",
		"Sol/Earth/STARLINK-1173",
		"Sol/Earth/STARLINK-1174",
		"Sol/Earth/STARLINK-1175",
		"Sol/Earth/STARLINK-1176",
		"Sol/Earth/STARLINK-1177",
		"Sol/Earth/STARLINK-1178",
		"Sol/Earth/STARLINK-1179",
		"Sol/Earth/STARLINK-1180",
		"Sol/Earth/STARLINK-1181",
		"Sol/Earth/STARLINK-1182",
		"Sol/Earth/STARLINK-1183",
		"Sol/Earth/STARLINK-1184",
		"Sol/Earth/STARLINK-1185",
		"Sol/Earth/STARLINK-1186",
		"Sol/Earth/STARLINK-1187",
		"Sol/Earth/STARLINK-1188",
		"Sol/Earth/STARLINK-1189",
		"Sol/Earth/STARLINK-1190",
		"Sol/Earth/STARLINK-1191",
		"Sol/Earth/STARLINK-1192",
		"Sol/Earth/STARLINK-1193",
		"Sol/Earth/STARLINK-1194",
		"Sol/Earth/STARLINK-1195",
		"Sol/Earth/STARLINK-1196",
		"Sol/Earth/STARLINK-1197",
		"Sol/Earth/STARLINK-1198",
		"Sol/Earth/STARLINK-1199",
		"Sol/Earth/STARLINK-1200",
		"Sol/Earth/STARLINK-1201",
		"Sol/Earth/STARLINK-1202",
		"Sol/Earth/STARLINK-1203",
		"Sol/Earth/STARLINK-1204",
		"Sol/Earth/STARLINK-1205",
		"Sol/Earth/STARLINK-1206",
		"Sol/Earth/STARLINK-1207",
		"Sol/Earth/STARLINK-1208",
		"Sol/Earth/STARLINK-1209",
		"Sol/Earth/STARLINK-1210",
		"Sol/Earth/STARLINK-1211",
		"Sol/Earth/STARLINK-1212",
		"Sol/Earth/STARLINK-1213",
		"Sol/Earth/STARLINK-1214",
		"Sol/Earth/STARLINK-1215",
		"Sol/Earth/STARLINK-1216",
		"Sol/Earth/STARLINK-1217",
		"Sol/Earth/STARLINK-1218",
		"Sol/Earth/STARLINK-1219",
		"Sol/Earth/STARLINK-1221",
		"Sol/Earth/STARLINK-1222",
		"Sol/Earth/STARLINK-1224",
		"Sol/Earth/STARLINK-1225",
		"Sol/Earth/STARLINK-1226",
		"Sol/Earth/STARLINK-1227",
		"Sol/Earth/STARLINK-1228",
		"Sol/Earth/STARLINK-1229",
		"Sol/Earth/STARLINK-1230",
		"Sol/Earth/STARLINK-1231",
		"Sol/Earth/STARLINK-1232",
		"Sol/Earth/STARLINK-1233",
		"Sol/Earth/STARLINK-1234",
		"Sol/Earth/STARLINK-1235",
		"Sol/Earth/STARLINK-1236",
		"Sol/Earth/STARLINK-1237",
		"Sol/Earth/STARLINK-1238",
		"Sol/Earth/STARLINK-1239",
		"Sol/Earth/STARLINK-1240",
		"Sol/Earth/STARLINK-1241",
		"Sol/Earth/STARLINK-1243",
		"Sol/Earth/STARLINK-1244",
		"Sol/Earth/STARLINK-1245",
		"Sol/Earth/STARLINK-1246",
		"Sol/Earth/STARLINK-1247",
		"Sol/Earth/STARLINK-1254",
		"Sol/Earth/STARLINK-1255",
		"Sol/Earth/STARLINK-1256",
		"Sol/Earth/STARLINK-1257",
		"Sol/Earth/STARLINK-1258",
		"Sol/Earth/STARLINK-1259",
		"Sol/Earth/STARLINK-1260",
		"Sol/Earth/STARLINK-1261",
		"Sol/Earth/STARLINK-1262",
		"Sol/Earth/STARLINK-1263",
		"Sol/Earth/STARLINK-1264",
		"Sol/Earth/STARLINK-1265",
		"Sol/Earth/STARLINK-1266",
		"Sol/Earth/STARLINK-1267",
		"Sol/Earth/STARLINK-1268",
		"Sol/Earth/STARLINK-1269",
		"Sol/Earth/STARLINK-1270",
		"Sol/Earth/STARLINK-1271",
		"Sol/Earth/STARLINK-1272",
		"Sol/Earth/STARLINK-1273",
		"Sol/Earth/STARLINK-1274",
		"Sol/Earth/STARLINK-1275",
		"Sol/Earth/STARLINK-1276",
		"Sol/Earth/STARLINK-1277",
		"Sol/Earth/STARLINK-1278",
		"Sol/Earth/STARLINK-1279",
		"Sol/Earth/STARLINK-1280",
		"Sol/Earth/STARLINK-1281",
		"Sol/Earth/STARLINK-1282",
		"Sol/Earth/STARLINK-1283",
		"Sol/Earth/STARLINK-1284",
		"Sol/Earth/STARLINK-1285",
		"Sol/Earth/STARLINK-1286",
		"Sol/Earth/STARLINK-1287",
		"Sol/Earth/STARLINK-1288",
		"Sol/Earth/STARLINK-1289",
		"Sol/Earth/STARLINK-1290",
		"Sol/Earth/STARLINK-1291",
		"Sol/Earth/STARLINK-1292",
		"Sol/Earth/STARLINK-1293",
		"Sol/Earth/STARLINK-1294",
		"Sol/Earth/STARLINK-1295",
		"Sol/Earth/STARLINK-1296",
		"Sol/Earth/STARLINK-1297",
		"Sol/Earth/STARLINK-1298",
		"Sol/Earth/STARLINK-1299",
		"Sol/Earth/STARLINK-1300",
		"Sol/Earth/STARLINK-1301",
		"Sol/Earth/STARLINK-1302",
		"Sol/Earth/STARLINK-1303",
		"Sol/Earth/STARLINK-1304",
		"Sol/Earth/STARLINK-1305",
		"Sol/Earth/STARLINK-1306",
		"Sol/Earth/STARLINK-1307",
		"Sol/Earth/STARLINK-1308",
		"Sol/Earth/STARLINK-1309",
		"Sol/Earth/STARLINK-1310",
		"Sol/Earth/STARLINK-1311",
		"Sol/Earth/STARLINK-1312",
		"Sol/Earth/STARLINK-1313",
		"Sol/Earth/STARLINK-1316",
		"Sol/Earth/STARLINK-1317",
		"Sol/Earth/STARLINK-1318",
		"Sol/Earth/STARLINK-1319",
		"Sol/Earth/STARLINK-1320",
		"Sol/Earth/STARLINK-1321",
		"Sol/Earth/STARLINK-1322",
		"Sol/Earth/STARLINK-1323",
		"Sol/Earth/STARLINK-1324",
		"Sol/Earth/STARLINK-1325",
		"Sol/Earth/STARLINK-1326",
		"Sol/Earth/STARLINK-1327",
		"Sol/Earth/STARLINK-1328",
		"Sol/Earth/STARLINK-1329",
		"Sol/Earth/STARLINK-1330",
		"Sol/Earth/STARLINK-1331",
		"Sol/Earth/STARLINK-1332",
		"Sol/Earth/STARLINK-1333",
		"Sol/Earth/STARLINK-1334",
		"Sol/Earth/STARLINK-1335",
		"Sol/Earth/STARLINK-1336",
		"Sol/Earth/STARLINK-1337",
		"Sol/Earth/STARLINK-1338",
		"Sol/Earth/STARLINK-1339",
		"Sol/Earth/STARLINK-1340",
		"Sol/Earth/STARLINK-1341",
		"Sol/Earth/STARLINK-1342",
		"Sol/Earth/STARLINK-1343",
		"Sol/Earth/STARLINK-1344",
		"Sol/Earth/STARLINK-1345",
		"Sol/Earth/STARLINK-1346",
		"Sol/Earth/STARLINK-1347",
		"Sol/Earth/STARLINK-1348",
		"Sol/Earth/STARLINK-1349",
		"Sol/Earth/STARLINK-1350",
		"Sol/Earth/STARLINK-1351",
		"Sol/Earth/STARLINK-1352",
		"Sol/Earth/STARLINK-1353",
		"Sol/Earth/STARLINK-1354",
		"Sol/Earth/STARLINK-1355",
		"Sol/Earth/STARLINK-1356",
		"Sol/Earth/STARLINK-1357",
		"Sol/Earth/STARLINK-1358",
		"Sol/Earth/STARLINK-1360",
		"Sol/Earth/STARLINK-1361",
		"Sol/Earth/STARLINK-1362",
		"Sol/Earth/STARLINK-1363",
		"Sol/Earth/STARLINK-1364",
		"Sol/Earth/STARLINK-1365",
		"Sol/Earth/STARLINK-1366",
		"Sol/Earth/STARLINK-1367",
		"Sol/Earth/STARLINK-1368",
		"Sol/Earth/STARLINK-1369",
		"Sol/Earth/STARLINK-1370",
		"Sol/Earth/STARLINK-1371",
		"Sol/Earth/STARLINK-1372",
		"Sol/Earth/STARLINK-1373",
		"Sol/Earth/STARLINK-1374",
		"Sol/Earth/STARLINK-1375",
		"Sol/Earth/STARLINK-1376",
		"Sol/Earth/STARLINK-1377",
		"Sol/Earth/STARLINK-1378",
		"Sol/Earth/STARLINK-1379",
		"Sol/Earth/STARLINK-1390",
		"Sol/Earth/STARLINK-1391",
		"Sol/Earth/STARLINK-1392",
		"Sol/Earth/STARLINK-1393",
		"Sol/Earth/STARLINK-1394",
		"Sol/Earth/STARLINK-1395",
		"Sol/Earth/STARLINK-1396",
		"Sol/Earth/STARLINK-1397",
		"Sol/Earth/STARLINK-1398",
		"Sol/Earth/STARLINK-1399",
		"Sol/Earth/STARLINK-1400",
		"Sol/Earth/STARLINK-1401",
		"Sol/Earth/STARLINK-1402",
		"Sol/Earth/STARLINK-1403",
		"Sol/Earth/STARLINK-1404",
		"Sol/Earth/STARLINK-1405",
		"Sol/Earth/STARLINK-1406",
		"Sol/Earth/STARLINK-1407",
		"Sol/Earth/STARLINK-1408",
		"Sol/Earth/STARLINK-1409",
		"Sol/Earth/STARLINK-1410",
		"Sol/Earth/STARLINK-1411",
		"Sol/Earth/STARLINK-1412",
		"Sol/Earth/STARLINK-1413",
		"Sol/Earth/STARLINK-1414",
		"Sol/Earth/STARLINK-1415",
		"Sol/Earth/STARLINK-1416",
		"Sol/Earth/STARLINK-1417",
		"Sol/Earth/STARLINK-1418",
		"Sol/Earth/STARLINK-1419",
		"Sol/Earth/STARLINK-1420",
		"Sol/Earth/STARLINK-1421",
		"Sol/Earth/STARLINK-1422",
		"Sol/Earth/STARLINK-1423",
		"Sol/Earth/STARLINK-1433",
		"Sol/Earth/STARLINK-1434",
		"Sol/Earth/STARLINK-1436",
		"Sol/Earth/STARLINK-1437",
		"Sol/Earth/STARLINK-1438",
		"Sol/Earth/STARLINK-1439",
		"Sol/Earth/STARLINK-1440",
		"Sol/Earth/STARLINK-1441",
		"Sol/Earth/STARLINK-1442",
		"Sol/Earth/STARLINK-1443",
		"Sol/Earth/STARLINK-1444",
		"Sol/Earth/STARLINK-1445",
		"Sol/Earth/STARLINK-1446",
		"Sol/Earth/STARLINK-1447",
		"Sol/Earth/STARLINK-1448",
		"Sol/Earth/STARLINK-1449",
		"Sol/Earth/STARLINK-1450",
		"Sol/Earth/STARLINK-1451",
		"Sol/Earth/STARLINK-1452",
		"Sol/Earth/STARLINK-1453",
		"Sol/Earth/STARLINK-1454",
		"Sol/Earth/STARLINK-1455",
		"Sol/Earth/STARLINK-1456",
		"Sol/Earth/STARLINK-1457",
		"Sol/Earth/STARLINK-1458",
		"Sol/Earth/STARLINK-1459",
		"Sol/Earth/STARLINK-1460",
		"Sol/Earth/STARLINK-1461",
		"Sol/Earth/STARLINK-1462",
		"Sol/Earth/STARLINK-1463",
		"Sol/Earth/STARLINK-1464",
		"Sol/Earth/STARLINK-1465",
		"Sol/Earth/STARLINK-1466",
		"Sol/Earth/STARLINK-1467",
		"Sol/Earth/STARLINK-1468",
		"Sol/Earth/STARLINK-1469",
		"Sol/Earth/STARLINK-1470",
		"Sol/Earth/STARLINK-1471",
		"Sol/Earth/STARLINK-1472",
		"Sol/Earth/STARLINK-1473",
		"Sol/Earth/STARLINK-1474",
		"Sol/Earth/STARLINK-1475",
		"Sol/Earth/STARLINK-1476",
		"Sol/Earth/STARLINK-1477",
		"Sol/Earth/STARLINK-1478",
		"Sol/Earth/STARLINK-1479",
		"Sol/Earth/STARLINK-1480",
		"Sol/Earth/STARLINK-1481",
		"Sol/Earth/STARLINK-1482",
		"Sol/Earth/STARLINK-1483",
		"Sol/Earth/STARLINK-1484",
		"Sol/Earth/STARLINK-1486",
		"Sol/Earth/STARLINK-1487",
		"Sol/Earth/STARLINK-1488",
		"Sol/Earth/STARLINK-1489",
		"Sol/Earth/STARLINK-1490",
		"Sol/Earth/STARLINK-1491",
		"Sol/Earth/STARLINK-1492",
		"Sol/Earth/STARLINK-1493",
		"Sol/Earth/STARLINK-1494",
		"Sol/Earth/STARLINK-1495",
		"Sol/Earth/STARLINK-1496",
		"Sol/Earth/STARLINK-1497",
		"Sol/Earth/STARLINK-1498",
		"Sol/Earth/STARLINK-1499",
		"Sol/Earth/STARLINK-1500",
		"Sol/Earth/STARLINK-1501",
		"Sol/Earth/STARLINK-1502",
		"Sol/Earth/STARLINK-1503",
		"Sol/Earth/STARLINK-1504",
		"Sol/Earth/STARLINK-1505",
		"Sol/Earth/STARLINK-1506",
		"Sol/Earth/STARLINK-1507",
		"Sol/Earth/STARLINK-1508",
		"Sol/Earth/STARLINK-1509",
		"Sol/Earth/STARLINK-1510",
		"Sol/Earth/STARLINK-1511",
		"Sol/Earth/STARLINK-1512",
		"Sol/Earth/STARLINK-1513",
		"Sol/Earth/STARLINK-1514",
		"Sol/Earth/STARLINK-1515",
		"Sol/Earth/STARLINK-1516",
		"Sol/Earth/STARLINK-1517",
		"Sol/Earth/STARLINK-1521",
		"Sol/Earth/STARLINK-1522",
		"Sol/Earth/STARLINK-1523",
		"Sol/Earth/STARLINK-1524",
		"Sol/Earth/STARLINK-1525",
		"Sol/Earth/STARLINK-1526",
		"Sol/Earth/STARLINK-1527",
		"Sol/Earth/STARLINK-1528",
		"Sol/Earth/STARLINK-1529",
		"Sol/Earth/STARLINK-1530",
		"Sol/Earth/STARLINK-1531",
		"Sol/Earth/STARLINK-1532",
		"Sol/Earth/STARLINK-1533",
		"Sol/Earth/STARLINK-1534",
		"Sol/Earth/STARLINK-1536",
		"Sol/Earth/STARLINK-1538",
		"Sol/Earth/STARLINK-1539",
		"Sol/Earth/STARLINK-1540",
		"Sol/Earth/STARLINK-1541",
		"Sol/Earth/STARLINK-1542",
		"Sol/Earth/STARLINK-1543",
		"Sol/Earth/STARLINK-1544",
		"Sol/Earth/STARLINK-1545",
		"Sol/Earth/STARLINK-1546",
		"Sol/Earth/STARLINK-1547",
		"Sol/Earth/STARLINK-1548",
		"Sol/Earth/STARLINK-1549",
		"Sol/Earth/STARLINK-1550",
		"Sol/Earth/STARLINK-1551",
		"Sol/Earth/STARLINK-1552",
		"Sol/Earth/STARLINK-1553",
		"Sol/Earth/STARLINK-1554",
		"Sol/Earth/STARLINK-1555",
		"Sol/Earth/STARLINK-1556",
		"Sol/Earth/STARLINK-1557",
		"Sol/Earth/STARLINK-1558",
		"Sol/Earth/STARLINK-1559",
		"Sol/Earth/STARLINK-1560",
		"Sol/Earth/STARLINK-1561",
		"Sol/Earth/STARLINK-1562",
		"Sol/Earth/STARLINK-1563",
		"Sol/Earth/STARLINK-1564",
		"Sol/Earth/STARLINK-1565",
		"Sol/Earth/STARLINK-1566",
		"Sol/Earth/STARLINK-1567",
		"Sol/Earth/STARLINK-1568",
		"Sol/Earth/STARLINK-1569",
		"Sol/Earth/STARLINK-1570",
		"Sol/Earth/STARLINK-1571",
		"Sol/Earth/STARLINK-1572",
		"Sol/Earth/STARLINK-1573",
		"Sol/Earth/STARLINK-1574",
		"Sol/Earth/STARLINK-1575",
		"Sol/Earth/STARLINK-1576",
		"Sol/Earth/STARLINK-1577",
		"Sol/Earth/STARLINK-1578",
		"Sol/Earth/STARLINK-1579",
		"Sol/Earth/STARLINK-1580",
		"Sol/Earth/STARLINK-1581",
		"Sol/Earth/STARLINK-1582",
		"Sol/Earth/STARLINK-1583",
		"Sol/Earth/STARLINK-1584",
		"Sol/Earth/STARLINK-1585",
		"Sol/Earth/STARLINK-1586",
		"Sol/Earth/STARLINK-1587",
		"Sol/Earth/STARLINK-1588",
		"Sol/Earth/STARLINK-1589",
		"Sol/Earth/STARLINK-1590",
		"Sol/Earth/STARLINK-1591",
		"Sol/Earth/STARLINK-1592",
		"Sol/Earth/STARLINK-1593",
		"Sol/Earth/STARLINK-1594",
		"Sol/Earth/STARLINK-1595",
		"Sol/Earth/STARLINK-1596",
		"Sol/Earth/STARLINK-1597",
		"Sol/Earth/STARLINK-1598",
		"Sol/Earth/STARLINK-1599",
		"Sol/Earth/STARLINK-1600",
		"Sol/Earth/STARLINK-1601",
		"Sol/Earth/STARLINK-1602",
		"Sol/Earth/STARLINK-1603",
		"Sol/Earth/STARLINK-1604",
		"Sol/Earth/STARLINK-1605",
		"Sol/Earth/STARLINK-1606",
		"Sol/Earth/STARLINK-1607",
		"Sol/Earth/STARLINK-1608",
		"Sol/Earth/STARLINK-1609",
		"Sol/Earth/STARLINK-1610",
		"Sol/Earth/STARLINK-1611",
		"Sol/Earth/STARLINK-1612",
		"Sol/Earth/STARLINK-1613",
		"Sol/Earth/STARLINK-1614",
		"Sol/Earth/STARLINK-1615",
		"Sol/Earth/STARLINK-1616",
		"Sol/Earth/STARLINK-1617",
		"Sol/Earth/STARLINK-1618",
		"Sol/Earth/STARLINK-1619",
		"Sol/Earth/STARLINK-1620",
		"Sol/Earth/STARLINK-1621",
		"Sol/Earth/STARLINK-1622",
		"Sol/Earth/STARLINK-1623",
		"Sol/Earth/STARLINK-1624",
		"Sol/Earth/STARLINK-1625",
		"Sol/Earth/STARLINK-1626",
		"Sol/Earth/STARLINK-1627",
		"Sol/Earth/STARLINK-1628",
		"Sol/Earth/STARLINK-1629",
		"Sol/Earth/STARLINK-1630",
		"Sol/Earth/STARLINK-1631",
		"Sol/Earth/STARLINK-1632",
		"Sol/Earth/STARLINK-1633",
		"Sol/Earth/STARLINK-1634",
		"Sol/Earth/STARLINK-1635",
		"Sol/Earth/STARLINK-1636",
		"Sol/Earth/STARLINK-1637",
		"Sol/Earth/STARLINK-1638",
		"Sol/Earth/STARLINK-1639",
		"Sol/Earth/STARLINK-1640",
		"Sol/Earth/STARLINK-1641",
		"Sol/Earth/STARLINK-1642",
		"Sol/Earth/STARLINK-1643",
		"Sol/Earth/STARLINK-1644",
		"Sol/Earth/STARLINK-1645",
		"Sol/Earth/STARLINK-1646",
		"Sol/Earth/STARLINK-1647",
		"Sol/Earth/STARLINK-1648",
		"Sol/Earth/STARLINK-1649",
		"Sol/Earth/STARLINK-1650",
		"Sol/Earth/STARLINK-1651",
		"Sol/Earth/STARLINK-1652",
		"Sol/Earth/STARLINK-1653",
		"Sol/Earth/STARLINK-1654",
		"Sol/Earth/STARLINK-1655",
		"Sol/Earth/STARLINK-1656",
		"Sol/Earth/STARLINK-1657",
		"Sol/Earth/STARLINK-1658",
		"Sol/Earth/STARLINK-1659",
		"Sol/Earth/STARLINK-1660",
		"Sol/Earth/STARLINK-1661",
		"Sol/Earth/STARLINK-1662",
		"Sol/Earth/STARLINK-1663",
		"Sol/Earth/STARLINK-1664",
		"Sol/Earth/STARLINK-1665",
		"Sol/Earth/STARLINK-1666",
		"Sol/Earth/STARLINK-1667",
		"Sol/Earth/STARLINK-1668",
		"Sol/Earth/STARLINK-1669",
		"Sol/Earth/STARLINK-1670",
		"Sol/Earth/STARLINK-1671",
		"Sol/Earth/STARLINK-1672",
		"Sol/Earth/STARLINK-1673",
		"Sol/Earth/STARLINK-1674",
		"Sol/Earth/STARLINK-1675",
		"Sol/Earth/STARLINK-1676",
		"Sol/Earth/STARLINK-1677",
		"Sol/Earth/STARLINK-1678",
		"Sol/Earth/STARLINK-1679",
		"Sol/Earth/STARLINK-1680",
		"Sol/Earth/STARLINK-1681",
		"Sol/Earth/STARLINK-1682",
		"Sol/Earth/STARLINK-1683",
		"Sol/Earth/STARLINK-1684",
		"Sol/Earth/STARLINK-1685",
		"Sol/Earth/STARLINK-1686",
		"Sol/Earth/STARLINK-1687",
		"Sol/Earth/STARLINK-1688",
		"Sol/Earth/STARLINK-1689",
		"Sol/Earth/STARLINK-1690",
		"Sol/Earth/STARLINK-1691",
		"Sol/Earth/STARLINK-1692",
		"Sol/Earth/STARLINK-1693",
		"Sol/Earth/STARLINK-1694",
		"Sol/Earth/STARLINK-1695",
		"Sol/Earth/STARLINK-1696",
		"Sol/Earth/STARLINK-1697",
		"Sol/Earth/STARLINK-1698",
		"Sol/Earth/STARLINK-1699",
		"Sol/Earth/STARLINK-1700",
		"Sol/Earth/STARLINK-1701",
		"Sol/Earth/STARLINK-1702",
		"Sol/Earth/STARLINK-1704",
		"Sol/Earth/STARLINK-1705",
		"Sol/Earth/STARLINK-1706",
		"Sol/Earth/STARLINK-1707",
		"Sol/Earth/STARLINK-1708",
		"Sol/Earth/STARLINK-1709",
		"Sol/Earth/STARLINK-1710",
		"Sol/Earth/STARLINK-1711",
		"Sol/Earth/STARLINK-1712",
		"Sol/Earth/STARLINK-1713",
		"Sol/Earth/STARLINK-1714",
		"Sol/Earth/STARLINK-1715",
		"Sol/Earth/STARLINK-1716",
		"Sol/Earth/STARLINK-1717",
		"Sol/Earth/STARLINK-1718",
		"Sol/Earth/STARLINK-1719",
		"Sol/Earth/STARLINK-1720",
		"Sol/Earth/STARLINK-1721",
		"Sol/Earth/STARLINK-1722",
		"Sol/Earth/STARLINK-1723",
		"Sol/Earth/STARLINK-1724",
		"Sol/Earth/STARLINK-1725",
		"Sol/Earth/STARLINK-1726",
		"Sol/Earth/STARLINK-1727",
		"Sol/Earth/STARLINK-1728",
		"Sol/Earth/STARLINK-1729",
		"Sol/Earth/STARLINK-1730",
		"Sol/Earth/STARLINK-1731",
		"Sol/Earth/STARLINK-1732",
		"Sol/Earth/STARLINK-1733",
		"Sol/Earth/STARLINK-1734",
		"Sol/Earth/STARLINK-1735",
		"Sol/Earth/STARLINK-1736",
		"Sol/Earth/STARLINK-1737",
		"Sol/Earth/STARLINK-1738",
		"Sol/Earth/STARLINK-1739",
		"Sol/Earth/STARLINK-1740",
		"Sol/Earth/STARLINK-1741",
		"Sol/Earth/STARLINK-1742",
		"Sol/Earth/STARLINK-1743",
		"Sol/Earth/STARLINK-1744",
		"Sol/Earth/STARLINK-1745",
		"Sol/Earth/STARLINK-1746",
		"Sol/Earth/STARLINK-1747",
		"Sol/Earth/STARLINK-1748",
		"Sol/Earth/STARLINK-1749",
		"Sol/Earth/STARLINK-1750",
		"Sol/Earth/STARLINK-1751",
		"Sol/Earth/STARLINK-1752",
		"Sol/Earth/STARLINK-1753",
		"Sol/Earth/STARLINK-1754",
		"Sol/Earth/STARLINK-1755",
		"Sol/Earth/STARLINK-1756",
		"Sol/Earth/STARLINK-1757",
		"Sol/Earth/STARLINK-1758",
		"Sol/Earth/STARLINK-1759",
		"Sol/Earth/STARLINK-1760",
		"Sol/Earth/STARLINK-1761",
		"Sol/Earth/STARLINK-1762",
		"Sol/Earth/STARLINK-1763",
		"Sol/Earth/STARLINK-1764",
		"Sol/Earth/STARLINK-1765",
		"Sol/Earth/STARLINK-1766",
		"Sol/Earth/STARLINK-1767",
		"Sol/Earth/STARLINK-1768",
		"Sol/Earth/STARLINK-1769",
		"Sol/Earth/STARLINK-1770",
		"Sol/Earth/STARLINK-1771",
		"Sol/Earth/STARLINK-1773",
		"Sol/Earth/STARLINK-1774",
		"Sol/Earth/STARLINK-1775",
		"Sol/Earth/STARLINK-1776",
		"Sol/Earth/STARLINK-1777",
		"Sol/Earth/STARLINK-1778",
		"Sol/Earth/STARLINK-1779",
		"Sol/Earth/STARLINK-1780",
		"Sol/Earth/STARLINK-1781",
		"Sol/Earth/STARLINK-1782",
		"Sol/Earth/STARLINK-1783",
		"Sol/Earth/STARLINK-1784",
		"Sol/Earth/STARLINK-1785",
		"Sol/Earth/STARLINK-1786",
		"Sol/Earth/STARLINK-1787",
		"Sol/Earth/STARLINK-1788",
		"Sol/Earth/STARLINK-1789",
		"Sol/Earth/STARLINK-1790",
		"Sol/Earth/STARLINK-1791",
		"Sol/Earth/STARLINK-1792",
		"Sol/Earth/STARLINK-1793",
		"Sol/Earth/STARLINK-1794",
		"Sol/Earth/STARLINK-1795",
		"Sol/Earth/STARLINK-1796",
		"Sol/Earth/STARLINK-1797",
		"Sol/Earth/STARLINK-1798",
		"Sol/Earth/STARLINK-1799",
		"Sol/Earth/STARLINK-1800",
		"Sol/Earth/STARLINK-1801",
		"Sol/Earth/STARLINK-1802",
		"Sol/Earth/STARLINK-1803",
		"Sol/Earth/STARLINK-1804",
		"Sol/Earth/STARLINK-1805",
		"Sol/Earth/STARLINK-1806",
		"Sol/Earth/STARLINK-1807",
		"Sol/Earth/STARLINK-1808",
		"Sol/Earth/STARLINK-1809",
		"Sol/Earth/STARLINK-1810",
		"Sol/Earth/STARLINK-1811",
		"Sol/Earth/STARLINK-1812",
		"Sol/Earth/STARLINK-1813",
		"Sol/Earth/STARLINK-1814",
		"Sol/Earth/STARLINK-1815",
		"Sol/Earth/STARLINK-1816",
		"Sol/Earth/STARLINK-1817",
		"Sol/Earth/STARLINK-1818",
		"Sol/Earth/STARLINK-1820",
		"Sol/Earth/STARLINK-1821",
		"Sol/Earth/STARLINK-1822",
		"Sol/Earth/STARLINK-1823",
		"Sol/Earth/STARLINK-1824",
		"Sol/Earth/STARLINK-1825",
		"Sol/Earth/STARLINK-1826",
		"Sol/Earth/STARLINK-1827",
		"Sol/Earth/STARLINK-1828",
		"Sol/Earth/STARLINK-1829",
		"Sol/Earth/STARLINK-1830",
		"Sol/Earth/STARLINK-1831",
		"Sol/Earth/STARLINK-1832",
		"Sol/Earth/STARLINK-1833",
		"Sol/Earth/STARLINK-1834",
		"Sol/Earth/STARLINK-1835",
		"Sol/Earth/STARLINK-1836",
		"Sol/Earth/STARLINK-1837",
		"Sol/Earth/STARLINK-1838",
		"Sol/Earth/STARLINK-1839",
		"Sol/Earth/STARLINK-1840",
		"Sol/Earth/STARLINK-1841",
		"Sol/Earth/STARLINK-1842",
		"Sol/Earth/STARLINK-1843",
		"Sol/Earth/STARLINK-1844",
		"Sol/Earth/STARLINK-1845",
		"Sol/Earth/STARLINK-1846",
		"Sol/Earth/STARLINK-1847",
		"Sol/Earth/STARLINK-1848",
		"Sol/Earth/STARLINK-1849",
		"Sol/Earth/STARLINK-1850",
		"Sol/Earth/STARLINK-1851",
		"Sol/Earth/STARLINK-1852",
		"Sol/Earth/STARLINK-1853",
		"Sol/Earth/STARLINK-1854",
		"Sol/Earth/STARLINK-1855",
		"Sol/Earth/STARLINK-1856",
		"Sol/Earth/STARLINK-1857",
		"Sol/Earth/STARLINK-1858",
		"Sol/Earth/STARLINK-1859",
		"Sol/Earth/STARLINK-1860",
		"Sol/Earth/STARLINK-1861",
		"Sol/Earth/STARLINK-1862",
		"Sol/Earth/STARLINK-1863",
		"Sol/Earth/STARLINK-1864",
		"Sol/Earth/STARLINK-1865",
		"Sol/Earth/STARLINK-1866",
		"Sol/Earth/STARLINK-1867",
		"Sol/Earth/STARLINK-1869",
		"Sol/Earth/STARLINK-1870",
		"Sol/Earth/STARLINK-1871",
		"Sol/Earth/STARLINK-1872",
		"Sol/Earth/STARLINK-1873",
		"Sol/Earth/STARLINK-1874",
		"Sol/Earth/STARLINK-1875",
		"Sol/Earth/STARLINK-1876",
		"Sol/Earth/STARLINK-1877",
		"Sol/Earth/STARLINK-1878",
		"Sol/Earth/STARLINK-1879",
		"Sol/Earth/STARLINK-1880",
		"Sol/Earth/STARLINK-1881",
		"Sol/Earth/STARLINK-1882",
		"Sol/Earth/STARLINK-1883",
		"Sol/Earth/STARLINK-1884",
		"Sol/Earth/STARLINK-1885",
		"Sol/Earth/STARLINK-1886",
		"Sol/Earth/STARLINK-1887",
		"Sol/Earth/STARLINK-1888",
		"Sol/Earth/STARLINK-1889",
		"Sol/Earth/STARLINK-1890",
		"Sol/Earth/STARLINK-1891",
		"Sol/Earth/STARLINK-1892",
		"Sol/Earth/STARLINK-1893",
		"Sol/Earth/STARLINK-1894",
		"Sol/Earth/STARLINK-1895",
		"Sol/Earth/STARLINK-1896",
		"Sol/Earth/STARLINK-1897",
		"Sol/Earth/STARLINK-1898",
		"Sol/Earth/STARLINK-1899",
		"Sol/Earth/STARLINK-1900",
		"Sol/Earth/STARLINK-1901",
		"Sol/Earth/STARLINK-1902",
		"Sol/Earth/STARLINK-1903",
		"Sol/Earth/STARLINK-1904",
		"Sol/Earth/STARLINK-1905",
		"Sol/Earth/STARLINK-1906",
		"Sol/Earth/STARLINK-1907",
		"Sol/Earth/STARLINK-1908",
		"Sol/Earth/STARLINK-1909",
		"Sol/Earth/STARLINK-1910",
		"Sol/Earth/STARLINK-1911",
		"Sol/Earth/STARLINK-1912",
		"Sol/Earth/STARLINK-1913",
		"Sol/Earth/STARLINK-1914",
		"Sol/Earth/STARLINK-1915",
		"Sol/Earth/STARLINK-1916",
		"Sol/Earth/STARLINK-1917",
		"Sol/Earth/STARLINK-1918",
		"Sol/Earth/STARLINK-1919",
		"Sol/Earth/STARLINK-1920",
		"Sol/Earth/STARLINK-1921",
		"Sol/Earth/STARLINK-1922",
		"Sol/Earth/STARLINK-1923",
		"Sol/Earth/STARLINK-1924",
		"Sol/Earth/STARLINK-1925",
		"Sol/Earth/STARLINK-1926",
		"Sol/Earth/STARLINK-1927",
		"Sol/Earth/STARLINK-1928",
		"Sol/Earth/STARLINK-1929",
		"Sol/Earth/STARLINK-1930",
		"Sol/Earth/STARLINK-1931",
		"Sol/Earth/STARLINK-1932",
		"Sol/Earth/STARLINK-1933",
		"Sol/Earth/STARLINK-1934",
		"Sol/Earth/STARLINK-1935",
		"Sol/Earth/STARLINK-1936",
		"Sol/Earth/STARLINK-1937",
		"Sol/Earth/STARLINK-1938",
		"Sol/Earth/STARLINK-1939",
		"Sol/Earth/STARLINK-1940",
		"Sol/Earth/STARLINK-1941",
		"Sol/Earth/STARLINK-1942",
		"Sol/Earth/STARLINK-1943",
		"Sol/Earth/STARLINK-1944",
		"Sol/Earth/STARLINK-1945",
		"Sol/Earth/STARLINK-1946",
		"Sol/Earth/STARLINK-1947",
		"Sol/Earth/STARLINK-1948",
		"Sol/Earth/STARLINK-1949",
		"Sol/Earth/STARLINK-1950",
		"Sol/Earth/STARLINK-1951",
		"Sol/Earth/STARLINK-1952",
		"Sol/Earth/STARLINK-1953",
		"Sol/Earth/STARLINK-1954",
		"Sol/Earth/STARLINK-1955",
		"Sol/Earth/STARLINK-1956",
		"Sol/Earth/STARLINK-1957",
		"Sol/Earth/STARLINK-1958",
		"Sol/Earth/STARLINK-1959",
		"Sol/Earth/STARLINK-1960",
		"Sol/Earth/STARLINK-1961",
		"Sol/Earth/STARLINK-1962",
		"Sol/Earth/STARLINK-1963",
		"Sol/Earth/STARLINK-1964",
		"Sol/Earth/STARLINK-1965",
		"Sol/Earth/STARLINK-1966",
		"Sol/Earth/STARLINK-1967",
		"Sol/Earth/STARLINK-1968",
		"Sol/Earth/STARLINK-1969",
		"Sol/Earth/STARLINK-1970",
		"Sol/Earth/STARLINK-1971",
		"Sol/Earth/STARLINK-1972",
		"Sol/Earth/STARLINK-1973",
		"Sol/Earth/STARLINK-1974",
		"Sol/Earth/STARLINK-1975",
		"Sol/Earth/STARLINK-1976",
		"Sol/Earth/STARLINK-1977",
		"Sol/Earth/STARLINK-1978",
		"Sol/Earth/STARLINK-1979",
		"Sol/Earth/STARLINK-1980",
		"Sol/Earth/STARLINK-1981",
		"Sol/Earth/STARLINK-1982",
		"Sol/Earth/STARLINK-1983",
		"Sol/Earth/STARLINK-1984",
		"Sol/Earth/STARLINK-1985",
		"Sol/Earth/STARLINK-1986",
		"Sol/Earth/STARLINK-1987",
		"Sol/Earth/STARLINK-1988",
		"Sol/Earth/STARLINK-1989",
		"Sol/Earth/STARLINK-1990",
		"Sol/Earth/STARLINK-1991",
		"Sol/Earth/STARLINK-1992",
		"Sol/Earth/STARLINK-1993",
		"Sol/Earth/STARLINK-1994",
		"Sol/Earth/STARLINK-1995",
		"Sol/Earth/STARLINK-1996",
		"Sol/Earth/STARLINK-1997",
		"Sol/Earth/STARLINK-1998",
		"Sol/Earth/STARLINK-1999",
		"Sol/Earth/STARLINK-2000",
		"Sol/Earth/STARLINK-2001",
		"Sol/Earth/STARLINK-2002",
		"Sol/Earth/STARLINK-2003",
		"Sol/Earth/STARLINK-2004",
		"Sol/Earth/STARLINK-2005",
		"Sol/Earth/STARLINK-2006",
		"Sol/Earth/STARLINK-2007",
		"Sol/Earth/STARLINK-2008",
		"Sol/Earth/STARLINK-2009",
		"Sol/Earth/STARLINK-2010",
		"Sol/Earth/STARLINK-2011",
		"Sol/Earth/STARLINK-2012",
		"Sol/Earth/STARLINK-2013",
		"Sol/Earth/STARLINK-2014",
		"Sol/Earth/STARLINK-2015",
		"Sol/Earth/STARLINK-2016",
		"Sol/Earth/STARLINK-2017",
		"Sol/Earth/STARLINK-2018",
		"Sol/Earth/STARLINK-2019",
		"Sol/Earth/STARLINK-2020",
		"Sol/Earth/STARLINK-2021",
		"Sol/Earth/STARLINK-2022",
		"Sol/Earth/STARLINK-2023",
		"Sol/Earth/STARLINK-2024",
		"Sol/Earth/STARLINK-2025",
		"Sol/Earth/STARLINK-2026",
		"Sol/Earth/STARLINK-2027",
		"Sol/Earth/STARLINK-2028",
		"Sol/Earth/STARLINK-2029", -- Starlink 24-45
		"Sol/Earth/STARLINK-2030",
		"Sol/Earth/STARLINK-2031",
		"Sol/Earth/STARLINK-2032",
		"Sol/Earth/STARLINK-2033",
		"Sol/Earth/STARLINK-2034",
		"Sol/Earth/STARLINK-2035",
		"Sol/Earth/STARLINK-2036",
		"Sol/Earth/STARLINK-2037",
		"Sol/Earth/STARLINK-2038",
		"Sol/Earth/STARLINK-2039",
		"Sol/Earth/STARLINK-2040",
		"Sol/Earth/STARLINK-2041",
		"Sol/Earth/STARLINK-2042",
		"Sol/Earth/STARLINK-2043",
		"Sol/Earth/STARLINK-2044",
		"Sol/Earth/STARLINK-2045",
		"Sol/Earth/STARLINK-2046",
		"Sol/Earth/STARLINK-2047",
		"Sol/Earth/STARLINK-2048", -- STARLINK 23-1
		"Sol/Earth/STARLINK-2049",
		"Sol/Earth/STARLINK-2050",
		"Sol/Earth/STARLINK-2051",
		"Sol/Earth/STARLINK-2052",
		"Sol/Earth/STARLINK-2053",
		"Sol/Earth/STARLINK-2054",
		"Sol/Earth/STARLINK-2055",
		"Sol/Earth/STARLINK-2056",
		"Sol/Earth/STARLINK-2057",
		"Sol/Earth/STARLINK-2058",
		"Sol/Earth/STARLINK-2059",
		"Sol/Earth/STARLINK-2060",
		"Sol/Earth/STARLINK-2061", -- Starlink 24-37
		"Sol/Earth/STARLINK-2062",
		"Sol/Earth/STARLINK-2063", -- Starlink 26-1
		"Sol/Earth/STARLINK-2064",
		"Sol/Earth/STARLINK-2065",
		"Sol/Earth/STARLINK-2066",
		"Sol/Earth/STARLINK-2067",
		"Sol/Earth/STARLINK-2068",
		"Sol/Earth/STARLINK-2069",
		"Sol/Earth/STARLINK-2070",
		"Sol/Earth/STARLINK-2071",
		"Sol/Earth/STARLINK-2076",
		"Sol/Earth/STARLINK-2077",
		"Sol/Earth/STARLINK-2078",
		"Sol/Earth/STARLINK-2079",
		"Sol/Earth/STARLINK-2080",
		"Sol/Earth/STARLINK-2081",
		"Sol/Earth/STARLINK-2082",
		"Sol/Earth/STARLINK-2083",
		"Sol/Earth/STARLINK-2084",
		"Sol/Earth/STARLINK-2085",
		"Sol/Earth/STARLINK-2086",
		"Sol/Earth/STARLINK-2087",
		"Sol/Earth/STARLINK-2088",
		"Sol/Earth/STARLINK-2089",
		"Sol/Earth/STARLINK-2090",
		"Sol/Earth/STARLINK-2091",
		"Sol/Earth/STARLINK-2092",
		"Sol/Earth/STARLINK-2093",
		"Sol/Earth/STARLINK-2094",
		"Sol/Earth/STARLINK-2095",
		"Sol/Earth/STARLINK-2096",
		"Sol/Earth/STARLINK-2097",
		"Sol/Earth/STARLINK-2098",
		"Sol/Earth/STARLINK-2099",
		"Sol/Earth/STARLINK-2100",
		"Sol/Earth/STARLINK-2101",
		"Sol/Earth/STARLINK-2102",
		"Sol/Earth/STARLINK-2103",
		"Sol/Earth/STARLINK-2104",
		"Sol/Earth/STARLINK-2105",
		"Sol/Earth/STARLINK-2106",
		"Sol/Earth/STARLINK-2107",
		"Sol/Earth/STARLINK-2108",
		"Sol/Earth/STARLINK-2109",
		"Sol/Earth/STARLINK-2110",
		"Sol/Earth/STARLINK-2111",
		"Sol/Earth/STARLINK-2112",
		"Sol/Earth/STARLINK-2113",
		"Sol/Earth/STARLINK-2114",
		"Sol/Earth/STARLINK-2115",
		"Sol/Earth/STARLINK-2116",
		"Sol/Earth/STARLINK-2117",
		"Sol/Earth/STARLINK-2118",
		"Sol/Earth/STARLINK-2119",
		"Sol/Earth/STARLINK-2120",
		"Sol/Earth/STARLINK-2121",
		"Sol/Earth/STARLINK-2122",
		"Sol/Earth/STARLINK-2123",
		"Sol/Earth/STARLINK-2124",
		"Sol/Earth/STARLINK-2125",
		"Sol/Earth/STARLINK-2126",
		"Sol/Earth/STARLINK-2127",
		"Sol/Earth/STARLINK-2128",
		"Sol/Earth/STARLINK-2129",
		"Sol/Earth/STARLINK-2130",
		"Sol/Earth/STARLINK-2131",
		"Sol/Earth/STARLINK-2132",
		"Sol/Earth/STARLINK-2133",
		"Sol/Earth/STARLINK-2134",
		"Sol/Earth/STARLINK-2135",
		"Sol/Earth/STARLINK-2139", -- Starlink 26-2
		"Sol/Earth/STARLINK-2140",
		"Sol/Earth/STARLINK-2141",
		"Sol/Earth/STARLINK-2142",
		"Sol/Earth/STARLINK-2143",
		"Sol/Earth/STARLINK-2144",
		"Sol/Earth/STARLINK-2145", -- Starlink 26-3
		"Sol/Earth/STARLINK-2146",
		"Sol/Earth/STARLINK-2147",
		"Sol/Earth/STARLINK-2148",
		"Sol/Earth/STARLINK-2149",
		"Sol/Earth/STARLINK-2150",
		"Sol/Earth/STARLINK-2151", -- Starlink 26-4
		"Sol/Earth/STARLINK-2152",
		"Sol/Earth/STARLINK-2153",
		"Sol/Earth/STARLINK-2154",
		"Sol/Earth/STARLINK-2155", -- Starlink 26-5
		"Sol/Earth/STARLINK-2156",
		"Sol/Earth/STARLINK-2157",
		"Sol/Earth/STARLINK-2158",
		"Sol/Earth/STARLINK-2159",
		"Sol/Earth/STARLINK-2160",
		"Sol/Earth/STARLINK-2161",
		"Sol/Earth/STARLINK-2162",
		"Sol/Earth/STARLINK-2163",
		"Sol/Earth/STARLINK-2164",
		"Sol/Earth/STARLINK-2166", -- Starlink 26-6
		"Sol/Earth/STARLINK-2167", -- Starlink 26-7
		"Sol/Earth/STARLINK-2168",
		"Sol/Earth/STARLINK-2169",
		"Sol/Earth/STARLINK-2170",
		"Sol/Earth/STARLINK-2171",
		"Sol/Earth/STARLINK-2172",
		"Sol/Earth/STARLINK-2173", -- Starlink 26-8
		"Sol/Earth/STARLINK-2174",
		"Sol/Earth/STARLINK-2175",
		"Sol/Earth/STARLINK-2176",
		"Sol/Earth/STARLINK-2177",
		"Sol/Earth/STARLINK-2178",
		"Sol/Earth/STARLINK-2179",
		"Sol/Earth/STARLINK-2180",
		"Sol/Earth/STARLINK-2181",
		"Sol/Earth/STARLINK-2182",
		"Sol/Earth/STARLINK-2183",
		"Sol/Earth/STARLINK-2184",
		"Sol/Earth/STARLINK-2185",
		"Sol/Earth/STARLINK-2186", -- Starlink 26-9
		"Sol/Earth/STARLINK-2187", -- Starlink 26-10
		"Sol/Earth/STARLINK-2188", -- Starlink 26-11
		"Sol/Earth/STARLINK-2189",
		"Sol/Earth/STARLINK-2190", -- Starlink 26-12
		"Sol/Earth/STARLINK-2191", -- Starlink 26-13
		"Sol/Earth/STARLINK-2192",
		"Sol/Earth/STARLINK-2193",
		"Sol/Earth/STARLINK-2194",
		"Sol/Earth/STARLINK-2195",
		"Sol/Earth/STARLINK-2196",
		"Sol/Earth/STARLINK-2197",
		"Sol/Earth/STARLINK-2198",
		"Sol/Earth/STARLINK-2199",
		"Sol/Earth/STARLINK-2200",
		"Sol/Earth/STARLINK-2201",
		"Sol/Earth/STARLINK-2202",
		"Sol/Earth/STARLINK-2203",
		"Sol/Earth/STARLINK-2204",
		"Sol/Earth/STARLINK-2205",
		"Sol/Earth/STARLINK-2206",
		"Sol/Earth/STARLINK-2207",
		"Sol/Earth/STARLINK-2208",
		"Sol/Earth/STARLINK-2209",
		"Sol/Earth/STARLINK-2210",
		"Sol/Earth/STARLINK-2211",
		"Sol/Earth/STARLINK-2212",
		"Sol/Earth/STARLINK-2213",
		"Sol/Earth/STARLINK-2214", -- Starlink 26-14
		"Sol/Earth/STARLINK-2215", -- Starlink 26-15
		"Sol/Earth/STARLINK-2216",
		"Sol/Earth/STARLINK-2217", -- Starlink 26-16
		"Sol/Earth/STARLINK-2218",
		"Sol/Earth/STARLINK-2219", -- Starlink 26-17
		"Sol/Earth/STARLINK-2220", -- Starlink 26-18
		"Sol/Earth/STARLINK-2221", -- Starlink 26-19
		"Sol/Earth/STARLINK-2222", -- Starlink 26-20
		"Sol/Earth/STARLINK-2223",
		"Sol/Earth/STARLINK-2224", -- Starlink 26-21
		"Sol/Earth/STARLINK-2225", -- Starlink 26-22
		"Sol/Earth/STARLINK-2226",
		"Sol/Earth/STARLINK-2227", -- Starlink 26-23
		"Sol/Earth/STARLINK-2228", -- Starlink 26-24
		"Sol/Earth/STARLINK-2229",
		"Sol/Earth/STARLINK-2231", -- Starlink 26-25
		"Sol/Earth/STARLINK-2232", -- Starlink 26-26
		"Sol/Earth/STARLINK-2233", -- Starlink 26-27
		"Sol/Earth/STARLINK-2234", -- Starlink 26-28
		"Sol/Earth/STARLINK-2235", -- Starlink 26-29
		"Sol/Earth/STARLINK-2236", -- Starlink 26-30
		"Sol/Earth/STARLINK-2237", -- Starlink 26-31
		"Sol/Earth/STARLINK-2238", -- Starlink 26-32
		"Sol/Earth/STARLINK-2239",
		"Sol/Earth/STARLINK-2240", -- Starlink 26-33
		"Sol/Earth/STARLINK-2241", -- Starlink 26-34
		"Sol/Earth/STARLINK-2242", -- Starlink 26-35
		"Sol/Earth/STARLINK-2243",
		"Sol/Earth/STARLINK-2244", -- Starlink 26-36
		"Sol/Earth/STARLINK-2245", -- Starlink 26-37
		"Sol/Earth/STARLINK-2246", -- Starlink 26-38
		"Sol/Earth/STARLINK-2248", -- Starlink 26-39
		"Sol/Earth/STARLINK-2249", -- Starlink 26-40
		"Sol/Earth/STARLINK-2250", -- Starlink 26-41
		"Sol/Earth/STARLINK-2251", -- Starlink 26-42
		"Sol/Earth/STARLINK-2252", -- Starlink 26-43
		"Sol/Earth/STARLINK-2253", -- Starlink 26-44
		"Sol/Earth/STARLINK-2254",
		"Sol/Earth/STARLINK-2255", -- Starlink 26-45
		"Sol/Earth/STARLINK-2256", -- Starlink 26-46
		"Sol/Earth/STARLINK-2257",
		"Sol/Earth/STARLINK-2258",
		"Sol/Earth/STARLINK-2259",
		"Sol/Earth/STARLINK-2260",
		"Sol/Earth/STARLINK-2261",
		"Sol/Earth/STARLINK-2262",
		"Sol/Earth/STARLINK-2263",
		"Sol/Earth/STARLINK-2264",
		"Sol/Earth/STARLINK-2265",
		"Sol/Earth/STARLINK-2266",
		"Sol/Earth/STARLINK-2267",
		"Sol/Earth/STARLINK-2268",
		"Sol/Earth/STARLINK-2270",
		"Sol/Earth/STARLINK-2271",
		"Sol/Earth/STARLINK-2272",
		"Sol/Earth/STARLINK-2273",
		"Sol/Earth/STARLINK-2274", -- Starlink 26-47
		"Sol/Earth/STARLINK-2275", -- Starlink 26-48
		"Sol/Earth/STARLINK-2276", -- Starlink 26-49
		"Sol/Earth/STARLINK-2277",
		"Sol/Earth/STARLINK-2278",
		"Sol/Earth/STARLINK-2279",
		"Sol/Earth/STARLINK-2280",
		"Sol/Earth/STARLINK-2281",
		"Sol/Earth/STARLINK-2282",
		"Sol/Earth/STARLINK-2283",
		"Sol/Earth/STARLINK-2284",
		"Sol/Earth/STARLINK-2285",
		"Sol/Earth/STARLINK-2286",
		"Sol/Earth/STARLINK-2287",
		"Sol/Earth/STARLINK-2288",
		"Sol/Earth/STARLINK-2289",
		"Sol/Earth/STARLINK-2290",
		"Sol/Earth/STARLINK-2291",
		"Sol/Earth/STARLINK-2292",
		"Sol/Earth/STARLINK-2293",
		"Sol/Earth/STARLINK-2294",
		"Sol/Earth/STARLINK-2295",
		"Sol/Earth/STARLINK-2296",
		"Sol/Earth/STARLINK-2297",
		"Sol/Earth/STARLINK-2298",
		"Sol/Earth/STARLINK-2299",
		"Sol/Earth/STARLINK-2300",
		"Sol/Earth/STARLINK-2301",
		"Sol/Earth/STARLINK-2302",
		"Sol/Earth/STARLINK-2303",
		"Sol/Earth/STARLINK-2304",
		"Sol/Earth/STARLINK-2305",
		"Sol/Earth/STARLINK-2306",
		"Sol/Earth/STARLINK-2307",
		"Sol/Earth/STARLINK-2308",
		"Sol/Earth/STARLINK-2309",
		"Sol/Earth/STARLINK-2310",
		"Sol/Earth/STARLINK-2311",
		"Sol/Earth/STARLINK-2312",
		"Sol/Earth/STARLINK-2313",
		"Sol/Earth/STARLINK-2314",
		"Sol/Earth/STARLINK-2315",
		"Sol/Earth/STARLINK-2316",
		"Sol/Earth/STARLINK-2317",
		"Sol/Earth/STARLINK-2318",
		"Sol/Earth/STARLINK-2319",
		"Sol/Earth/STARLINK-2320",
		"Sol/Earth/STARLINK-2321",
		"Sol/Earth/STARLINK-2322",
		"Sol/Earth/STARLINK-2323",
		"Sol/Earth/STARLINK-2324",
		"Sol/Earth/STARLINK-2325",
		"Sol/Earth/STARLINK-2326",
		"Sol/Earth/STARLINK-2327",
		"Sol/Earth/STARLINK-2328",
		"Sol/Earth/STARLINK-2329",
		"Sol/Earth/STARLINK-2330",
		"Sol/Earth/STARLINK-2331",
		"Sol/Earth/STARLINK-2332",
		"Sol/Earth/STARLINK-2333",
		"Sol/Earth/STARLINK-2334",
		"Sol/Earth/STARLINK-2335",
		"Sol/Earth/STARLINK-2336",
		"Sol/Earth/STARLINK-2337",
		"Sol/Earth/STARLINK-2338",
		"Sol/Earth/STARLINK-2339",
		"Sol/Earth/STARLINK-2340",
		"Sol/Earth/STARLINK-2341",
		"Sol/Earth/STARLINK-2342",
		"Sol/Earth/STARLINK-2343",
		"Sol/Earth/STARLINK-2344",
		"Sol/Earth/STARLINK-2345",
		"Sol/Earth/STARLINK-2346",
		"Sol/Earth/STARLINK-2347",
		"Sol/Earth/STARLINK-2348",
		"Sol/Earth/STARLINK-2349",
		"Sol/Earth/STARLINK-2350",
		"Sol/Earth/STARLINK-2351",
		"Sol/Earth/STARLINK-2352",
		"Sol/Earth/STARLINK-2353",
		"Sol/Earth/STARLINK-2354",
		"Sol/Earth/STARLINK-2355",
		"Sol/Earth/STARLINK-2356",
		"Sol/Earth/STARLINK-2357",
		"Sol/Earth/STARLINK-2358",
		"Sol/Earth/STARLINK-2359",
		"Sol/Earth/STARLINK-2360",
		"Sol/Earth/STARLINK-2361",
		"Sol/Earth/STARLINK-2362",
		"Sol/Earth/STARLINK-2363",
		"Sol/Earth/STARLINK-2364",
		"Sol/Earth/STARLINK-2365",
		"Sol/Earth/STARLINK-2366",
		"Sol/Earth/STARLINK-2367",
		"Sol/Earth/STARLINK-2368",
		"Sol/Earth/STARLINK-2369",
		"Sol/Earth/STARLINK-2370",
		"Sol/Earth/STARLINK-2371",
		"Sol/Earth/STARLINK-2372",
		"Sol/Earth/STARLINK-2373",
		"Sol/Earth/STARLINK-2374",
		"Sol/Earth/STARLINK-2375",
		"Sol/Earth/STARLINK-2376",
		"Sol/Earth/STARLINK-2377",
		"Sol/Earth/STARLINK-2378",
		"Sol/Earth/STARLINK-2379",
		"Sol/Earth/STARLINK-2380",
		"Sol/Earth/STARLINK-2381",
		"Sol/Earth/STARLINK-2382",
		"Sol/Earth/STARLINK-2383",
		"Sol/Earth/STARLINK-2384",
		"Sol/Earth/STARLINK-2385",
		"Sol/Earth/STARLINK-2386",
		"Sol/Earth/STARLINK-2387",
		"Sol/Earth/STARLINK-2388",
		"Sol/Earth/STARLINK-2389",
		"Sol/Earth/STARLINK-2390",
		"Sol/Earth/STARLINK-2391",
		"Sol/Earth/STARLINK-2392",
		"Sol/Earth/STARLINK-2393",
		"Sol/Earth/STARLINK-2394",
		"Sol/Earth/STARLINK-2395",
		"Sol/Earth/STARLINK-2396",
		"Sol/Earth/STARLINK-2397",
		"Sol/Earth/STARLINK-2398",
		"Sol/Earth/STARLINK-2399",
		"Sol/Earth/STARLINK-2400",
		"Sol/Earth/STARLINK-2401",
		"Sol/Earth/STARLINK-2402",
		"Sol/Earth/STARLINK-2403",
		"Sol/Earth/STARLINK-2404", -- STARLINK 23-2
		"Sol/Earth/STARLINK-2405",
		"Sol/Earth/STARLINK-2406",
		"Sol/Earth/STARLINK-2407",
		"Sol/Earth/STARLINK-2408",
		"Sol/Earth/STARLINK-2409",
		"Sol/Earth/STARLINK-2410",
		"Sol/Earth/STARLINK-2411",
		"Sol/Earth/STARLINK-2412", -- STARLINK 23-3
		"Sol/Earth/STARLINK-2413",
		"Sol/Earth/STARLINK-2414", -- STARLINK 23-4
		"Sol/Earth/STARLINK-2415",
		"Sol/Earth/STARLINK-2416",
		"Sol/Earth/STARLINK-2417", -- STARLINK 23-5
		"Sol/Earth/STARLINK-2418", -- STARLINK 23-6
		"Sol/Earth/STARLINK-2419",
		"Sol/Earth/STARLINK-2420",
		"Sol/Earth/STARLINK-2421", -- STARLINK 23-7
		"Sol/Earth/STARLINK-2422",
		"Sol/Earth/STARLINK-2423",
		"Sol/Earth/STARLINK-2424",
		"Sol/Earth/STARLINK-2425",
		"Sol/Earth/STARLINK-2426",
		"Sol/Earth/STARLINK-2427",
		"Sol/Earth/STARLINK-2428", -- STARLINK 23-8
		"Sol/Earth/STARLINK-2429",
		"Sol/Earth/STARLINK-2430", -- STARLINK 23-9
		"Sol/Earth/STARLINK-2431",
		"Sol/Earth/STARLINK-2432",
		"Sol/Earth/STARLINK-2433",
		"Sol/Earth/STARLINK-2434",
		"Sol/Earth/STARLINK-2435",
		"Sol/Earth/STARLINK-2436", -- STARLINK 23-10
		"Sol/Earth/STARLINK-2437", -- STARLINK 23-11
		"Sol/Earth/STARLINK-2438", -- STARLINK 23-12
		"Sol/Earth/STARLINK-2439", -- STARLINK 23-13
		"Sol/Earth/STARLINK-2440", -- STARLINK 23-14
		"Sol/Earth/STARLINK-2441", -- Starlink 24-60
		"Sol/Earth/STARLINK-2442", -- STARLINK 23-15
		"Sol/Earth/STARLINK-2443", -- STARLINK 23-16
		"Sol/Earth/STARLINK-2444", -- STARLINK 23-17
		"Sol/Earth/STARLINK-2445", -- STARLINK 23-18
		"Sol/Earth/STARLINK-2446",
		"Sol/Earth/STARLINK-2447", -- STARLINK 23-19
		"Sol/Earth/STARLINK-2448", -- STARLINK 23-20
		"Sol/Earth/STARLINK-2449", -- STARLINK 23-21
		"Sol/Earth/STARLINK-2450", -- STARLINK 23-22
		"Sol/Earth/STARLINK-2451", -- STARLINK 23-23
		"Sol/Earth/STARLINK-2452", -- STARLINK 23-24
		"Sol/Earth/STARLINK-2453",
		"Sol/Earth/STARLINK-2454", -- STARLINK 23-25
		"Sol/Earth/STARLINK-2455", -- STARLINK 23-26
		"Sol/Earth/STARLINK-2456",
		"Sol/Earth/STARLINK-2457", -- Starlink 24-46
		"Sol/Earth/STARLINK-2458", -- STARLINK 23-27
		"Sol/Earth/STARLINK-2459", -- STARLINK 23-28
		"Sol/Earth/STARLINK-2460", -- STARLINK 23-29
		"Sol/Earth/STARLINK-2462", -- STARLINK 23-30
		"Sol/Earth/STARLINK-2463", -- STARLINK 23-31
		"Sol/Earth/STARLINK-2464", -- STARLINK 23-32
		"Sol/Earth/STARLINK-2465", -- STARLINK 23-33
		"Sol/Earth/STARLINK-2466", -- STARLINK 23-34
		"Sol/Earth/STARLINK-2467", -- STARLINK 23-35
		"Sol/Earth/STARLINK-2468", -- STARLINK 23-36
		"Sol/Earth/STARLINK-2469", -- STARLINK 23-37
		"Sol/Earth/STARLINK-2470", -- Starlink 24-59
		"Sol/Earth/STARLINK-2471", -- STARLINK 23-38
		"Sol/Earth/STARLINK-2472", -- STARLINK 23-39
		"Sol/Earth/STARLINK-2473", -- STARLINK 23-40
		"Sol/Earth/STARLINK-2474", -- STARLINK 23-41
		"Sol/Earth/STARLINK-2475", -- STARLINK 23-42
		"Sol/Earth/STARLINK-2476", -- STARLINK 23-43
		"Sol/Earth/STARLINK-2477", -- Starlink 24-47
		"Sol/Earth/STARLINK-2478", -- STARLINK 23-44
		"Sol/Earth/STARLINK-2479", -- STARLINK 23-45
		"Sol/Earth/STARLINK-2480", -- STARLINK 23-46
		"Sol/Earth/STARLINK-2481", -- STARLINK 23-47
		"Sol/Earth/STARLINK-2482", -- STARLINK 23-48
		"Sol/Earth/STARLINK-2483", -- STARLINK 23-49
		"Sol/Earth/STARLINK-2484", -- STARLINK 23-50
		"Sol/Earth/STARLINK-2485", -- STARLINK 23-51
		"Sol/Earth/STARLINK-2486", -- STARLINK 23-52
		"Sol/Earth/STARLINK-2487", -- STARLINK 23-53
		"Sol/Earth/STARLINK-2488", -- STARLINK 23-54
		"Sol/Earth/STARLINK-2489", -- STARLINK 23-55
		"Sol/Earth/STARLINK-2490", -- STARLINK 23-56
		"Sol/Earth/STARLINK-2491", -- STARLINK 23-57
		"Sol/Earth/STARLINK-2492", -- STARLINK 23-58
		"Sol/Earth/STARLINK-2493", -- STARLINK 23-59
		"Sol/Earth/STARLINK-2495", -- Starlink 24-50
		"Sol/Earth/STARLINK-2498", -- Starlink 24-51
		"Sol/Earth/STARLINK-2499",
		"Sol/Earth/STARLINK-2501", -- Starlink 24-55
		"Sol/Earth/STARLINK-2502", -- Starlink 24-52
		"Sol/Earth/STARLINK-2503", -- STARLINK 23-60
		"Sol/Earth/STARLINK-2504", -- Starlink 24-53
		"Sol/Earth/STARLINK-2505",
		"Sol/Earth/STARLINK-2506", -- Starlink 24-40
		"Sol/Earth/STARLINK-2507", -- Starlink 24-41
		"Sol/Earth/STARLINK-2509", -- Starlink 24-43
		"Sol/Earth/STARLINK-2510", -- Starlink 24-54
		"Sol/Earth/STARLINK-2511", -- Starlink 24-57
		"Sol/Earth/STARLINK-2512", -- Starlink 24-44
		"Sol/Earth/STARLINK-2513", -- Starlink 24-42
		"Sol/Earth/STARLINK-2514", -- Starlink 24-56
		"Sol/Earth/STARLINK-2515", -- Starlink 24-48
		"Sol/Earth/STARLINK-2516", -- Starlink 24-8
		"Sol/Earth/STARLINK-2517", -- Starlink 24-34
		"Sol/Earth/STARLINK-2518", -- Starlink 24-58
		"Sol/Earth/STARLINK-2519", -- Starlink 24-30
		"Sol/Earth/STARLINK-2520", -- Starlink 24-6
		"Sol/Earth/STARLINK-2521", -- Starlink 28-11
		"Sol/Earth/STARLINK-2523", -- Starlink 24-31
		"Sol/Earth/STARLINK-2524", -- Starlink 24-29
		"Sol/Earth/STARLINK-2526",
		"Sol/Earth/STARLINK-2527", -- Starlink 24-49
		"Sol/Earth/STARLINK-2528", -- Starlink 24-32
		"Sol/Earth/STARLINK-2530", -- Starlink 24-28
		"Sol/Earth/STARLINK-2532", -- Starlink 24-33
		"Sol/Earth/STARLINK-2533", -- Starlink 24-19
		"Sol/Earth/STARLINK-2534", -- Starlink 24-36
		"Sol/Earth/STARLINK-2535", -- Starlink 24-20
		"Sol/Earth/STARLINK-2536", -- Starlink 24-35
		"Sol/Earth/STARLINK-2537", -- Starlink 24-26
		"Sol/Earth/STARLINK-2538", -- Starlink 24-25
		"Sol/Earth/STARLINK-2540", -- Starlink 24-15
		"Sol/Earth/STARLINK-2541", -- Starlink 24-38
		"Sol/Earth/STARLINK-2542", -- Starlink 24-17
		"Sol/Earth/STARLINK-2543", -- Starlink 24-3
		"Sol/Earth/STARLINK-2544", -- Starlink 24-22
		"Sol/Earth/STARLINK-2545", -- Starlink 24-14
		"Sol/Earth/STARLINK-2546", -- Starlink 24-21
		"Sol/Earth/STARLINK-2547", -- Starlink 24-11
		"Sol/Earth/STARLINK-2548", -- Starlink 24-10
		"Sol/Earth/STARLINK-2549", -- Starlink 24-39
		"Sol/Earth/STARLINK-2550", -- Starlink 24-18
		"Sol/Earth/STARLINK-2555", -- Starlink 24-16
		"Sol/Earth/STARLINK-2556", -- Starlink 24-27
		"Sol/Earth/STARLINK-2557", -- Starlink 24-24
		"Sol/Earth/STARLINK-2558", -- Starlink 24-7
		"Sol/Earth/STARLINK-2559", -- Starlink 24-23
		"Sol/Earth/STARLINK-2560",
		"Sol/Earth/STARLINK-2561",
		"Sol/Earth/STARLINK-2562", -- Starlink 24-13
		"Sol/Earth/STARLINK-2563",
		"Sol/Earth/STARLINK-2564", -- Starlink 24-9
		"Sol/Earth/STARLINK-2565", -- Starlink 24-5
		"Sol/Earth/STARLINK-2566", -- Starlink 24-12
		"Sol/Earth/STARLINK-2567", -- Starlink 24-1
		"Sol/Earth/STARLINK-2568",
		"Sol/Earth/STARLINK-2569", -- Starlink 24-2
		"Sol/Earth/STARLINK-2570",
		"Sol/Earth/STARLINK-2571",
		"Sol/Earth/STARLINK-2572",
		"Sol/Earth/STARLINK-2573",
		"Sol/Earth/STARLINK-2574",
		"Sol/Earth/STARLINK-2575",
		"Sol/Earth/STARLINK-2576",
		"Sol/Earth/STARLINK-2578",
		"Sol/Earth/STARLINK-2580", -- Starlink 24-4
		"Sol/Earth/STARLINK-2581",
		"Sol/Earth/STARLINK-2585",
		"Sol/Earth/STARLINK-2586",
		"Sol/Earth/STARLINK-2587",
		"Sol/Earth/STARLINK-2588",
		"Sol/Earth/STARLINK-2589",
		"Sol/Earth/STARLINK-2590",
		"Sol/Earth/STARLINK-2591",
		"Sol/Earth/STARLINK-2592",
		"Sol/Earth/STARLINK-2593",
		"Sol/Earth/STARLINK-2594",
		"Sol/Earth/STARLINK-2595",
		"Sol/Earth/STARLINK-2596",
		"Sol/Earth/STARLINK-2598",
		"Sol/Earth/STARLINK-2599",
		"Sol/Earth/STARLINK-2600",
		"Sol/Earth/STARLINK-2601",
		"Sol/Earth/STARLINK-2602",
		"Sol/Earth/STARLINK-2603",
		"Sol/Earth/STARLINK-2604",
		"Sol/Earth/STARLINK-2605",
		"Sol/Earth/STARLINK-2606",
		"Sol/Earth/STARLINK-2607",
		"Sol/Earth/STARLINK-2608",
		"Sol/Earth/STARLINK-2609",
		"Sol/Earth/STARLINK-2610",
		"Sol/Earth/STARLINK-2611",
		"Sol/Earth/STARLINK-2612",
		"Sol/Earth/STARLINK-2613",
		"Sol/Earth/STARLINK-2614",
		"Sol/Earth/STARLINK-2615", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2616", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2617", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2618", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2621",
		"Sol/Earth/STARLINK-2622",
		"Sol/Earth/STARLINK-2623",
		"Sol/Earth/STARLINK-2624",
		"Sol/Earth/STARLINK-2626",
		"Sol/Earth/STARLINK-2627", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2628",
		"Sol/Earth/STARLINK-2629", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2630",
		"Sol/Earth/STARLINK-2631",
		"Sol/Earth/STARLINK-2635",
		"Sol/Earth/STARLINK-2636",
		"Sol/Earth/STARLINK-2637",
		"Sol/Earth/STARLINK-2641",
		"Sol/Earth/STARLINK-2643",
		"Sol/Earth/STARLINK-2646", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2647", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2648", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2649", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2651", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2653", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2657", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2666", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2667", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2672", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2673", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2674",
		"Sol/Earth/STARLINK-2688", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2691", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2695", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2701", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2704", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2705", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2707", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2708", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2709", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2711", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2712", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2713", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2714", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2715", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2717", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2719", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2720", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2725", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2726", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2727", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2731", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2732", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2733", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2734", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2735", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2736", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2737", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2738", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2739", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2740", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2741", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2742", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2743", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2745", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2746", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2748", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2750", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2751", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2752", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2753", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2754", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2756", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2757", -- Starlink V1.0 L26
		"Sol/Earth/STARLINK-2758", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-2763", -- Starlink V1.0 L28
		"Sol/Earth/STARLINK-3003", -- Starlink V1.0 TR2-1
		"Sol/Earth/STARLINK-3004", -- Starlink V1.0 TR2-2
		"Sol/Earth/STARLINK-3005", -- Starlink V1.0 TR2-3
		"Sol/Earth/STARLINK-3042", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3043", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3045", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3046", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3047", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3048", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3050", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3051", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3052", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3053", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3054", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3055", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3056", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3057", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3058", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3059", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3060", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3068", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3069", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3071", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3072", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3073", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3074", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3077", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3078", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3080", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3081", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3082", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3083", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3084", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3085", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3086", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3087", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3088", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3089", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3090", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3091", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3093", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3095", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3096", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3100", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3101", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3102", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3103", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3104", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3106", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3107", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3109", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3116", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3118", -- Starlink V1.5 L1
		"Sol/Earth/STARLINK-3119", -- Starlink V1.5 L1
		
		-- Spaceway
		"Sol/Earth/Spaceway F1",
		"Sol/Earth/Spaceway F2",
		"Sol/Earth/Spaceway F3",
		--***************************************
		--***************************************
		--***************************************
		-- T
		-- TDRS
		"Sol/Earth/TDRS-1",
		"Sol/Earth/TDRS-3",
		"Sol/Earth/TDRS-4",
		"Sol/Earth/TDRS-5",
		"Sol/Earth/TDRS-6",
		"Sol/Earth/TDRS-7",
		"Sol/Earth/TDRS-8",
		"Sol/Earth/TDRS-9",
		"Sol/Earth/TDRS-10",
		"Sol/Earth/TDRS-11",
		"Sol/Earth/TDRS-12",
		"Sol/Earth/TDRS-13",
		
		"Sol/Earth/Telstar 1",
		"Sol/Earth/Terra",
		"Sol/Earth/TERRIERS",
		"Sol/Tesla roadster",
		"Sol/Earth/TESS",
		"Sol/Earth/Thaicom-4",
		-- Themis
		"Sol/Earth/THEMIS A",
		"Sol/Earth/THEMIS D",
		"Sol/Earth/THEMIS E",
		-- Tiangong
		"Sol/Earth/Tiangong 1",
		"Sol/Earth/Tiangong 2",
		"Sol/Earth/Tiangong Space Station",
		-- Titan
		"Sol/Earth/Titan III-E",
		"Sol/Earth/Titan IV-B",
		-- Tianzhou
		"Sol/Earth/Tianzhou",
		"Sol/Earth/Tianzhou 1",
		"Sol/Earth/Tianzhou 2",
		
		"Sol/Earth/Tianhe",
		"Sol/TIANWEN-1",
		
		"Sol/Earth/TOMS-EP",
		"Sol/Earth/TOPEX-Poseidon",
		"Sol/Earth/TRAAC",
		"Sol/Earth/TRMM",
				-- Toutatis
				"Sol/Toutatis-2",
				"Sol/Toutatis-3(IC)",
				"Sol/Jupiter/Toutatis-3(JS)",
				"Sol/Jupiter/Ganymede/Toutatis-3(GS)",
				"Sol/Toutatis-4(IC)",
				"Sol/Saturn/Toutatis-4(S1)",
				"Sol/Saturn/Toutatis-4(S2)",
				"Sol/Saturn/Titan/Toutatis-4(TS)",
				"Sol/Toutatis-5(IC)",
				"Sol/Uranus/Toutatis-5(U1)",
				"Sol/Uranus/Toutatis-5(U2)",
				"Sol/Uranus/Oberon/Toutatis-5(OBS)",
				"Sol/Toutatis-6(IC)",
				"Sol/Neptune/Toutatis-6(N1)",
				"Sol/Toutatis-7(IC)",
				"Sol/Eris/Toutatis-7(E1)",
				"Sol/Toutatis-8(IC)",
				"Sol/Mars/Toutatis-8(MS)",
		-- Turksat
		"Sol/Earth/TURKSAT 1B",
		"Sol/Earth/TURKSAT 1C",
		"Sol/Earth/TURKSAT 2A",
		"Sol/Earth/TURKSAT 3A",
		"Sol/Earth/TURKSAT 4A",
		"Sol/Earth/TURKSAT 4B",
		"Sol/Earth/TURKSAT 5A",
		--***************************************
		--***************************************
		--***************************************
		-- U
		"Sol/Ulysses IUS",
		"Sol/Ulysses (probe)",
		--***************************************
		--***************************************
		--***************************************
		-- V
		-- V1 - V2
		"Sol/Earth/ V2london",
		"Sol/Earth/ V2peenemunde",
		"Sol/Earth/ V2peenemunde/V2 to Peenemunde",
		"Sol/Earth/ V2london/V2 on London",
		
		"Sol/Earth/Vanguard 1",
		-- Vega
		"Sol/Vega 1a",
		"Sol/Vega 1b",
		-- Vega
		"Sol/Venus/Vega 1",
		"Sol/Venus/Vega 2",
		-- Venera
		"Sol/Earth/Venera 2",
		"Sol/Venera 3",
		"Sol/Venera 4",
		"Sol/Venera 5",
		"Sol/Venera 6",
		"Sol/Venera 7",
		"Sol/Venera 8",
		"Sol/Venera 9",
		"Sol/Venera 10",
		"Sol/Venera 11",
		"Sol/Venera 13",
		"Sol/Venera 14",
		"Sol/Venera 16",
		-- Venus Express
		--Sol/Venus/Venus Express (Engine Burn)
		"Sol/Earth/Venus Express (earth)",
			"Sol/Earth/Venus Express (earth)/Aspera-Main Unit",
			"Sol/Earth/Venus Express (earth)/Aspera",
			"Sol/Earth/Venus Express (earth)/High Gain Antenna",
			"Sol/Earth/Venus Express (earth)/Magnetometer",
			"Sol/Earth/Venus Express (earth)/PFS",
			"Sol/Earth/Venus Express (earth)/Spica V_Soir",
			"Sol/Earth/Venus Express (earth)/VeRa",
			"Sol/Earth/Venus Express (earth)/Virtis",
			"Sol/Earth/Venus Express (earth)/VMC",
		"Sol/Venus Express (sun)",
			"Sol/Venus Express (sun)/Aspera-Main Unit",
			"Sol/Venus Express (sun)/Aspera",
			"Sol/Venus Express (sun)/High Gain Antenna",
			"Sol/Venus Express (sun)/Magnetometer",
			"Sol/Venus Express (sun)/PFS",
			"Sol/Venus Express (sun)/Spica V_Soir",
			"Sol/Venus Express (sun)/VeRa",
			"Sol/Venus Express (sun)/Virtis",
			"Sol/Venus Express (sun)/VMC",
		-- Viking
		"Sol/Mars/Viking-1",
			"Sol/Mars/Viking1 lander",
		"Sol/Mars/Viking-2",
			"Sol/Mars/Viking2 lander",
		
		"Sol/Earth/Vostok 1",
		-- Voyager
		"Sol/Voyager 1",
		"Sol/Voyager 2",
		--***************************************
		--***************************************
		--***************************************
		-- W
		"Sol/Earth/WIND",
		"Sol/Earth/Wmap",
		--***************************************
		--***************************************
		--***************************************
		-- X
		"Sol/Earth/X-15",
		"Sol/Earth/XMM-Newton",
		--***************************************
		--***************************************
		--***************************************
		-- Y
		-- Yutu
		"Sol/Earth/Moon/Yutu",
		"Sol/Earth/Moon/Yutu 2",
		
		"Sol/Earth/Yohkoh",
		--***************************************
		--***************************************
		--***************************************
		-- Z
		-- Zond
		"Sol/Zond 2",
		"Sol/Zond 3",
		--***************************************
		--***************************************
		--***************************************
	}
}